// *F* Developed 2011-2014 rejecht <rejecht at outlook dot com>

class Award_WeaponKill extends Award
	abstract
	HideDropdown
	;

const AwardCount = 23;

var private const localized string CaptionString[AwardCount];

var private const Sound BukkakeSound;
var private const byte BukkakeSoundVolume;

// #Queries

static function string GetCaptionString (int AwardIndex)
{
	return Default.CaptionString[AwardIndex];
}

static function Color GetCaptionColor (int AwardIndex)
{
	if
	(
		(AwardIndex == 2)
		||
		(AwardIndex == 3)
		||
		(AwardIndex == 12)
		||
		(AwardIndex == 22)
	)
	{
		return Default.WhiteCaptionColor;
	}
	else
	{
		return Default.PurpleCaptionColor;
	}
}

// #Dispatch

static function ClientReceive
(
	PlayerController PC,
	optional int AwardIndex,
	optional int Points,
	optional int Multiplier,
	optional int PlayerID
)
{
	Super.ClientReceive (PC, AwardIndex, Points, Multiplier, PlayerID);


	switch (AwardIndex)
	{
		case 0:
		case 18:
			UnrealPlayer(PC).ClientDelayedAnnouncementNamed ('FlackMonkey', 15);
			break;

		case 1:
		case 20:
			UnrealPlayer(PC).ClientDelayedAnnouncementNamed ('ComboWhore', 15);
			break;

		case 4:
		case 19:
			UnrealPlayer(PC).ClientDelayedAnnouncementNamed ('HeadHunter', 15);
			break;

		case 6:
			PC.ClientPlaySound (default.BukkakeSound, True, Default.BukkakeSoundVolume);
			break;

		default:
			break;
	}
}

// #

protected static function HandleLocalMessage
(
	PlayerController PC,
	PlayerReplicationInfo RelatedPRI_1_Subject,
	int AwardIndex
)
{
	switch (AwardIndex)
	{
		case 2:
		case 3:
			PC.ReceiveLocalizedMessage (Class'XGame.SpecialKillMessage', 0, RelatedPRI_1_Subject);
			return;

		case 4: // Headhunter
		case 19:
		case 21: // Sweating Bullets
			PC.ReceiveLocalizedMessage (Class'LocalMessage_AwardLocal', AwardIndex, None, None, Default.Class);
			return;

		default:
			Super.HandleLocalMessage (PC, RelatedPRI_1_Subject, AwardIndex);
	}
}

// #

DefaultProperties
{
	// ReTDM

	CaptionString(0) = "Flak Monkey"
	CaptionString(1) = "Combo Whore"
	CaptionString(2) = "Head Shot"
	CaptionString(3) = "Head Shot"
	CaptionString(4) = "Headhunter"
	CaptionString(5) = "Chunky"

	CaptionString(6) = "Bukkake"
	BukkakeSound = Sound'Re.Sounds.Bukkake'
	BukkakeSoundVolume = 18

	CaptionString(7) = "Hardball"
	CaptionString(8) = "Rocket Man"
	CaptionString(9) = "Plasmatic"
	CaptionString(10) = "Disruptor"
	CaptionString(11) = "Lux Aeterna"
	CaptionString(12) = "Seek and Destroy"
	CaptionString(13) = "Electric Six"
	CaptionString(14) = "Small Moves"
	CaptionString(15) = "Kemphler Fi"
	CaptionString(16) = "Purple Haze"
	CaptionString(17) = "Shock Core"

	// 

	CaptionString(18) = "Flak Monkey"
	CaptionString(19) = "Headhunter"
	CaptionString(20) = "Combo Whore"
	CaptionString(21) = "Sweating Bullets"

	CaptionString(22) = "Head Shot"

	//

	CaptionColor = (R=152,G=81,B=204,A=255)
}
