// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class LocalMessage_Camper extends LocalMessage
    abstract
    ;

var private const Sound CampingPenaltySound;

var private localized const string
	IsCampingStringPrefix,
	IsCampingStringSuffix,
	CampingPenaltyString,
	FirstOffenseString,
	SecondOffenseString,
	ThirdOffenseString
	;

var private string SecondaryString;

// #Rendering

static event RenderComplexMessage
(
	Canvas Canvas,
	out float XL,
	out float YL,
	optional string MessageString,
	optional int Index,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	local float U, V, Y;

	Y = Canvas.CurY;

	Canvas.DrawText (MessageString, False);


	Canvas.Font = Canvas.MedFont;

	Canvas.StrLen (Default.SecondaryString, U, V);

	Canvas.SetPos
	(
		(Canvas.ClipX * Default.PosX) - (U * 0.5f),
		Y + YL
	);

	Canvas.DrawText (Default.SecondaryString, False);
}

// ## Queries ##

static event string GetString
(
    optional int Context,
    optional PlayerReplicationInfo RelatedPRI_1,
    optional PlayerReplicationInfo RelatedPRI_2,
    optional Object O
)
{
    local int WarningCount;

    WarningCount = Context & 7;

    if ((Context & 128) == 128) // Someone is camping and it's not you!
    {
		Default.SecondaryString = RelatedPRI_1.GetLocationName ();

        return
        (
            Default.IsCampingStringPrefix
            $ Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_1)
            $ Default.IsCampingStringSuffix
        );
    }
    else if (WarningCount == 0)
    {
		Default.SecondaryString = Default.FirstOffenseString;

        return Default.CampingPenaltyString;
    }
    else if (WarningCount == 1)
    {
		Default.SecondaryString = Default.SecondOffenseString;

        return Default.CampingPenaltyString;
    }
    else if (WarningCount == 2)
    {
		Default.SecondaryString = Default.ThirdOffenseString;

        return Default.CampingPenaltyString;
    }
    else if (WarningCount > 2)
    {
		Default.SecondaryString = "";

        return Default.CampingPenaltyString;
    }

    return "";
}

// #Dispatch

static event ClientReceive
(
    PlayerController PC,
    optional int Context,
    optional PlayerReplicationInfo RelatedPRI_1,
    optional PlayerReplicationInfo RelatedPRI_2,
    optional Object O
)
{
	if (Class'PlayerSettings'.Default.bShowCamperMessage)
	{
	    if ((Context & 128) == 0) // Local Player (Gets Warning Sound)
	    {
	        PC.ClientPlaySound (Default.CampingPenaltySound);
	    }


	    Super.ClientReceive (PC, Context, RelatedPRI_1, RelatedPRI_2, O);
    }
}

// #

DefaultProperties
{
    CampingPenaltySound = Sound'AssaultSounds.HnShipFireReadyl01'

    IsCampingStringSuffix = " IS CAMPING"
    CampingPenaltyString = "Camping Penalty"
    FirstOffenseString = "First Offense"
    SecondOffenseString = "Second Offense"
    ThirdOffenseString = "Third Offense"

    // LocalMessage

	bComplexString = True
	bFadeMessage = True
	bIsConsoleMessage = False
    bIsUnique = True

    DrawColor = (R=255,G=160,B=0,A=255)
	FontSize = -1
	Lifetime = 5
	PosY = 0.15
	StackMode = SM_None
}
