// *F* Developed 2011-2013 rejecht <rejecht at outlook dot com>

class LocalMessage_DrawRound extends LocalMessage
	abstract
	;

var(ConstantStrings) private localized const string
	CamperString,
	OvertimeString,
	DrawString,
	StalemateString;

var private string SecondaryString;
var private const Sound DrawSound;

// #Rendering

static event RenderComplexMessage
(
	Canvas Canvas,
	out float XL,
	out float YL,
	optional string Text,
	optional int IndexSymbol,
	optional PlayerReplicationInfo RelatedPRI_1_Subject,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	local float Y, U, V;

	Y = Canvas.CurY;

	if (Canvas.DrawColor.A < (Default.DrawColor.A / Default.Lifetime))
	{
		Canvas.DrawColor.A = Canvas.DrawColor.A * Default.Lifetime;
	}
	else
	{
		Canvas.DrawColor.A = Default.DrawColor.A;
	}

	Canvas.DrawText (Text, False);


	Canvas.Font = Canvas.MedFont;

	Canvas.StrLen (Default.SecondaryString, U, V);

	Canvas.SetPos
	(
		(Canvas.ClipX * Default.PosX) - (U * 0.5f),
		Y + YL
	);

	Canvas.DrawText (Default.SecondaryString, False);
}

// #Queries

static event string GetString
(
	optional int Context,
	optional PlayerReplicationInfo OptionalPRI_1,
	optional PlayerReplicationInfo OptionalPRI_2,
	optional Object O
)
{
	if (Context == 0)
	{
		Default.SecondaryString = Default.OvertimeString;
    }
    else if (Context == 1)
    {
		Default.SecondaryString = Default.CamperString;
    }
    else if (Context == 2)
    {
		Default.SecondaryString = Default.StalemateString;
    }

	return Default.DrawString;
}

// #Dispatch

static event ClientReceive
(
	PlayerController PC,
	optional int Context,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	PC.ClientPlaySound (Default.DrawSound);


	Super.ClientReceive (PC, Context, RelatedPRI_1, RelatedPRI_2, O);
}

// #

DefaultProperties
{
	CamperString = "Teams died from camping penalties!"
	OvertimeString = "Teams died from overtime penalties!"
	DrawString = "Round ended in a draw"
	StalemateString = "Round ended in a stalemate!"

	DrawSound = Sound'GameSounds.Fanfares.UT2K3Fanfare08'

	// LocalMessage

	bComplexString = True
	bFadeMessage = True
	bIsConsoleMessage = False
	bIsSpecial = True
	bIsUnique = True

	DrawColor = (R=255,G=255,B=255,A=255)
	PosX = 0.5
	PosY = 0.2975
	FontSize = 2
	DrawPivot = DP_MiddleMiddle
	Lifetime = 4
	StackMode = SM_None
}
