// *F* Developed 2014 rejecht <rejecht at outlook dot com>

class LocalMessage_Game extends GameMessage
	abstract
	;

// #Dispatch

private static final function PlayerJoinedTeam (PlayerController PC, PlayerReplicationInfo RelatedPRI_1, TeamInfo RelatedTeamInfo)
{
	PC.ReceiveLocalizedMessage (Class'LocalMessage_PlayerJoinedTeam', , RelatedPRI_1, , RelatedTeamInfo);
}

private static final function PlayerEnteredGame (PlayerController PC, PlayerReplicationInfo RelatedPRI_1)
{
	PC.ReceiveLocalizedMessage (Class'LocalMessage_PlayerEnteredGame', , RelatedPRI_1);
}

private static final function SomeoneEnteredGame (PlayerController PC)
{
	PC.ReceiveLocalizedMessage (Class'LocalMessage_SomeoneEnteredGame');
}

private static final function PlayerBecameSpectator (PlayerController PC, PlayerReplicationInfo RelatedPRI_1)
{
	PC.ReceiveLocalizedMessage (Class'LocalMessage_PlayerBecameSpectator', , RelatedPRI_1);
}

private static final function PlayerLeftGame (PlayerController PC, PlayerReplicationInfo RelatedPRI_1)
{
	PC.ReceiveLocalizedMessage (Class'LocalMessage_PlayerLeftGame', , RelatedPRI_1);
}

private static final function SpectatorEntered (PlayerController PC, PlayerReplicationInfo RelatedPRI_1)
{
	PC.ReceiveLocalizedMessage (Class'LocalMessage_SpectatorEntered', , RelatedPRI_1);
}

private static final function PlayerReady (PlayerController PC, PlayerReplicationInfo RelatedPRI_1)
{
	PC.ReceiveLocalizedMessage (Class'LocalMessage_PlayerReady', , RelatedPRI_1);
}

// - Intercept and create a centered message.

static event ClientReceive
(
	PlayerController PC,
	optional int Context,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	local TeamInfo RelatedTeamInfo;

	switch (Context)
	{
        case 1: // Entered

			if (PC != None) // NewPlayerMessage
			{
	        	if (RelatedPRI_1 != None)
	        	{
					PlayerEnteredGame (PC, RelatedPRI_1);
	            }
	            else
	            {
					SomeoneEnteredGame (PC);
                }
            }

            break;

		case 3: // Changed Teams

			if
			(
				(True)
				&&
				(PC != None)
			)
			{
				RelatedTeamInfo = TeamInfo(O);

	            if
	            (
		            (RelatedPRI_1 != None)
		            &&
		            (RelatedTeamInfo != None)
				)
	            {
					PlayerJoinedTeam (PC, RelatedPRI_1, RelatedTeamInfo);
	            }
	            else
	            {
					return; // Superclass comes to the same conclusion.
                }
            }

            break;

        case 4: // Left

        	if
        	(
				(RelatedPRI_1 != None)
				&&
				(PC != None)
			)
			{
				PlayerLeftGame (PC, RelatedPRI_1);
            }

            break;

		case 14: // Became Spectator

        	if
        	(
				(RelatedPRI_1 != None)
				&&
				(PC != None)
			)
			{
				PlayerBecameSpectator (PC, RelatedPRI_1);
            }

			break;

		case 16:

        	if
        	(
				(RelatedPRI_1 != None)
				&&
				(PC != None)
			)
			{
				SpectatorEntered (PC, RelatedPRI_1);
            }

            break;

		case 17:

        	if
        	(
				(RelatedPRI_1 != None)
				&&
				(PC != None)
			)
			{
				PlayerReady (PC, RelatedPRI_1);
            }

            break;
	}

	Super.ClientReceive (PC, Context, RelatedPRI_1, RelatedPRI_2, O);
}

// #

DefaultProperties
{
}
