// *F* Developed 2013-2014 rejecht <rejecht at outlook dot com>

class LocalMessage_PlayerStatus extends LocalMessage
	abstract
	;

var private localized const string
	StatusStringPrefix[4],
	StatusStringSuffix[4]
	;

// #Queries

static event Color GetColor
(
	optional int IndexSymbol,
	optional PlayerReplicationInfo RelatedPRI_1_Subject,
	optional PlayerReplicationInfo RelatedPRI_2
)
{
	local PlayerController PC;

	if
	(
		(RelatedPRI_1_Subject != None)
		&&
		(RelatedPRI_1_Subject.Team != None)
	)
	{
		PC = RelatedPRI_1_Subject.Level.GetLocalPlayerController ();
    }

	if (PC != None)
	{
		return Class'PlayerSettings'.Static.GetRelativeTeamColor (PC.GetTeamNum (), RelatedPRI_1_Subject.Team.TeamIndex);
    }
    else
    {
		return Default.DrawColor;
    }
}

static event string GetString
(
	optional int IndexSymbol,
	optional PlayerReplicationInfo RelatedPRI_1_Subject,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	return
	(
		Default.StatusStringPrefix[IndexSymbol]
		$ Class'ReUtility'.Static.GetPlayerNameString (RelatedPRI_1_Subject)
		$ Default.StatusStringSuffix[IndexSymbol]
	);
}

// #

DefaultProperties
{
	StatusStringSuffix(0) = " DIED"
	StatusStringSuffix(1) = " IS OUT"
	StatusStringSuffix(2) = " FROZE"
	StatusStringSuffix(3) = " THAWED"

	// LocalMessage

	bComplexString = False
	bFadeMessage = True
	bIsConsoleMessage = False
	bIsUnique = True
	bIsPartiallyUnique = True

	DrawColor = (R=255,G=255,B=255,A=255)
    DrawPivot = DP_MiddleMiddle
	FontSize = 1
	Lifetime = 3
	PosY = 0.87
	StackMode = SM_Down
}
