// *I* Developed 2014 rejecht <rejecht at outlook dot com>

class LocalMessage_TimeWarning extends CriticalEventPlus
	abstract
	HideDropdown
	;

var private localized const string
	FiveMinuteWarningString,
	ThreeMinuteWarningString,
	TwoMinuteWarningString,
	OneMinuteWarningString,
	ThirtySecondWarningString,
	TwentySecondWarningString;

// #Queries

static event Color GetColor
(
	optional int Seconds,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2
)
{
	return Default.DrawColor;
}

// #

static event string GetString
(
	optional int Seconds,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	switch (Seconds)
	{
		case 300:
			return Default.FiveMinuteWarningString;

		case 180:
			return Default.ThreeMinuteWarningString;

		case 120:
			return Default.TwoMinuteWarningString;

		case 60:
			return Default.OneMinuteWarningString;

		case 30:
			return Default.ThirtySecondWarningString;

		case 20:
			return Default.TwentySecondWarningString;

		case 10:
		case 9:
		case 8:
		case 7:
		case 6:
		case 5:
		case 4:
		case 3:
		case 2:
		case 1:
			return
			(
				"..."
				$ Seconds
				$ "..."
			);
    }

    return "";
}

// #Dispatch

static event ClientReceive
(
	PlayerController PC,
	optional int Seconds,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O
)
{
	if (Class'PlayerSettings'.Default.bShowTimeWarnings)
	{
		Super.ClientReceive (PC, Seconds, RelatedPRI_1, RelatedPRI_2, O);
    }
}

// #

DefaultProperties
{
	FiveMinuteWarningString = "Five Minute Warning"
	ThreeMinuteWarningString = "Three Minutes Left"
	TwoMinuteWarningString = "Two Minutes Remain"
	OneMinuteWarningString = "One Minute Remains"
	ThirtySecondWarningString = "Thirty Seconds Left"
	TwentySecondWarningString = "Twenty Seconds"

	// LocalMessage

	DrawColor = (R=255,G=255,B=0,A=255)
	FontSize = 2
	Lifetime = 3
	PosY = 0.1
	StackMode = SM_Down
}
