// *F* Developed 2013-2014 rejecht <rejecht at outlook dot com>

class RandomAdrenalinePickup extends AdrenalinePickup
    HideDropdown
    NotPlaceable
    ;

// #Precaching

static event StaticPrecache (LevelInfo LI)
{
    LI.AddPrecacheStaticMesh (StaticMesh'XEffects.EffectsSphere144');
	LI.AddPrecacheMaterial (Texture'Textures.Pickup');
}

simulated event UpdatePrecacheMaterials ()
{
	Level.AddPrecacheMaterial (Texture'Textures.Pickup');

	Super.UpdatePrecacheMaterials ();
}

simulated event UpdatePrecacheStaticMeshes ()
{
	Level.AddPrecacheMaterial (Texture'Textures.Pickup');

	Super.UpdatePrecacheStaticMeshes ();
}

// #Reset

event Reset ()
{
	if (Inventory != None)
	{
		Destroy();
    }
	else
	{
		Super(Actor).Reset ();
	}
}

// #Bots

event float BotDesireability (Pawn P)
{
	if
	(
		ReGRI(Level.GRI).bRoundbased
		&&
		ReGRI(Level.GRI).IsSpawning ()
	)
	{
		return 0.0f;
    }
    else
    {
		return Super.BotDesireability (P);
    }
}

// #

DefaultProperties
{
    // AdrenalinePickup

    AdrenalineAmount = 10.0

    // Pickup

    MaxDesireability = 1.0
    RespawnTime = 33.0

    // Actor

    bAcceptsProjectors = False
	bGameRelevant = True // Mutators never get a say.
    bUnlit = True
    bUseDynamicLights = False

    CullDistance = 6500.0
    DrawScale = 0.4
    RotationRate = (Yaw=35000)
    Skins[0] = Texture'Textures.Pickup'
    StaticMesh = XEffects.EffectsSphere144
    TransientSoundVolume = 0.35
}
