// *F* Developed 2013-2014 rejecht <rejecht at outlook dot com>

class RandomLowHealthPickup extends TournamentHealth
	NotPlaceable
	HideDropdown
	;

// #Precaching

static event StaticPrecache (LevelInfo LI)
{
    LI.AddPrecacheStaticMesh (StaticMesh'XEffects.EffectsSphere144');
	LI.AddPrecacheMaterial (Texture'Textures.Pickup');
}

simulated event UpdatePrecacheMaterials ()
{
	Level.AddPrecacheMaterial (Texture'Textures.Pickup');

	Super.UpdatePrecacheMaterials ();
}

simulated event UpdatePrecacheStaticMeshes ()
{
	Level.AddPrecacheMaterial (Texture'Textures.Pickup');

	Super.UpdatePrecacheStaticMeshes ();
}

// #Reset

event Reset ()
{
	if (Inventory != None)
	{
		Destroy();
    }
	else
	{
		Super(Actor).Reset ();
	}
}

// #Bots

event float BotDesireability (Pawn P)
{
	if
	(
		ReGRI(Level.GRI).bRoundbased
		&&
		ReGRI(Level.GRI).IsSpawning ()
	)
	{
		return 0.0f;
	}
	else
	{
		return Super.BotDesireability (P);
	}
}

// #

DefaultProperties
{
	// TournamentHealth

	bSuperHeal = True

	HealingAmount = 10

	// Pickup

	MaxDesireability = 1.0
	PickupSound = Sound'PickupSounds.HealthPack'
	PickupForce = "HealthPack"
	RespawnTime = 33.0

	// Actor

	bAcceptsProjectors = False
	bGameRelevant = True // Mutators never get a say.
	bUnlit = True
	bUseDynamicLights = False

	CullDistance = 6500.0
	DrawScale = 0.5
	DrawType = DT_StaticMesh
	Physics = PHYS_Rotating
	RotationRate = (Yaw=35000)
	ScaleGlow = 0.6
	Skins[0] = Texture'Textures.Pickup'
	StaticMesh = XEffects.EffectsSphere144
	Style = STY_AlphaZ
	TransientSoundVolume = 0.35
}
