// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class ReTAM_Scoreboard extends ReTDM_Scoreboard
	HideDropDown
	;

// #Slot

protected function UpdatePlayerSlotData (PlayerReplicationInfo OtherPRI)
{
	local float RoundsPlayed;

	// Right-Most Column

	if (Level.NetMode == NM_Client)
	{
		if (!OtherPRI.bBot)
		{
			TopDataColor[0] = TopLegendColor[0];

			if (!bMatchOver)
			{
				TopDataString[0] = string(Min (OtherPRI.Ping * 4, 999));
			}
			else
			{
				TopDataString[0] = "---";
            }


			if (OtherPRI.PacketLoss > 0)
			{
				BottomDataColor[0] = ExperiencingPacketlossColor;
			}
			else if (RePRI(OtherPRI).bHadPacketLoss)
			{
				BottomDataColor[0] = HadPacketlossColor;
			}
			else
			{
				BottomDataColor[0] = ConnectionColor;
			}

			BottomDataString[0] = string(OtherPRI.PacketLoss);
		}
		else
		{
			TopDataColor[0] = TopLegendColor[0];
			TopDataString[0] = BotConnectionString;

			BottomDataColor[0] = BottomLegendColor[0];
			BottomDataString[0] = BotConnectionString;
		}

		// Kills / Deaths

		TopDataColor[1] = TopLegendColor[1];
		TopDataString[1] = string(RePRI(OtherPRI).ReplicatedKills);

		BottomDataColor[1] = BottomLegendColor[1];
		BottomDataString[1] = string(int(OtherPRI.Deaths));

		// Score / PPR

		TopDataColor[2] = TopLegendColor[2];
		TopDataString[2] = string(int(OtherPRI.Score));

		BottomDataColor[2] = BottomLegendColor[2];

		RoundsPlayed = ReGRI(GRI).IndexRound_Current - RePRI(OtherPRI).IndexRound_Joined;

		if (RoundsPlayed > 0.0f)
		{
			BottomDataString[2] = string(OtherPRI.Score / RoundsPlayed);
		}
		else
		{
			BottomDataString[2] = "---";
	    }
    }
    else
    {
		// Kills / Deaths

		TopDataColor[1] = TopLegendColor[1];
		TopDataString[1] = string(RePRI(OtherPRI).ReplicatedKills);

		BottomDataColor[1] = BottomLegendColor[1];
		BottomDataString[1] = string(int(OtherPRI.Deaths));

		// Score / PPR

		TopDataColor[2] = TopLegendColor[2];
		TopDataString[2] = string(int(OtherPRI.Score));

		BottomDataColor[2] = BottomLegendColor[2];

		RoundsPlayed = ReGRI(GRI).IndexRound_Current - RePRI(OtherPRI).IndexRound_Joined;

		if (RoundsPlayed > 0.0f)
		{
			BottomDataString[2] = string(OtherPRI.Score / RoundsPlayed);
		}
		else
		{
			BottomDataString[2] = "---";
	    }
	}
}

// #

event string GetDefaultScoreInfoString ()
{
	local ReGRI ReGRI;

	ReGRI = ReGRI(GRI);

	if
	(
		(ReGRI != None)
		&&
		(GameClass != None)
	)
	{
		return
		(
			GameClass.Static.GetDisplayText ("RoundScoreLimit")
			$ ":"
			@ ReGRI.RoundScoreLimit
			@ Spacer
			@ GameClass.Static.GetDisplayText ("RoundTimeLimit")
			$ ":"
			@ ReGRI.RoundTimeLimit
			@ Spacer
			@ FooterText
			@ FormatTime (GRI.ElapsedTime)
		);
    }
    else
	{
		return Super.GetDefaultScoreInfoString ();
    }
}

// #

DefaultProperties
{
	BottomLegendString(2) = "PPR"

	// Scoreboard

	HUDClass = Class'ReTAM_HUD'
}
