// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class ReTDM_Statistics extends ReStatistics
	HideDropDown
	;

protected function UpdatePlayerScores ()
{
	// Score

	if (SpectatedPRI.Score > 0)
	{
		ScoreDataString[0] = string(Clamp (int(SpectatedPRI.Score), 1, 99999));
	}
	else
	{
		ScoreDataString[0] = ScoreLongestString[0];
	}

	// KILLS

	if (SpectatedPRI.Metrics.Kills > 0)
	{
		ScoreDataString[1] = string(Clamp (SpectatedPRI.Metrics.Kills, 1, 999));
	}
	else
	{
		ScoreDataString[1] = ScoreLongestString[1];
	}

	// DEATHS

	if (SpectatedPRI.Metrics.Deaths > 0)
	{
		ScoreDataString[2] = string(Clamp (SpectatedPRI.Metrics.Deaths, 1, 999));
	}
	else
	{
		ScoreDataString[2] = ScoreLongestString[2];
	}

	// SELFK

	if (SpectatedPRI.Metrics.Suicides > 0)
	{
		ScoreDataString[3] = string(Clamp (SpectatedPRI.Metrics.Suicides, 1, 999));
	}
	else
	{
		ScoreDataString[3] = ScoreLongestString[3];
	}

	// TKs

	if (SpectatedPRI.Metrics.Teamkills > 0)
	{
		ScoreDataString[4] = string(Clamp (SpectatedPRI.Metrics.Teamkills, 1, 999));
	}
	else
	{
		ScoreDataString[4] = ScoreLongestString[4];
	}

	// TKd

	if (SpectatedPRI.Metrics.TeamDeaths > 0)
	{
		ScoreDataString[5] = string(Clamp (SpectatedPRI.Metrics.TeamDeaths, 1, 999));
	}
	else
	{
		ScoreDataString[5] = ScoreLongestString[5];
	}

	// RFF

	if (SpectatedPRI.ScaledReverseFriendlyFire > 0.0f)
	{
		ScoreDataString[6] = string(Clamp (int(SpectatedPRI.ScaledReverseFriendlyFire * 100.0f), 1, 100))$"%";
	}
	else
	{
		ScoreDataString[6] = ScoreLongestString[6];
	}

	// DmgD

	if (SpectatedPRI.Metrics.TotalWeaponDamageDone_Enemies > 0)
	{
		ScoreDataString[7] = string(Clamp (SpectatedPRI.Metrics.TotalWeaponDamageDone_Enemies, 1, 99999));
	}
	else
	{
		ScoreDataString[7] = ScoreLongestString[7];
	}

	// DmgR

	if (SpectatedPRI.Metrics.TotalWeaponDamageTaken_Enemies > 0)
	{
		ScoreDataString[8] = string(Clamp (SpectatedPRI.Metrics.TotalWeaponDamageTaken_Enemies, 1, 99999));
	}
	else
	{
		ScoreDataString[8] = ScoreLongestString[8];
	}

	// HS

	if (SpectatedPRI.Metrics.TotalHeadShotHits > 0)
	{
		ScoreDataString[9] = string(Clamp (SpectatedPRI.Metrics.TotalHeadShotHits, 1, 999));
	}
	else
	{
		ScoreDataString[9] = ScoreLongestString[9];
	}

	// Played

	ScoreDataString[10] = SpectatedPRI.Metrics.Played $ "%";
}


protected function Weapons_UpdateSpectatedWeaponValues (out AwardPRI.SWeaponRecord Out_ReadOnly_WeaponRecord)
{
	// Weapon

	Weapons_Text_Value[0] = Out_ReadOnly_WeaponRecord.Class_Weapon.Default.ItemName;

	// KILLS

	if (Out_ReadOnly_WeaponRecord.Kills > 0)
	{
		Weapons_Text_Value[1] = string(Min (Out_ReadOnly_WeaponRecord.Kills, 999));
	}
	else
	{
		Weapons_Text_Value[1] = Weapons_Text_Highest[1];
	}

	// DEATHS

	if (Out_ReadOnly_WeaponRecord.Deaths > 0)
	{
		Weapons_Text_Value[2] = string(Min (Out_ReadOnly_WeaponRecord.Deaths, 999));
	}
	else
	{
		Weapons_Text_Value[2] = Weapons_Text_Highest[2];
	}

	// SELFK

	if (Out_ReadOnly_WeaponRecord.Suicides > 0)
	{
		Weapons_Text_Value[3] = string(Min (Out_ReadOnly_WeaponRecord.Suicides, 999));
	}
	else
	{
		Weapons_Text_Value[3] = Weapons_Text_Highest[3];
	}

	// DmgD

	if (Out_ReadOnly_WeaponRecord.DamageDone > 0)
	{
		Weapons_Text_Value[4] = string(Min (Out_ReadOnly_WeaponRecord.DamageDone, 99999));
	}
	else
	{
		Weapons_Text_Value[4] = Weapons_Text_Highest[4];
	}
}


protected function Weapons_UpdateSpectatedWeaponDamageTypeValues (out AwardPRI.SWeaponDamageRecord Out_ReadOnly_WeaponDamageRecord)
{
	// Weapon

	Weapons_Text_Value[0] = Out_ReadOnly_WeaponDamageRecord.Title;

	// KILLS

	if (Out_ReadOnly_WeaponDamageRecord.Kills > 0)
	{
		Weapons_Text_Value[1] = string(Min (Out_ReadOnly_WeaponDamageRecord.Kills, 999));
	}
	else
	{
		Weapons_Text_Value[1] = Weapons_Text_Highest[1];
	}

	// DEATHS

	if (Out_ReadOnly_WeaponDamageRecord.Deaths > 0)
	{
		Weapons_Text_Value[2] = string(Min (Out_ReadOnly_WeaponDamageRecord.Deaths, 999));
	}
	else
	{
		Weapons_Text_Value[2] = Weapons_Text_Highest[2];
	}

	// SELFK

	if (Out_ReadOnly_WeaponDamageRecord.Suicides > 0)
	{
		Weapons_Text_Value[3] = string(Min (Out_ReadOnly_WeaponDamageRecord.Suicides, 999));
	}
	else
	{
		Weapons_Text_Value[3] = Weapons_Text_Highest[3];
	}

	// DmgD

	if (Out_ReadOnly_WeaponDamageRecord.DamageDone > 0)
	{
		Weapons_Text_Value[4] = string(Min (Out_ReadOnly_WeaponDamageRecord.DamageDone, 99999));
	}
	else
	{
		Weapons_Text_Value[4] = Weapons_Text_Highest[4];
	}
}

// #

DefaultProperties
{
	Metrics_Count_Used = 11
	ScoreLegendString(0) = "Score"
	ScoreLongestString(0) = "-----"
	ScoreLegendString(1) = "Kills"
	ScoreLongestString(1) = "---"
	ScoreLegendString(2) = "Deaths"
	ScoreLongestString(2) = "---"
	ScoreLegendString(3) = "SelfK"
	ScoreLongestString(3) = "---"
	ScoreLegendString(4) = "TKs"
	ScoreLongestString(4) = "---"
	ScoreLegendString(5) = "TKd"
	ScoreLongestString(5) = "---"
	ScoreLegendString(6) = "RFF"
	ScoreLongestString(6) = "-----"
	ScoreLegendString(7) = "DmgD"
	ScoreLongestString(7) = "-----"
	ScoreLegendString(8) = "DmgR"
	ScoreLongestString(8) = "-----"
 	ScoreLegendString(9) = "HSHits"
	ScoreLongestString(9) = "---"
	ScoreLegendString(10) = "Played"
	ScoreLongestString(10) = "-----"

	Weapons_Count_Used = 5
	WeaponLegendString(0) = "Weapon"
	Weapons_Text_Highest(0) = "********************"
	WeaponLegendString(1) = "Kills"
	Weapons_Text_Highest(1) = "---"
	WeaponLegendString(2) = "Deaths"
	Weapons_Text_Highest(2) = "---"
	WeaponLegendString(3) = "SelfK"
	Weapons_Text_Highest(3) = "---"
	WeaponLegendString(4) = "DmgD"
	Weapons_Text_Highest(4) = "-----"
}
