// *F* Developed 2011-2014 rejecht <rejecht at outlook dot com>

// class ReTeamGameHUD extends HUDCTeamDeathmatch
class ReTeamGameHUD extends HudWTeamDeathMatch
	abstract
	config (User)
	HideDropdown
	;

const IndexTeam_Max = 2;
const IndexTeam_A = 0;
const IndexTeam_B = 1;
const IndexTeam_Unspecified = 255;

const RatioUnrealUnitMeter = 0.01875f;

var(Tick) protected ReGRI ReGRI;
var protected bool bReGRIReceived;

var(Tick) protected bool
	bMatchOver,
	bMatchLive,
	bMatchHasBegun;

var(Development) GlobalConfig bool bLogLocalizedMessage;

// - IntBox is used everywhere in place of this structure, though.
// - This is about semantics.

var const Vector NullVector;

var(Tick) protected PlayerReplicationInfo PlayerOwnerPRI;

var(Tick) protected Color
	TeammateColor,
	EnemyColor;

var(Colors) GlobalConfig Color OvertimeColor; // DrawTimer

var(Tick) protected int
	LocalTeamIndex, // {0, 1, IndexTeam_Unspecified}
	TeammateTeamIndex, // {0, IndexTeam_Max - 1} -- Spectators: IndexTeam_A
	EnemyTeamIndex; // {0, IndexTeam_Max - 1} -- Spectators: IndexTeam_B

var(Messages) protected const class<LocalMessage>
	AnnouncementLocalMessageClass,
	TimeWarningLocalMessageClass,
	SayLocalMessageClass,
	TeamSayLocalMessageClass,
	CriticalLocalMessageClass,
	DeathMessageLocalMessageClass,
	MessageLocalMessageClass,
	EnemyPlayerNameLocalMessageClass,
	CombatTypingLocalMessageClass;

// The global sin function is used by the event beacons.

var(Tick) protected float SinTimeSeconds;
var(Tick) protected float SinY;

// #

var(Tick) protected array<RePRI> GroupPlayer;
var(Tick) protected array<RePRI> GroupSpectator;

// #

const Length_MaxClientMessage = 128;
var protected const string DrawTypingPrompt_Text_Prefix;
var protected const float DrawTypingPrompt_ScaledWidth_TextArea;
var protected int TextMessages_IndexNext;
var(Glocals) protected float DisplayMessages_L_ScaledTimeSeconds;

// #CombatTyping

var protected const int CombatTyping_TimeInterval_LastWarning;
var(Tick) protected float CombatTyping_TimeSeconds_LastWarning;

// #Symbols

var protected const IntBox
	OffsetTexture_Playing,
	OffsetTexture_Out,
	OffsetTexture_Spawning;

// #RespawnStatus

var protected SpriteWidget RespawnStatus_SpriteWidget_SymbolProgress;
var protected NumericWidget RespawnStatus_NumericWidget_Value;
var protected int RespawnStatus_Count_LivesRemaining;

// #bShowTeamCombos

var protected NumericWidget TeamComboAdrenalineNumericWidget;
var protected SpriteWidget TeamComboBackgroundSpriteWidget;
var protected SpriteWidget TeamComboTypeSpriteWidget[10];

// #

var(Colors) GlobalConfig Color
	ConnectionStringColor,
	ConnectionHasPacketlossStringColor,
	ConnectionHadPacketlossStringColor,
	ChatPortrait_ColorTexture_Frame,
	ChatPortrait_ColorTexture_Portrait,
	ChatPortrait_ColorTexture_Effect;

// #

var(Glocals) protected string NetworkMetrics_Draw_L_CachedString;

var protected const float
	NetworkMetrics_ScaledPosition_X_Ping,
	NetworkMetrics_ScaledPosition_X_PacketLoss,
	NetworkMetrics_ScaledPosition_Y;

var(Glocals) protected float
	NetworkMetrics_Draw_L_X,
	NetworkMetrics_Draw_L_Y,
	NetworkMetrics_Draw_L_Width_Text,
	NetworkMetrics_Draw_L_Height_Text;

// #

var(Glocals) protected Vector
	DrawEnemyName_L_HitLocation,
	DrawEnemyName_L_HitNormal,
	DrawEnemyName_L_ViewPos;

var protected const Texture DrawEnemyName_Texture_ForbiddenSymbol;
var protected const IntBox DrawEnemyName_OffsetTexture;

// #ChatPortrait

var protected const Material ChatPortrait_Material_Noise;

var(Once) protected float
	ChatPortrait_USize_Material_Noise,
	ChatPortrait_VSize_Material_Noise;

var protected const byte ChatPortrait_ColorAlphaTexture_Health;

var protected const float
	ChatPortrait_TimeSeconds_Duration,
	ChatPortrait_Tick_Speed;

var(Glocals) protected float
	ChatPortrait_Draw_L_SizeUV_Portrait,
	ChatPortrait_Draw_L_SizeUVSource_Portrait;

var(Glocals) protected string ChatPortrait_Draw_L_Text_PlayerName;
var(Tick) protected Color ChatPortrait_ColorText_PlayerName;

// #TypingPrompt

var(ConstantTextures) protected const Texture DrawTypingPrompt_Texture_Background;
var(Colors) GlobalConfig Color DrawTypingPrompt_BackgroundTextureColor;

// #TrackingDisplayHit

const TrackingDisplayHit_TimeFadeOut = 180.0f;
const TrackingDisplayHit_DamageLocal_TimeFadeOut = 240.0f;
const TrackingDisplayHit_Count = 8;

var(ConstantTextures) protected const Texture
	TrackingDisplayHit_Texture_Crescent,
	TrackingDisplayHit_Texture_Square;

var(Colors) GlobalConfig Color
	TrackingDisplayHit_ColorTexture_Health,
	TrackingDisplayHit_ColorTexture_Shield,
	TrackingDisplayHit_ColorTexture_SuperHealth,
	TrackingDisplayHit_DamageLocal_ColorTexture_Health,
	TrackingDisplayHit_DamageLocal_ColorTexture_Shield,
	TrackingDisplayHit_DamageLocal_ColorTexture_SuperHealth;

var protected const float
	TrackingDisplayHit_DamageLocal_ScaledSize_Texture,
	TrackingDisplayHit_ScaledSize_Crescent;

var protected array<TexRotator> TrackingDisplayHit_Texture;

var(Tick) protected int TrackingDisplayHit_Index;

var protected float
	TrackingDisplayHit_USize,
	TrackingDisplayHit_VSize,
	TrackingDisplayHit_DamageLocal_TimeLast,
	TrackingDisplayHit_Yaw[TrackingDisplayHit_Count],
	TrackingDisplayHit_Time_LastDamage[TrackingDisplayHit_Count];

var(Colors) protected Color
	TrackingDisplayHit_DamageLocal_ColorLast,
	TrackingDisplayHit_ColorDamage[TrackingDisplayHit_Count];

var(Tick) protected int TrackingDisplayHit_Damage[TrackingDisplayHit_Count];

// #EventBeacons

const EventBeacons_Count_Symbols = 4;

var protected const float
	EventBeacons_TimeInterval_Lifetime,
	EventBeacons_TimeInterval_Fade;

var protected const FloatBox EventBeacons_Window_ScaledPosition;
var protected const Material EventBeacons_Material_Symbols;
var protected IntBox EventBeacons_OffsetTexture_Symbol[EventBeacons_Count_Symbols];
var(Colors) protected Color EventBeacons_Color_Symbol[EventBeacons_Count_Symbols];
var(Glocals) protected string EventBeacons_L_Text_Distance;
var(Glocals) protected Rotator EventBeacons_L_Rotation_Camera;

var(Glocals) protected Vector
	EventBeacons_L_Location_Target,
	EventBeacons_L_Location_Screen,
	EventBeacons_L_X,
	EventBeacons_L_Y,
	EventBeacons_L_Z,
	EventBeacons_L_Orientation,
	EventBeacons_L_Location_Camera;

var(Glocals) protected IntBox EventBeacons_L_Rectangle_Symbol;

var(Glocals) protected float
	EventBeacons_L_WindowX1,
	EventBeacons_L_WindowY1,
	EventBeacons_L_WindowX2,
	EventBeacons_L_WindowY2,
	EventBeacons_L_Distance,
	EventBeacons_L_DirectionY,
	EventBeacons_L_DirectionZ,
	EventBeacons_L_Edge,
	EventBeacons_L_Width_Text,
	EventBeacons_L_Height_Text,
	EventBeacons_L_SizeUV_Symbol,
	EventBeacons_L_Radius_Symbol,
	EventBeacons_L_ScaledAlpha,
	EventBeacons_L_ScaledSize_Symbol;

// #MatchPending

var(Colors) protected const Color MatchPending_ColorText_LevelTitle;

var(Cached) protected string
	MatchPending_Text_Title,
	MatchPending_Text_Game;

// #MatchHint

enum EMatchHintContext
{
	MHC_Unspecified,
	MHC_MatchInProgress_KickWarning,
	MHC_Global_Menu,
	MHC_Replication_WaitingforOtherPlayers,
	MHC_MatchOver_Lost,
	MHC_MatchOver_Won,
	MHC_MatchOver_Latecomer,
	MHC_MatchOver_Spectators,
	MHC_MatchInProgress_SpectatingOtherPlayer,
	MHC_MatchInProgress_PlayerOut,
	MHC_MatchInProgress_PlayerOutCanRespawn,
	MHC_MatchInProgress_PlayerOutSpectator,
	MHC_MatchPending_SpectatorWaitingforOtherPlayers,
	MHC_StandaloneMatchPending_PlayerIsReadyWaitingforReadySignals,
	MHC_StandaloneMatchPending_PlayerPressFire,
	MHC_MatchPending_PlayerIsReadyWaitingforReadySignals,
	MHC_MatchPending_PlayerNotReady
};

var(Colors) GlobalConfig Color
	MatchHint_Color_Text,
	MatchHint_ColorMaterial_Background,
	MatchHint_ColorTexture_Logo;

var(Size) protected const int MatchHint_IndexSize_Font;

var protected const IntBox MatchHint_OffsetTexture_Logo;

var protected const Texture
	MatchHint_Texture_Logo,
	MatchHint_Texture_Background;

var(Cached) protected float
	MatchHint_USize_Texture_Logo,
	MatchHint_VSize_Texture_Logo;

// #DamagePoints

const DamagePoints_Count_Types = 5;
const DamagePoints_Count_Tracked = 8;

var(Constants) protected const float
	DamagePoints_ScaledPosition_X,
	DamagePoints_ScaledPosition_Y,
	DamagePoints_TimeSeconds_Duration,
	DamagePoints_TimeSeconds_Fadeout,
	DamagePoints_Tick_Speed;

var(Tick) protected Color
	DamagePoints_Color_Type[DamagePoints_Count_Types],
	DamagePoints_ColorText[DamagePoints_Count_Tracked];

var(Tick) protected float
	DamagePoints_OffsetX[DamagePoints_Count_Tracked],
	DamagePoints_TimeSeconds_Completed[DamagePoints_Count_Tracked],
	DamagePoints_OffsetY[DamagePoints_Count_Tracked];

var protected string DamagePoints_Text[DamagePoints_Count_Tracked];

var protected int DamagePoints_IndexNext;

// #NetworkStatus

var(Once) protected float NetworkStatus_SizeUV_Circle;

var GlobalConfig float NetworkStatusPosX, NetworkStatusPosY;

var(Objects) protected FadeColor NetworkStatus_FadeColor_Circle;
var(Objects) protected TexRotator NetworkStatus_TexRotator_Circle;
var(Objects) protected Shader NetworkStatus_Shader_Circle;

// #LocationName

var(Positions) protected float DrawLocationName_ScaledPosition_Y;

// #SpawnProtection

var protected localized const string SpawnProtectionString;
var protected float SpawnProtectionTime;
var GlobalConfig float SpawnProtectionPosY;
var GlobalConfig Color SpawnProtectionTextColor, SpawnProtectionBackgroundColor;
var protected bool bSpawnProtection;

// #Lifetime

event PreBeginPlay ()
{
	Super.PreBeginPlay ();


	if (Level.NetMode == NM_Client)
	{
		NetworkStatus_PreBeginPlay ();
	}
}

event PostBeginPlay ()
{
	Super.PostBeginPlay ();


	TrackingDisplayHit_PostBeginPlay ();

	ChatPortrait_PostBeginPlay ();

	MatchHint_PostBeginPlay ();
}

event Destroyed ()
{
	TrackingDisplayHit_Destroyed ();


	Super.Destroyed ();
}

event Reset ()
{
	Super(Actor).Reset (); // To avoid having the scoreboard close for spectators upon level resets.
}

// #Tick #Start

event LinkActors ()
{
	local RePRI OtherRePRI;
	local TeamSummary TeamSummary;
	local int Index;

	bIsCinematic = IsInCinematic ();

	if (PlayerOwnerPRI != None) // Implies (PlayerOwner != None)
	{
		// PlayerConsole

		if (PlayerOwner.Player != None)
		{
			PlayerConsole = PlayerOwner.Player.Console;
		}
		else
		{
			PlayerConsole = None;
		}

		// PawnOwner

		if
		(
			(Pawn(PlayerOwner.ViewTarget) != None)
			&&
			(Pawn(PlayerOwner.ViewTarget).Health > 0)
		)
		{
			PawnOwner = Pawn(PlayerOwner.ViewTarget);
		}
		else if (PlayerOwner.Pawn != None)
		{
			PawnOwner = PlayerOwner.Pawn;
		}
		else
		{
			PawnOwner = None;
		}

		// PawnOwnerPRI

		if
		(
			(PawnOwner != None)
			&&
			(PawnOwner.PlayerReplicationInfo != None)
		)
		{
			PawnOwnerPRI = PawnOwner.PlayerReplicationInfo;
		}
		else
		{
			PawnOwnerPRI = PlayerOwner.PlayerReplicationInfo;
		}

		//

		ReGRI = ReGRI(PlayerOwner.GameReplicationInfo);

		if (ReGRI != None)
		{
			bMatchOver = ReGRI.IsOver ();
			bMatchLive = ReGRI.IsLive ();
			bMatchHasBegun = ReGRI.bMatchHasBegun;

			if (!bReGRIReceived)
			{
				bReGRIReceived = True;
				NotifyReGRIReceived (ReGRI);
            }
		}
		else
		{
			bMatchOver = False;
			bMatchLive = False;
		}

		// LocalTeamIndex

		if (PlayerOwnerPRI.bOnlySpectator)
		{
			LocalTeamIndex = IndexTeam_Unspecified;

			TeammateTeamIndex = IndexTeam_A;
			EnemyTeamIndex = IndexTeam_B;

			TeammateColor = Class'PlayerSettings'.Default.StandardTeamColor[TeammateTeamIndex];
			EnemyColor = Class'PlayerSettings'.Default.StandardTeamColor[EnemyTeamIndex];
		}
		else if (PlayerOwnerPRI.Team != None)
		{
			LocalTeamIndex = PlayerOwnerPRI.Team.TeamIndex;

			if (LocalTeamIndex == IndexTeam_A)
			{
				TeammateTeamIndex = IndexTeam_A;
				EnemyTeamIndex = IndexTeam_B;
			}
			else if (LocalTeamIndex == IndexTeam_B)
			{
				TeammateTeamIndex = IndexTeam_B;
				EnemyTeamIndex = IndexTeam_A;
			}

			TeammateColor = Class'PlayerSettings'.Static.GetCustomTeammateColor (TeammateTeamIndex);
			EnemyColor = Class'PlayerSettings'.Static.GetCustomEnemyColor (EnemyTeamIndex);


			TeamSummary = RePRI(PlayerOwnerPRI).TeamSummary;

			if (TeamSummary != None)
			{
				for (Index = 0; Index < 16; ++Index)
				{
					OtherRePRI = TeamSummary.RePRI[Index];

					if (OtherRePRI != None)
					{
						OtherRePRI.Position = TeamSummary.Position[Index];
						OtherRePRI.NormalizedHitPoints = TeamSummary.HitPoints[Index] / FMax (1.0f, TeamSummary.MaximumHitPoints[Index]);
						OtherRePRI.HitPoints = TeamSummary.HitPoints[Index];
						OtherRePRI.Flags = TeamSummary.Flags[Index];
					}
				}
			}
		}
		else // Assume these defaults until replication gets client updated.
		{
			LocalTeamIndex = IndexTeam_Unspecified;

			TeammateTeamIndex = IndexTeam_A;
			EnemyTeamIndex = IndexTeam_B;

			TeammateColor = Class'PlayerSettings'.Default.StandardTeamColor[IndexTeam_A];
			EnemyColor = Class'PlayerSettings'.Default.StandardTeamColor[IndexTeam_B];
		}

		// Data

		if (PlayerOwner.GameReplicationInfo != None)
		{
			UpdateReset ();


			for (Index = 0; Index < PlayerOwner.GameReplicationInfo.PRIArray.Length; ++Index)
			{
				OtherRePRI = RePRI(PlayerOwner.GameReplicationInfo.PRIArray[Index]);

				if (OtherRePRI != None)
				{
					if (OtherRePRI.bOnlySpectator)
					{
						UpdateSpectator (OtherRePRI);
					}
					else if
					(
						(OtherRePRI.Team != None)
						&&
						(OtherRePRI.RealtimePlayerInfo != None)
					)
					{
						UpdatePlayer (OtherRePRI);
					}
				}
			}
		}

		// #Resources

		if (ReGRI != None)
		{
			CalculateTeamResources ();
        }

		// #SpawnProtection

		if
		(
			Class'PlayerSettings'.Default.bShowSpawnProtection
			&&
			(RePawn(PawnOwner) != None)
			&&
			(RePawn(PawnOwner).TemporalFluxEffect != None)
			&&
			(ReGRI != None)
		)
		{
			if (!bSpawnProtection)
			{
				bSpawnProtection = True;

				SpawnProtectionTime = Level.TimeSeconds + ReGRI.SpawnProtectionTime;
	        }
		}
		else
		{
			bSpawnProtection = False;
	    }
	}
	else
	{
		PlayerConsole = None;
		PawnOwner = None;
		PawnOwnerPRI = None;
		PlayerOwner = PlayerController(Owner);
		LocalTeamIndex = IndexTeam_Unspecified;

		if (PlayerOwner != None)
		{
			PlayerOwnerPRI = PlayerOwner.PlayerReplicationInfo;

			ReGRI = ReGRI(PlayerOwner.GameReplicationInfo);

			if (ReGRI != None)
			{
				bMatchOver = ReGRI.IsOver ();
				bMatchLive = ReGRI.IsLive ();
			}
			else
			{
				bMatchOver = False;
				bMatchLive = False;
			}
		}
		else
		{
			PlayerOwnerPRI = None;
			ReGRI = None;
			bMatchOver = False;
			bMatchLive = False;
		}

		bSpawnProtection = False;

		UpdateReset ();
	}
}

// #

protected function NotifyReGRIReceived (ReGRI ReGRI)
{
}

// #

protected function CalculateTeamResources () // *I*
{
}

// #Metrics

protected function UpdateReset ()
{
	GroupPlayer.Length = 0;
	GroupSpectator.Length = 0;
}

protected function UpdatePlayer (RePRI OtherRePRI)
{
	GroupPlayer[GroupPlayer.Length] = OtherRePRI;


	if (OtherRePRI.PacketLoss > 0)
	{
		OtherRePRI.bHadPacketLoss = True;
	}
}

protected function UpdateSpectator (RePRI OtherRePRI)
{
	GroupSpectator[GroupSpectator.Length] = OtherRePRI;
}

// #Location

// Preconditions: (PlayerOwnerPRI != None) && (bDrawLocationName)

protected function DrawLocationName (Canvas Canvas)
{
	local string CachedString;
	local float Width_Text;
	local float Height_Text;

	Canvas.DrawColor = Class'PlayerSettings'.Default.LocationNameColor;

	Canvas.Font = GetFontSizeIndex (Canvas, Clamp (Class'PlayerSettings'.Default.LocationNameFontSize, -8, 8));

	if (PawnOwnerPRI == None)
	{
		CachedString = PlayerOwnerPRI.GetLocationName ();
	}
	else
	{
		CachedString = PawnOwnerPRI.GetLocationName ();
	}

	Canvas.StrLen (CachedString, Width_Text, Height_Text);

	Canvas.SetPos
	(
		Height_Text,
		(Canvas.ClipY * DrawLocationName_ScaledPosition_Y * HUDScale)
	);

	Canvas.DrawText (CachedString, False);
}

protected function Shader Shader_Allocate ()
{
	local Shader O;

	O = Shader(Level.ObjectPool.AllocateObject (class'Engine.Shader'));

	if (O != None)
	{
	}

	return O;
}

protected function TexRotator TexRotator_Allocate ()
{
	local TexRotator O;

	O = TexRotator(Level.ObjectPool.AllocateObject (class'Engine.TexRotator'));

	if (O != None)
	{
	}

	return O;
}

protected function FadeColor FadeColor_Allocate ()
{
	local FadeColor O;

	O = FadeColor(Level.ObjectPool.AllocateObject (class'Engine.FadeColor'));

	if (O != None)
	{
	}

	return O;
}

// - To let spectators see the score.
// Preconditions:
// || (PlayerOwner == None)
// || (PawnOwner == None)
// || (PawnOwnerPRI == None)
// || PlayerOwner.IsSpectating ()
// || PlayerOwner.bBehindView

event DrawSpectatingHUD (Canvas Canvas)
{
	local GameReplicationInfo GRI;


	DisplayLocalMessages (Canvas);


	Canvas.Style = ERenderStyle.STY_Alpha;


	if
	(
		!bIsCinematic
		&&
		(PlayerOwner != None)
	)
	{
		if
		(
			(PlayerOwnerPRI != None)
			&&
			!PlayerOwnerPRI.bOnlySpectator
			&&
			bMatchHasBegun
			&&
			PlayerOwner.bBehindView
		)
		{
			DrawSpectatingPlayerHUD (Canvas);
		}


		MatchHint_Draw (Canvas);


		if
		(
			(Level.NetMode == NM_Client)
			&&
			Class'PlayerSettings'.Default.bShowNet
			&&
			(PlayerOwner.PlayerReplicationInfo != None)
			&&
			!bMatchOver // Drawn while waiting and while match is live.
			&&
			!PlayerOwner.bDemoOwner
		)
		{
			NetworkMetrics_Draw (Canvas);
		}


		GRI = PlayerOwner.GameReplicationInfo;

		if
		(
			!bMatchOver // When match is live.
			&&
			(GRI != None)
		)
		{
			if
			(
				bDrawTimer
				&&
				GRI.bMatchhasBegun
			)
			{
				DrawTimer (Canvas);
			}


			if
			(
				(Pawn(PlayerOwner.ViewTarget) != None)
				&&
				(Pawn(PlayerOwner.ViewTarget).PlayerReplicationInfo != None)
			)
			{
				SpectatedPlayerName_Draw (Canvas, Pawn(PlayerOwner.ViewTarget).PlayerReplicationInfo);
			}
		}
		else if
		(
			(Level.NetMode == NM_Client)
			&&
			!bMatchOver
		)
		{
			NetworkStatus_Draw (Canvas);
		}


		if (bSpawnProtection)
		{
			DrawSpawnProtection (Canvas);
		}
	}
}

// - Called for players and spectators whose camera is in third-person view
// locked onto a view target other than themselves.
// Preconditions:
// - (PlayerOwnerPRI != None)

protected function DrawSpectatingPlayerHUD (Canvas Canvas)
{
	if (RespawnStatus_Relevant ())
	{
		RespawnStatus_Draw (Canvas, PlayerOwner.GameReplicationInfo);
	}


	if
	(
		Class'PlayerSettings'.Default.bShowLocationName
		&&
		!bMatchOver
	)
	{
		DrawLocationName (Canvas);
	}


	if
	(
		(
			bShowPortrait
			||
			(
				bShowPortraitVC
				&&
				((Level.TimeSeconds - LastPlayerIDTalkingTime) < 2.0f)
			)
		)
		&&
		PlayerOwner.IsSpectating () // To exclude Dead state.
		&&
		(Portrait != None)
	)
	{
		ChatPortrait_Draw (Canvas);
	}


	if (Class'PlayerSettings'.Default.bShowEventBeacons)
	{
		EventBeacons_Draw (Canvas);
	}
}

// #

event Tick (float DeltaTime)
{
	SinY = Sin (SinTimeSeconds) * 4.0f; // SinAmplitude

	SinTimeSeconds += DeltaTime * 10.0f;


	if (Class'PlayerSettings'.Default.bShowDamageIndicators)
	{
		DisplayHit_Tick_Unrolled (DeltaTime);
	}


	if (Class'PlayerSettings'.Default.bUseTrackingDamageIndicators)
	{
		TrackingDisplayHit_Tick_Unrolled (DeltaTime);
	}


	if (Class'PlayerSettings'.Default.bShowDamagePoints)
	{
		DamagePoints_Tick_Unrolled (DeltaTime);
	}


	ChatPortrait_Tick (DeltaTime);
}

// ## HUD Pass A ##

event DrawHUDPassA (Canvas Canvas)
{
	if
	(
		Class'PlayerSettings'.Default.bShowLocationName
		&&
		!bMatchOver
	)
	{
		DrawLocationName (Canvas);
	}


	Super.DrawHUDPassA (Canvas); // Score, Weapons, DrawTimer, DrawAdrenaline, DrawUDamage, DisplayLocalMessages, (...).


	if
	(
		(Level.NetMode == NM_Client)
		&&
		Class'PlayerSettings'.Default.bShowNet
		&&
		(PlayerOwner.PlayerReplicationInfo != None)
		&&
		!bMatchOver
		&&
		!PlayerOwner.bDemoOwner
	)
	{
		NetworkMetrics_Draw (Canvas);
	}


	if (RespawnStatus_Relevant ())
	{
		RespawnStatus_Draw (Canvas, PlayerOwner.GameReplicationInfo);
	}


	if (bSpawnProtection)
	{
		DrawSpawnProtection (Canvas);
	}
}

// #SpawnProtection

protected function DrawSpawnProtection (Canvas Canvas)
{
	local string CachedString;
	local float X, Y, U, V;

	CachedString = SpawnProtectionString @ SpawnProtectionTime - Level.TimeSeconds;

	Canvas.Font = GetFontSizeIndex (Canvas, -1);

	Canvas.StrLen (CachedString, U, V);

	Canvas.DrawColor = SpawnProtectionBackgroundColor;

    X = Canvas.ClipX * 0.5f - (U * 0.5f);
    Y = (Canvas.ClipY * SpawnProtectionPosY) - (V * 0.5f);

    Canvas.SetPos
    (
        X - (V * 0.5f),
        Y - (V * 0.25f)
    );

    Canvas.DrawTile
    (
        Texture'Textures.MessageBar',
        U + V,
        V + (V * 0.5f),
        0.0f,
        0.0f,
        Texture'Textures.MessageBar'.USize,
        Texture'Textures.MessageBar'.VSize
    );


	Canvas.DrawColor = SpawnProtectionTextColor;

    Canvas.SetPos
    (
        X,
        Y + 2.0f // Meh way due to baseline of font.
    );

	Canvas.DrawText (CachedString, False);
}

// #Countdown

protected function int GetCountdownTimeLimit (ReGRI ReGRI)
{
	return (ReGRI.TimeLimit * 60);
}

protected function int GetCountdownTimeRemaining (ReGRI ReGRI)
{
	return ReGRI.RemainingTime;
}

event CheckCountdown (GameReplicationInfo GRI)
{
	local float TimeSeconds_Limit;
	local float TimeSeconds_Remaining;

	if
	(
		(ReGRI != None)
		&&
		(ReGRI.Winner == None)
	)
	{
		TimeSeconds_Limit = GetCountdownTimeLimit (ReGRI);
		TimeSeconds_Remaining = GetCountdownTimeRemaining (ReGRI);

		if
		(
			(TimeSeconds_Limit > 0)
			&&
			(TimeSeconds_Limit != TimeSeconds_Remaining) // *UT2004Fix*
			&&
			(TimeSeconds_Remaining != 0)
			&&
			(TimeSeconds_Remaining != OldRemainingTime)
		)
		{
			OldRemainingTime = TimeSeconds_Remaining;

			AnnounceCountdown (OldRemainingTime);
		}
	}
}

// Preconditions: (PlayerOwner != None) && (TimeSeconds > 0)

protected function AnnounceCountdown (int TimeSeconds)
{
	if (TimeSeconds > 300)
	{
		return;
	}
	else if (TimeSeconds > 30)
	{
		if
		(
			(TimeSeconds == 300)
			&&
			Class'PlayerSettings'.Default.bFiveMinuteWarning
		)
		{
			PlayerOwner.QueueAnnouncement (LongCountName[0], 1);
			PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, 300);
		}
		else if
		(
			(TimeSeconds == 180)
			&&
			Class'PlayerSettings'.Default.bThreeMinuteWarning
		)
		{
			PlayerOwner.QueueAnnouncement (LongCountName[1], 1);
			PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, 180);
		}
		else if
		(
			(TimeSeconds == 120)
			&&
			Class'PlayerSettings'.Default.bTwoMinuteWarning
		)
		{
			PlayerOwner.QueueAnnouncement (LongCountName[2], 1);
			PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, 120);
		}
		else if
		(
			(TimeSeconds == 60)
			&&
			Class'PlayerSettings'.Default.bOneMinuteWarning
		)
		{
			PlayerOwner.QueueAnnouncement (LongCountName[3], 1);
			PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, 60);
		}
	}
	else if
	(
		(TimeSeconds == 30)
		&&
		Class'PlayerSettings'.Default.bThirtySecondWarning
	)
	{
		PlayerOwner.QueueAnnouncement (LongCountName[4], 1);
		PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, 30);
	}
	else if
	(
		(TimeSeconds == 20)
		&&
		Class'PlayerSettings'.Default.bTwentySecondWarning
	)
	{
		PlayerOwner.QueueAnnouncement (LongCountName[5], 1, AP_InstantPlay);
		PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, 20);
	}
	else if
	(
		Class'PlayerSettings'.Default.bTenSecondWarning
		&&
		(TimeSeconds < 11)
		&&
		(TimeSeconds > 0)
	)
	{
		PlayerOwner.QueueAnnouncement (CountdownName[TimeSeconds - 1], 1, AP_InstantOrQueueSwitch, 1);
		PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, TimeSeconds);
	}
	else if
	(
		Class'PlayerSettings'.Default.bFiveSecondCountdown
		&&
		(TimeSeconds < 6)
		&&
		(TimeSeconds > 0)
	)
	{
		PlayerOwner.QueueAnnouncement (CountdownName[TimeSeconds - 1], 1, AP_InstantOrQueueSwitch, 1);
		PlayerOwner.ReceiveLocalizedMessage (TimeWarningLocalMessageClass, TimeSeconds);
	}
}

protected function int DrawTimer_GetSeconds (GameReplicationInfo GRI)
{
	if (!GRI.bMatchhasBegun)
	{
		return GRI.TimeLimit * 60;
	}
	else if (!GRI.bStopCountdown)
	{
		if (GRI.RemainingTime > 0)
		{
			return GRI.RemainingTime;
		}
		else
		{
			return Abs (GRI.RemainingTime);
		}
	}
	else
	{
		return GRI.ElapsedTime;
	}
}

// #

protected function DrawTimer_UpdateTimeColor (GameReplicationInfo GRI)
{
	if
	(
		(Level.Pauser != None)
		||
		!GRI.bMatchhasBegun
	)
	{
		TimerHours.Tints[0] = WhiteColor;
		TimerMinutes.Tints[0] = WhiteColor;
		TimerSeconds.Tints[0] = WhiteColor;

		TimerDigitSpacer[0].Tints[0] = WhiteColor;
		TimerDigitSpacer[1].Tints[0] = WhiteColor;
	}
	else if (!GRI.bStopCountdown)
	{
		if (GRI.RemainingTime > 0)
		{
			TimerHours.Tints[0] = WhiteColor;
			TimerMinutes.Tints[0] = WhiteColor;
			TimerSeconds.Tints[0] = WhiteColor;

			TimerDigitSpacer[0].Tints[0] = WhiteColor;
			TimerDigitSpacer[1].Tints[0] = WhiteColor;
		}
		else
		{
			TimerHours.Tints[0] = OvertimeColor;
			TimerMinutes.Tints[0] = OvertimeColor;
			TimerSeconds.Tints[0] = OvertimeColor;

			TimerDigitSpacer[0].Tints[0] = OvertimeColor;
			TimerDigitSpacer[1].Tints[0] = OvertimeColor;
		}
	}
	else
	{
		TimerHours.Tints[0] = WhiteColor;
		TimerMinutes.Tints[0] = WhiteColor;
		TimerSeconds.Tints[0] = WhiteColor;

		TimerDigitSpacer[0].Tints[0] = WhiteColor;
		TimerDigitSpacer[1].Tints[0] = WhiteColor;
	}
}

// #

event DrawTimer (Canvas Canvas)
{
	local GameReplicationInfo GRI;
	local int Minutes, Hours, Seconds;

	GRI = PlayerOwner.GameReplicationInfo;

	Seconds = DrawTimer_GetSeconds (GRI);

	// Background | Disc | Icon

	DrawWidgetAsTile (Canvas, TimerBackground);
	DrawWidgetAsTile (Canvas, TimerBackgroundDisc);
	DrawWidgetAsTile (Canvas, TimerIcon);

	// Numbers

	TimerMinutes.OffsetX = default.TimerMinutes.OffsetX - 80;
	TimerSeconds.OffsetX = default.TimerSeconds.OffsetX - 80;

	TimerDigitSpacer[0].OffsetX = Default.TimerDigitSpacer[0].OffsetX;
	TimerDigitSpacer[1].OffsetX = Default.TimerDigitSpacer[1].OffsetX;

	DrawTimer_UpdateTimeColor (GRI);

	if( Seconds > 3600 )
	{
		Hours = Seconds / 3600;
		Seconds -= Hours * 3600;

		DrawNumericWidgetAsTiles (Canvas, TimerHours, DigitsBig);

		TimerHours.Value = Hours;

		if (Hours > 9)
		{
			TimerMinutes.OffsetX = default.TimerMinutes.OffsetX;
			TimerSeconds.OffsetX = default.TimerSeconds.OffsetX;
		}
		else
		{
			TimerMinutes.OffsetX = default.TimerMinutes.OffsetX -40;
			TimerSeconds.OffsetX = default.TimerSeconds.OffsetX -40;

			TimerDigitSpacer[0].OffsetX = Default.TimerDigitSpacer[0].OffsetX - 32;
			TimerDigitSpacer[1].OffsetX = Default.TimerDigitSpacer[1].OffsetX - 32;
		}

		DrawWidgetAsTile (Canvas, TimerDigitSpacer[0]);
	}

	DrawWidgetAsTile (Canvas, TimerDigitSpacer[1]);

	Minutes = Seconds / 60;
	Seconds -= Minutes * 60;

	TimerMinutes.Value = Min(Minutes, 60);
	TimerSeconds.Value = Min(Seconds, 60);

	DrawNumericWidgetAsTiles (Canvas, TimerMinutes, DigitsBig);
	DrawNumericWidgetAsTiles (Canvas, TimerSeconds, DigitsBig);
}

// #

event CalculateEnergy ()
{
	if
	(
		(PawnOwner == None)
		||
		(PawnOwner.Controller == None)
	)
	{
		MaxEnergy = PlayerOwner.AdrenalineMax;
		CurEnergy = Clamp (PlayerOwner.Adrenaline, 0, MaxEnergy);
	}
	else
	{
		MaxEnergy = PawnOwner.Controller.AdrenalineMax;
		CurEnergy = Clamp (PawnOwner.Controller.Adrenaline, 0, MaxEnergy);
	}
}

// #DamagePoints

function DamagePoints_Log (int Type, int Amount)
{
	local int IndexLast;

	IndexLast = DamagePoints_IndexNext - 1;

	if (IndexLast < 0)
	{
		IndexLast = DamagePoints_Count_Tracked - 1; // Wrap
	}

	if ((DamagePoints_TimeSeconds_Completed[IndexLast] - Level.TimeSeconds) > DamagePoints_TimeSeconds_Fadeout)
	{
		DamagePoints_TimeSeconds_Completed[IndexLast] = Level.TimeSeconds + DamagePoints_TimeSeconds_Fadeout;
	}

	DamagePoints_ColorText[DamagePoints_IndexNext] = DamagePoints_Color_Type[Type];
	DamagePoints_Text[DamagePoints_IndexNext] = string(int(Abs (Amount)));
	DamagePoints_OffsetY[DamagePoints_IndexNext] = 0.0f;
	DamagePoints_TimeSeconds_Completed[DamagePoints_IndexNext] = Level.TimeSeconds + DamagePoints_TimeSeconds_Duration;

	DamagePoints_IndexNext = (++DamagePoints_IndexNext) & 7; // Wrap
}

protected function DamagePoints_Tick_Unrolled (float DeltaTime)
{
	DeltaTime *= DamagePoints_Tick_Speed;

	// |

	if ((DamagePoints_TimeSeconds_Completed[0] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[0] -= DeltaTime;
	}

	// ||

	if ((DamagePoints_TimeSeconds_Completed[1] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[1] -= DeltaTime;
	}

	// |||

	if ((DamagePoints_TimeSeconds_Completed[2] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[2] -= DeltaTime;
	}

	// ||||

	if ((DamagePoints_TimeSeconds_Completed[3] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[3] -= DeltaTime;
	}

	// |||| |

	if ((DamagePoints_TimeSeconds_Completed[4] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[4] -= DeltaTime;
	}

	// |||| ||

	if ((DamagePoints_TimeSeconds_Completed[5] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[5] -= DeltaTime;
	}

	// |||| |||

	if ((DamagePoints_TimeSeconds_Completed[6] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[6] -= DeltaTime;
	}

	// |||| ||||

	if ((DamagePoints_TimeSeconds_Completed[7] - Level.TimeSeconds) > 0.0f)
	{
		DamagePoints_OffsetY[7] -= DeltaTime;
	}
}

protected function DamagePoints_Draw_Unrolled (Canvas Canvas)
{
	local float X;
	local float Y;
	local float Width_Text;
	local float Height_Text;
	local float TimeSeconds_Remaining;

	// Initialize

	Canvas.Font = GetFontSizeIndex (Canvas, Class'PlayerSettings'.Default.DamagePointFontSize);
	Canvas.StrLen ("****", Width_Text, Height_Text);

	X = Canvas.ClipX * DamagePoints_ScaledPosition_X - (Width_Text * 0.5f);
	Y = (Canvas.ClipY * DamagePoints_ScaledPosition_Y) - (Height_Text * 0.5f);

	// |

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[0] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[0];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[0].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[0]),
			Y + DamagePoints_OffsetY[0]
		);

		Canvas.DrawText (DamagePoints_Text[0], False);
	}

	// ||

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[1] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[1];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[1].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[1]),
			Y + DamagePoints_OffsetY[1]
		);

		Canvas.DrawText (DamagePoints_Text[1], False);
	}

	// |||

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[2] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[2];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[2].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[2]),
			Y + DamagePoints_OffsetY[2]
		);

		Canvas.DrawText (DamagePoints_Text[2], False);
	}

	// ||||

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[3] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[3];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[3].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[3]),
			Y + DamagePoints_OffsetY[3]
		);

		Canvas.DrawText (DamagePoints_Text[3], False);
	}

	// |||| |

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[4] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[4];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[4].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[4]),
			Y + DamagePoints_OffsetY[4]
		);

		Canvas.DrawText (DamagePoints_Text[4], False);
	}

	// |||| ||

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[5] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[5];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[5].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[5]),
			Y + DamagePoints_OffsetY[5]
		);

		Canvas.DrawText (DamagePoints_Text[5], False);
	}

	// |||| |||

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[6] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[6];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[6].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[6]),
			Y + DamagePoints_OffsetY[6]
		);

		Canvas.DrawText (DamagePoints_Text[6], False);
	}

	// |||| ||||

	TimeSeconds_Remaining = DamagePoints_TimeSeconds_Completed[7] - Level.TimeSeconds;

	if (TimeSeconds_Remaining > 0.0f)
	{
		Canvas.DrawColor = DamagePoints_ColorText[7];

		if (TimeSeconds_Remaining < DamagePoints_TimeSeconds_Fadeout)
		{
			Canvas.DrawColor.A = DamagePoints_ColorText[7].A * (TimeSeconds_Remaining / DamagePoints_TimeSeconds_Fadeout);
		}

		Canvas.SetPos
		(
			X + (Width_Text * DamagePoints_OffsetX[7]),
			Y + DamagePoints_OffsetY[7]
		);

		Canvas.DrawText (DamagePoints_Text[7], False);
	}
}

// #DamageIndicators

event DisplayHit
(
	Vector HitSource,
	int HitDamage,
	class<DamageType> Class_DamageType
)
{
	if (PawnOwner != None)
	{
		if (Class'PlayerSettings'.Default.bShowDamageIndicators)
		{
			Super.DisplayHit (HitSource, HitDamage, Class_DamageType);
		}

		if
		(
			Class'PlayerSettings'.Default.bUseTrackingDamageIndicators
			&&
			(ReGRI != None)
			&&
			ReGRI.bAllowTrackingDamageIndicators
		)
		{
			TrackingDisplayHit (HitSource, HitDamage, Class_DamageType);
		}
	}
}

// ## Network Metrics ##

protected function NetworkMetrics_Draw (Canvas Canvas)
{
	NetworkMetrics_Draw_L_X = Canvas.ClipX * Class'PlayerSettings'.Default.PingPosX;
	NetworkMetrics_Draw_L_Y = Canvas.ClipY * Class'PlayerSettings'.Default.PingPosY;

	// Ping Text

	Canvas.DrawColor = ConnectionStringColor;

	Canvas.Font = GetFontSizeIndex (Canvas, -5);

	Canvas.TextSize
	(
		Class'XInterface.ScoreBoardDeathMatch'.Default.PingText,
		NetworkMetrics_Draw_L_Width_Text,
		NetworkMetrics_Draw_L_Height_Text
	);

	Canvas.SetPos
	(
		NetworkMetrics_Draw_L_X - (NetworkMetrics_Draw_L_Width_Text * 0.5f),
		NetworkMetrics_Draw_L_Y - NetworkMetrics_Draw_L_Height_Text
	);

	Canvas.DrawText (Class'XInterface.ScoreBoardDeathMatch'.Default.PingText, False);

	// Ping Value

	NetworkMetrics_Draw_L_CachedString = string(Min (PlayerOwner.PlayerReplicationInfo.Ping * 4, 999));

	Canvas.TextSize (NetworkMetrics_Draw_L_CachedString, NetworkMetrics_Draw_L_Width_Text, NetworkMetrics_Draw_L_Height_Text);

	Canvas.SetPos
	(
		NetworkMetrics_Draw_L_X - (NetworkMetrics_Draw_L_Width_Text * 0.5f),
		NetworkMetrics_Draw_L_Y
	);

	Canvas.DrawText (NetworkMetrics_Draw_L_CachedString, False);

	// Packet Loss Text

	NetworkMetrics_Draw_L_X = Canvas.ClipX * Class'PlayerSettings'.Default.PacketLossPosX;
	NetworkMetrics_Draw_L_Y = Canvas.ClipY * Class'PlayerSettings'.Default.PacketLossPosY;

	Canvas.TextSize
	(
		Class'XInterface.ScoreBoardDeathMatch'.Default.PLText,
		NetworkMetrics_Draw_L_Width_Text,
		NetworkMetrics_Draw_L_Height_Text
	);

	Canvas.SetPos
	(
		NetworkMetrics_Draw_L_X - (NetworkMetrics_Draw_L_Width_Text * 0.5f),
		NetworkMetrics_Draw_L_Y - NetworkMetrics_Draw_L_Height_Text
	);

	Canvas.DrawText (Class'XInterface.ScoreBoardDeathMatch'.Default.PLText, False);

	// Packet Loss Value

	if (PlayerOwnerPRI.PacketLoss > 0)
	{
		Canvas.DrawColor = ConnectionHasPacketlossStringColor;
	}
	else if (RePRI(PlayerOwnerPRI).bHadPacketLoss)
	{
		Canvas.DrawColor = ConnectionHadPacketlossStringColor;
	}
	else
	{
		Canvas.DrawColor = ConnectionStringColor;
	}

	NetworkMetrics_Draw_L_CachedString = string(PlayerOwner.PlayerReplicationInfo.PacketLoss);

	Canvas.TextSize
	(
		NetworkMetrics_Draw_L_CachedString,
		NetworkMetrics_Draw_L_Width_Text,
		NetworkMetrics_Draw_L_Height_Text
	);

	Canvas.SetPos
	(
		NetworkMetrics_Draw_L_X - (NetworkMetrics_Draw_L_Width_Text * 0.5f),
		NetworkMetrics_Draw_L_Y
	);

	Canvas.DrawText (NetworkMetrics_Draw_L_CachedString, False);
}

protected function bool AcceptLocalizedMessage (Class<LocalMessage> LocalMessageClass)
{
	return
	(
		(LocalMessageClass != None)
		&&
		(LocalMessageClass != Class'UnrealGame.StartupMessage') // Workaround (Demo Recording Playback)
		&&
		(
			!bIsCinematic
			||
			ClassIsChildOf (LocalMessageClass, Class'Gameplay.ActionMessage')
		)
	);
}

protected function string GetCriticalLocalizedMessageString
(
	Class<LocalMessage> Class_LocalMessage,
	int Switch,
	PlayerReplicationInfo RelatedPRI_1,
	PlayerReplicationInfo RelatedPRI_2,
	Object O
)
{
	if
	(
		(PawnOwner != None)
		&&
		(PawnOwner.PlayerReplicationInfo != None)
	)
	{
		if (RelatedPRI_1 == PawnOwner.PlayerReplicationInfo)
		{
			return Class_LocalMessage.Static.GetRelatedString (Switch, RelatedPRI_1, RelatedPRI_2, O);
		}
		else
		{
			return Class_LocalMessage.Static.GetString (Switch, RelatedPRI_1, RelatedPRI_2, O);
		}
	}
	else
	{
		if (RelatedPRI_1 == PlayerOwner.PlayerReplicationInfo)
		{
			return Class_LocalMessage.Static.GetRelatedString (Switch, RelatedPRI_1, RelatedPRI_2, O);
		}
		else
		{
			return Class_LocalMessage.Static.GetString (Switch, RelatedPRI_1, RelatedPRI_2, O);
		}
	}
}

// - Ugly name for ugly workarounds.
// - Special case for demo recording playback.

protected function bool IsDuplicateDemoRecordingConsoleMessage (string Text_Message)
{
	if ((TextMessages_IndexNext - 1) < 0)
	{
		if (Text_Message == TextMessages[ArrayCount (TextMessages) - 1].Text)
		{
			return True;
		}
		else
		{
			return False;
		}
	}
	else if (Text_Message == TextMessages[TextMessages_IndexNext - 1].Text)
	{
		return True;
	}
	else
	{
		return False;
	}
}

// - PlayerController.TeamMessage handles adding chat messages to the chat log.
// Protocol:
// - Add immediately if owner is player.
// - Check if already added (duplicate) if this is a demo recording playback.

protected function AddConsoleMessage
(
	Class<LocalMessage> LocalMessageClass,
	PlayerReplicationInfo RelatedPRI_1,
	string MessageString
)
{
	if
	(
		!PlayerOwner.bDemoOwner
		||
		!IsDuplicateDemoRecordingConsoleMessage (MessageString)
	)
	{
		AddTextMessage (MessageString, LocalMessageClass, RelatedPRI_1);
	}
}

protected function int UniqueLocalizedMessage
(
	Class<LocalMessage> LocalMessageClass
)
{
	if (LocalMessageClass == LocalMessages[0].Message)
	{
		return 0;
	}
	else if (LocalMessageClass == LocalMessages[1].Message)
	{
		return 1;
	}
	else if (LocalMessageClass == LocalMessages[2].Message)
	{
		return 2;
	}
	else if (LocalMessageClass == LocalMessages[3].Message)
	{
		return 3;
	}
	else if (LocalMessageClass == LocalMessages[4].Message)
	{
		return 4;
	}
	else if (LocalMessageClass == LocalMessages[5].Message)
	{
		return 5;
	}
	else if (LocalMessageClass == LocalMessages[6].Message)
	{
		return 6;
	}
	else if (LocalMessageClass == LocalMessages[7].Message)
	{
		return 7;
	}
	else
	{
		return ArrayCount (LocalMessages);
	}
}

// Protocol:
// - Return the first matching slot [0,7].
// - Return ArrayCount (8) if no match.

protected function int PartiallyUniqueLocalizedMessage
(
	Class<LocalMessage> LocalMessageClass,
	int Switch
)
{
	if
	(
		(LocalMessageClass == LocalMessages[0].Message)
		&&
		(LocalMessages[0].Switch == Switch)
	)
	{
		return 0;
	}
	else if
	(
		(LocalMessageClass == LocalMessages[1].Message)
		&&
		(LocalMessages[1].Switch == Switch)
	)
	{
		return 1;
	}
	else if
	(
		(LocalMessageClass == LocalMessages[2].Message)
		&&
		(LocalMessages[2].Switch == Switch)
	)
	{
		return 2;
	}
	else if
	(
		(LocalMessageClass == LocalMessages[3].Message)
		&&
		(LocalMessages[3].Switch == Switch)
	)
	{
		return 3;
	}
	else if
	(
		(LocalMessageClass == LocalMessages[4].Message)
		&&
		(LocalMessages[4].Switch == Switch)
	)
	{
		return 4;
	}
	else if
	(
		(LocalMessageClass == LocalMessages[5].Message)
		&&
		(LocalMessages[5].Switch == Switch)
	)
	{
		return 5;
	}
	else if
	(
		(LocalMessageClass == LocalMessages[6].Message)
		&&
		(LocalMessages[6].Switch == Switch)
	)
	{
		return 6;
	}
	else if
	(
		(LocalMessageClass == LocalMessages[7].Message)
		&&
		(LocalMessages[7].Switch == Switch)
	)
	{
		return 7;
	}
	else
	{
		return ArrayCount (LocalMessages);
	}
}

// Protocol:
// - Return the first free slot (index) [0,7].
// - Return ArrayCount (8) if no free slot.

protected function int GetIndexLocalizedMessage ()
{
	if (LocalMessages[0].Message == None)
	{
		return 0;
	}
	else if (LocalMessages[1].Message == None)
	{
		return 1;
	}
	else if (LocalMessages[2].Message == None)
	{
		return 2;
	}
	else if (LocalMessages[3].Message == None)
	{
		return 3;
	}
	else if (LocalMessages[4].Message == None)
	{
		return 4;
	}
	else if (LocalMessages[5].Message == None)
	{
		return 5;
	}
	else if (LocalMessages[6].Message == None)
	{
		return 6;
	}
	else if (LocalMessages[7].Message == None)
	{
		return 7;
	}
	else
	{
		return ArrayCount (LocalMessages); // 8
	}
}

event LocalizedMessage
(
	Class<LocalMessage> LocalMessageClass,
	optional int Context,
	optional PlayerReplicationInfo RelatedPRI_1,
	optional PlayerReplicationInfo RelatedPRI_2,
	optional Object O,
	optional string MessageString
)
{
	local int IndexLocalMessage;

	if (bLogLocalizedMessage)
	{
		Log (Class'ReUtility'.Static.GetShortTimeString (Level) @ "LocalizedMessage (" $ LocalMessageClass $ ", " $ Context $ ", " $ RelatedPRI_1 $ ", " $ RelatedPRI_2 $ ", " $ O $ ", <" $ MessageString $ ">)");
    }

	if (AcceptLocalizedMessage (LocalMessageClass))
	{
		if (MessageString == "")
		{
			MessageString = GetCriticalLocalizedMessageString (LocalMessageClass, Context, RelatedPRI_1, RelatedPRI_2, O);
		}


		if (!LocalMessageClass.Default.bIsSpecial)
		{
			AddConsoleMessage (LocalMessageClass, RelatedPRI_1, MessageString);
		}
		else
		{
			IndexLocalMessage = ArrayCount (LocalMessages);


			if (LocalMessageClass.Default.bIsUnique)
			{
				IndexLocalMessage = UniqueLocalizedMessage (LocalMessageClass);
			}
			else if
			(
				LocalMessageClass.Default.bIsPartiallyUnique
				||
				PlayerOwner.bDemoOwner
			)
			{
				IndexLocalMessage = PartiallyUniqueLocalizedMessage (LocalMessageClass, Context);
			}


			if (IndexLocalMessage == ArrayCount (LocalMessages))
			{
				IndexLocalMessage = GetIndexLocalizedMessage ();
			}


			if (IndexLocalMessage == ArrayCount (LocalMessages))
			{
				LocalMessages[0] = LocalMessages[1];
				LocalMessages[1] = LocalMessages[2];
				LocalMessages[2] = LocalMessages[3];
				LocalMessages[3] = LocalMessages[4];
				LocalMessages[4] = LocalMessages[5];
				LocalMessages[5] = LocalMessages[6];
				LocalMessages[6] = LocalMessages[7];

				IndexLocalMessage = 7;
			}


			ClearMessage (LocalMessages[IndexLocalMessage]);


			LocalMessages[IndexLocalMessage].Message = LocalMessageClass;
			LocalMessages[IndexLocalMessage].Switch = Context;
			LocalMessages[IndexLocalMessage].RelatedPRI = RelatedPRI_1;
			LocalMessages[IndexLocalMessage].RelatedPRI2 = RelatedPRI_2;
			LocalMessages[IndexLocalMessage].OptionalObject = O;
			LocalMessages[IndexLocalMessage].EndofLife = LocalMessageClass.Static.GetLifetime (Context) + Level.TimeSeconds;
			LocalMessages[IndexLocalMessage].StringMessage = MessageString;
			LocalMessages[IndexLocalMessage].LifeTime = LocalMessageClass.Static.GetLifetime (Context);

			if
			(
				bMessageBeep
				&&
				LocalMessageClass.Default.bBeep
			)
			{
				PlayerOwner.PlayBeepSound (); // *UT2004Fix* Moved here as to not beep twice in a row on console text messages.
			}
		}
	}
}

// - To reduce duplication of logic.
// - Only TeamSay and Say are of concern here.

event Message
(
	PlayerReplicationInfo RelatedPRI_1,
	coerce string Text_Message,
	name NameMessageType
)
{
	switch (NameMessageType)
	{
		case 'TeamSay':

			if (RelatedPRI_1 != None)
			{
				AddTextMessage
				(
					TeamSayLocalMessageClass.static.AssembleString
					(
						Self,
						,
						RelatedPRI_1,
						Text_Message
					),
					TeamSayLocalMessageClass,
					RelatedPRI_1
				);
			}

			return;

		case 'Say':

			if (RelatedPRI_1 != None)
			{
				AddTextMessage
				(
					SayLocalMessageClass.static.AssembleString
					(
						Self,
						,
						RelatedPRI_1,
						Text_Message
					),
					SayLocalMessageClass,
					RelatedPRI_1
				);
			}

			return;

		case 'Announcement':

			AddTextMessage (Text_Message, AnnouncementLocalMessageClass, None);

			return;

		case 'CriticalEvent':

			LocalizedMessage
			(
				CriticalLocalMessageClass,
				0,
				None,
				None,
				None,
				Text_Message
			);

			return;

		case 'DeathMessage':

			AddTextMessage (Text_Message, DeathMessageLocalMessageClass, RelatedPRI_1);

			return;

		default:

			AddTextMessage (Text_Message, MessageLocalMessageClass, RelatedPRI_1);
	}
}

// #EnemyName

event DisplayEnemyName (Canvas Canvas, PlayerReplicationInfo PRI)
{
	PlayerOwner.ReceiveLocalizedMessage
	(
		EnemyPlayerNameLocalMessageClass,
		,
		PRI
	);
}

// To prevent the names of invisible players from popping up on the HUD.

event DrawEnemyName (Canvas Canvas)
{
	local Actor HitActor;

	if
	(
		PlayerOwner.bBehindView
		||
		bNoEnemyNames
		||
		(PawnOwner == None)
		||
		(PawnOwner.Controller == None)
	)
	{
		return;
	}

	DrawEnemyName_L_ViewPos = PawnOwner.Location + PawnOwner.BaseEyeHeight * Vect (0.0f, 0.0f, 1.0f);

	HitActor = Trace (DrawEnemyName_L_HitLocation, DrawEnemyName_L_HitNormal, DrawEnemyName_L_ViewPos + 1200.0f * Vector (PawnOwner.Controller.Rotation), DrawEnemyName_L_ViewPos, True);

	if
	(
		(xPawn(HitActor) != None)
		&&
		(Pawn(HitActor).PlayerReplicationInfo != None)
		&&
		(HitActor != PawnOwner)
		&&
		(PawnOwner.PlayerReplicationInfo.Team != None)
	)
	{
		if // Draw enemy player name
		(
			PawnOwner.PlayerReplicationInfo.Team // Viewer Team
			!=
			Pawn(HitActor).PlayerReplicationInfo.Team
		)
		{
			if
			(
				(
					(NamedPlayer != Pawn(HitActor).PlayerReplicationInfo)
					||
					((Level.TimeSeconds - NameTime) > 0.5f)
				)
				&&
				!xPawn(HitActor).bInvis // Hide name if enemy is invisible.
			)
			{
				DisplayEnemyName (Canvas, Pawn(HitActor).PlayerReplicationInfo);

				NameTime = Level.TimeSeconds;
			}

			NamedPlayer = Pawn(HitActor).PlayerReplicationInfo;
		}
	}
}

// #ChatPortrait

event DisplayPortrait (PlayerReplicationInfo PRI)
{
	if (LastPlayerIDTalking < 1)
	{
		ChatPortrait_Update (PRI.GetPortrait (), PRI);
	}
}

protected function ChatPortrait_PostBeginPlay ()
{
	ChatPortrait_USize_Material_Noise = ChatPortrait_Material_Noise.MaterialUSize ();
	ChatPortrait_VSize_Material_Noise = ChatPortrait_Material_Noise.MaterialVSize ();
}

protected function ChatPortrait_Tick (float DeltaTime)
{
	if
	(
		((Level.TimeSeconds - LastPlayerIDTalkingTime) < 0.1f)
		&&
		(PlayerOwner.GameReplicationInfo != None)
	)
	{
		if
		(
			(PortraitPRI == None)
			||
			(PortraitPRI.PlayerID != LastPlayerIDTalking)
		)
		{
			PortraitPRI = PlayerOwner.GameReplicationInfo.FindPlayerByID (LastPlayerIDTalking);

			if (PortraitPRI != None)
			{
				ChatPortrait_Update (PortraitPRI.GetPortrait (), PortraitPRI);
			}
		}
		else
		{
			PortraitTime = Level.TimeSeconds + 0.2f;
		}
	}
	else
	{
		LastPlayerIDTalking = 0;
	}

	if ((PortraitTime - Level.TimeSeconds) > 0.0f)
	{
		PortraitX = FMax (0.0f, PortraitX - (ChatPortrait_Tick_Speed * DeltaTime)); // Move Right/In
	}
	else if (Portrait != None)
	{
		PortraitX = FMin (1.0f, PortraitX + (ChatPortrait_Tick_Speed * DeltaTime)); // Move Left/Out

		if (PortraitX == 1.0f) // Far Left / Outside
		{
			PortraitPRI = None;

			Portrait = None;
		}
	}
}

protected function ChatPortrait_Draw (Canvas Canvas)
{
}

protected function ChatPortrait_UpdateName (Material M, PlayerReplicationInfo PRI)
{
}

protected function ChatPortrait_Update (Material M, PlayerReplicationInfo PRI)
{
	if (Portrait == None)
	{
		PortraitX = 1.0f;
	}

	PortraitPRI = PRI;
	Portrait = M;
	ChatPortrait_Draw_L_Text_PlayerName = PortraitPRI.PlayerName;
	ChatPortrait_Draw_L_SizeUVSource_Portrait = Portrait.MaterialUSize ();

	if (PortraitPRI.Team != None)
	{
		ChatPortrait_ColorText_PlayerName = Class'PlayerSettings'.Static.GetRelativeTeamColor (LocalTeamIndex, PortraitPRI.Team.TeamIndex);
	}
	else
	{
		ChatPortrait_ColorText_PlayerName = Class'HUD'.Default.GoldColor;
	}

	PortraitTime = Level.TimeSeconds + ChatPortrait_TimeSeconds_Duration;
}

// #

protected function DisplayHit_Reset ()
{
	local int Index;

	for (Index = 0; Index < ArrayCount (DamageTime); ++Index)
	{
		DamageTime[Index] = 0;
	}
}

protected final function DisplayHit_Tick_Unrolled (float DeltaTime)
{
	DeltaTime *= 120.0f;

	// |

	if (DamageTime[0] > 0.0f)
	{
		DamageTime[0] -= DeltaTime;

		if (DamageTime[0] < 1.0f)
		{
			DamageTime[0] = 0.0f;
		}
	}

	// ||

	if (DamageTime[1] > 0.0f)
	{
		DamageTime[1] -= DeltaTime;

		if (DamageTime[1] < 1.0f)
		{
			DamageTime[1] = 0.0f;
		}
	}

	// |||

	if (DamageTime[2] > 0.0f)
	{
		DamageTime[2] -= DeltaTime;

		if (DamageTime[2] < 1.0f)
		{
			DamageTime[2] = 0.0f;
		}
	}

	// ||||

	if (DamageTime[3] > 0.0f)
	{
		DamageTime[3] -= DeltaTime;

		if (DamageTime[3] < 1.0f)
		{
			DamageTime[3] = 0.0f;
		}
	}
}

// #

protected static function Color GetColorHealth (float Pct)
{
	local Color GYRColor;

	GYRColor.A = 255;

	if ( Pct < 0.34 )
	{
		GYRColor.R = 128 + 127 * FClamp(3.0f * Pct, 0.0f, 1.0f);
		GYRColor.G = 63;
		GYRColor.B = 63;
	}
	else if ( Pct < 0.67 )
	{
		GYRColor.R = 255;
		GYRColor.G = 255 * FClamp (3.f * (Pct - 0.33f), 0.0f, 1.0f);
		GYRColor.B = 0;
	}
	else
	{
		GYRColor.R = 0;
		GYRColor.G = 100;
		GYRColor.B = 200;
		GYRColor.A = 255;
	}

	return GYRColor;
}

// #

// Preconditions:
// - (bUseTrackingDamageIndicators)

protected function TrackingDisplayHit_PostBeginPlay ()
{
	local int Index;
	local float Radius;

	// Initialize

	TrackingDisplayHit_USize = TrackingDisplayHit_Texture_Crescent.MaterialUSize ();
	TrackingDisplayHit_VSize = TrackingDisplayHit_Texture_Crescent.MaterialVSize ();

	Radius = TrackingDisplayHit_USize * 0.5f;

	// Stretch Array

	TrackingDisplayHit_Texture.Length = TrackingDisplayHit_Count;

	// Pre-Allocate & Initialize TexRotator

	for (Index = 0; Index < TrackingDisplayHit_Count; ++Index)
	{
		TrackingDisplayHit_Texture[Index] = TexRotator(Level.ObjectPool.AllocateObject (class'Engine.TexRotator'));

		if (TrackingDisplayHit_Texture[Index] != None)
		{
			TrackingDisplayHit_Texture[Index].Material = TrackingDisplayHit_Texture_Crescent;

			TrackingDisplayHit_Texture[Index].TexRotationType = TR_FixedRotation;

			TrackingDisplayHit_Texture[Index].UOffset = Radius;
			TrackingDisplayHit_Texture[Index].VOffset = Radius;
		}
		else // Early Warning
		{
			Warn ("(TrackingDisplayHit_Texture[" $ Index $ "] == None) - Feature Disabled");

			Class'PlayerSettings'.Default.bUseTrackingDamageIndicators = False;

			break;
		}
	}
}

protected function TrackingDisplayHit_Destroyed ()
{
	local int Index;

	// Free TexRotator

	for (Index = 0; Index < TrackingDisplayHit_Count; ++Index)
	{
		if (TrackingDisplayHit_Texture[Index] != None)
		{
			TrackingDisplayHit_Texture[Index].Material = None;

			Level.ObjectPool.FreeObject (TrackingDisplayHit_Texture[Index]);
			TrackingDisplayHit_Texture[Index] = None;
		}
	}

	// Reset Array

	if (Index > 0)
	{
		TrackingDisplayHit_Texture.Length = 0;
	}
}

// - Queue damage events to be drawn.
// Preconditions: (TrackingDisplayHit_Enabled) && (PawnOwner != None)

protected function TrackingDisplayHit
(
	Vector DamageSource,
	int Damage,
	class<DamageType> Class_DamageType
)
{
	if (DamageSource != NullVector)
	{
		if (ClassIsChildof (Class_DamageType, class'UnrealGame.WeaponDamageType'))
		{
			TrackingDisplayHit_Yaw[TrackingDisplayHit_Index] = -(ATan (DamageSource.Y, DamageSource.X) * 32768.0f / PI);

			if (PawnOwner.ShieldStrength > 0)
			{
				TrackingDisplayHit_ColorDamage[TrackingDisplayHit_Index] = TrackingDisplayHit_ColorTexture_Shield;
			}
			else if (PawnOwner.Health > PawnOwner.HealthMax)
			{
				TrackingDisplayHit_ColorDamage[TrackingDisplayHit_Index] = TrackingDisplayHit_ColorTexture_SuperHealth;
			}
			else
			{
				TrackingDisplayHit_ColorDamage[TrackingDisplayHit_Index] = TrackingDisplayHit_ColorTexture_Health;
			}

			TrackingDisplayHit_Time_LastDamage[TrackingDisplayHit_Index] = 255.0f;

			++TrackingDisplayHit_Index;
			TrackingDisplayHit_Index = TrackingDisplayHit_Index & 7;
		}
		else
		{
			if (PawnOwner.ShieldStrength > 0)
			{
				TrackingDisplayHit_ColorDamage[TrackingDisplayHit_Index] = TrackingDisplayHit_ColorTexture_Shield;
			}
			else if (PawnOwner.Health > PawnOwner.HealthMax)
			{
				TrackingDisplayHit_ColorDamage[TrackingDisplayHit_Index] = TrackingDisplayHit_ColorTexture_SuperHealth;
			}
			else
			{
				TrackingDisplayHit_ColorDamage[TrackingDisplayHit_Index] = TrackingDisplayHit_ColorTexture_Health;
			}

			TrackingDisplayHit_DamageLocal_TimeLast = 255.0f;
		}
	}
	else
	{
		if (PawnOwner.ShieldStrength > 0)
		{
			TrackingDisplayHit_DamageLocal_ColorLast = TrackingDisplayHit_DamageLocal_ColorTexture_Shield;
		}
		else if (PawnOwner.Health > PawnOwner.HealthMax)
		{
			TrackingDisplayHit_DamageLocal_ColorLast = TrackingDisplayHit_DamageLocal_ColorTexture_SuperHealth;
		}
		else
		{
			TrackingDisplayHit_DamageLocal_ColorLast = TrackingDisplayHit_DamageLocal_ColorTexture_Health;
		}

		TrackingDisplayHit_DamageLocal_TimeLast = 255.0f;
	}
}

protected function TrackingDisplayHit_Reset ()
{
	local int Index;

	for (Index = 0; Index < TrackingDisplayHit_Count; ++Index)
	{
		TrackingDisplayHit_Time_LastDamage[Index] = 0;
	}

	TrackingDisplayHit_DamageLocal_TimeLast = 0.0f;
}

protected function TrackingDisplayHit_Tick_Unrolled (float DeltaTime)
{
	local float DeltaTime_Crescent;

	// Initialize

	DeltaTime_Crescent = TrackingDisplayHit_TimeFadeOut * DeltaTime;

	// |

	if (TrackingDisplayHit_Time_LastDamage[0] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[0] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[0] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[0] = 0.0f;
		}
	}

	// ||

	if (TrackingDisplayHit_Time_LastDamage[1] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[1] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[1] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[1] = 0.0f;
		}
	}

	// |||

	if (TrackingDisplayHit_Time_LastDamage[2] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[2] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[2] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[2] = 0.0f;
		}
	}

	// ||||

	if (TrackingDisplayHit_Time_LastDamage[3] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[3] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[3] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[3] = 0.0f;
		}
	}

	// |||| |

	if (TrackingDisplayHit_Time_LastDamage[4] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[4] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[4] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[4] = 0.0f;
		}
	}

	// |||| ||

	if (TrackingDisplayHit_Time_LastDamage[5] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[5] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[5] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[5] = 0.0f;
		}
	}

	// |||| |||

	if (TrackingDisplayHit_Time_LastDamage[6] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[6] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[6] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[6] = 0.0f;
		}
	}

	// |||| ||||

	if (TrackingDisplayHit_Time_LastDamage[7] > 0.0f)
	{
		TrackingDisplayHit_Time_LastDamage[7] -= DeltaTime_Crescent;

		if (TrackingDisplayHit_Time_LastDamage[7] < 1.0f)
		{
			TrackingDisplayHit_Time_LastDamage[7] = 0.0f;
		}
	}

	// To tick the self-inflicted damage type indicator.

	if (TrackingDisplayHit_DamageLocal_TimeLast > 0.0f)
	{
		TrackingDisplayHit_DamageLocal_TimeLast -= TrackingDisplayHit_DamageLocal_TimeFadeOut * DeltaTime;

		if (TrackingDisplayHit_DamageLocal_TimeLast < 1.0f)
		{
			TrackingDisplayHit_DamageLocal_TimeLast = 0.0f;
		}
	}
}

// #

protected function DrawTrackingDamageIndicators (Canvas Canvas)
{
	local float X, Y, Size, Yaw;

	// Initialize

	Size = Canvas.ClipX * TrackingDisplayHit_ScaledSize_Crescent * 0.5f;
	X = (Canvas.ClipX * 0.5f) - Size;

	Y = (Canvas.ClipY * 0.5f) - Size;
	Size = Canvas.ClipX * TrackingDisplayHit_ScaledSize_Crescent;

	Yaw = PlayerOwner.Rotation.Yaw;

	// |

	if (TrackingDisplayHit_Time_LastDamage[0] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[0];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[0];

		TrackingDisplayHit_Texture[0].Rotation.Yaw = TrackingDisplayHit_Yaw[0] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[0],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// ||

	if (TrackingDisplayHit_Time_LastDamage[1] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[1];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[1];

		TrackingDisplayHit_Texture[1].Rotation.Yaw = TrackingDisplayHit_Yaw[1] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[1],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// |||

	if (TrackingDisplayHit_Time_LastDamage[2] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[2];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[2];

		TrackingDisplayHit_Texture[2].Rotation.Yaw = TrackingDisplayHit_Yaw[2] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[2],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// ||||

	if (TrackingDisplayHit_Time_LastDamage[3] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[3];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[3];

		TrackingDisplayHit_Texture[3].Rotation.Yaw = TrackingDisplayHit_Yaw[3] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[3],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// |||| |

	if (TrackingDisplayHit_Time_LastDamage[4] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[4];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[4];

		TrackingDisplayHit_Texture[4].Rotation.Yaw = TrackingDisplayHit_Yaw[4] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[4],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// |||| ||

	if (TrackingDisplayHit_Time_LastDamage[5] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[5];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[5];

		TrackingDisplayHit_Texture[5].Rotation.Yaw = TrackingDisplayHit_Yaw[5] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[5],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// |||| |||

	if (TrackingDisplayHit_Time_LastDamage[6] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[6];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[6];

		TrackingDisplayHit_Texture[6].Rotation.Yaw = TrackingDisplayHit_Yaw[6] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[6],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// |||| ||||

	if (TrackingDisplayHit_Time_LastDamage[7] > 0.0f)
	{
		Canvas.DrawColor = TrackingDisplayHit_ColorDamage[7];
		Canvas.DrawColor.A = TrackingDisplayHit_Time_LastDamage[7];

		TrackingDisplayHit_Texture[7].Rotation.Yaw = TrackingDisplayHit_Yaw[7] + Yaw;

		Canvas.SetPos (X, Y);

		Canvas.DrawTile
		(
			TrackingDisplayHit_Texture[7],
			Size,
			Size,
			0.0f,
			0.0f,
			TrackingDisplayHit_USize,
			TrackingDisplayHit_VSize
		);
	}

	// - Draw world damage and self-inflicted damage indicator.
	// - Shows only one damage indicator.

	if (TrackingDisplayHit_DamageLocal_TimeLast > 0.0f)
	{
		X = (Canvas.ClipX * 0.5f) - (Canvas.ClipX * TrackingDisplayHit_DamageLocal_ScaledSize_Texture * 0.5f);
		Y = (Canvas.ClipY * 0.5f) - (Canvas.ClipX * TrackingDisplayHit_DamageLocal_ScaledSize_Texture * 0.5f);

		Size = Canvas.ClipX * TrackingDisplayHit_DamageLocal_ScaledSize_Texture;

		Canvas.DrawColor = TrackingDisplayHit_DamageLocal_ColorLast;
		Canvas.DrawColor.A = TrackingDisplayHit_DamageLocal_TimeLast;

		Canvas.SetPos (X, Y);

		Canvas.DrawTileStretched
		(
			TrackingDisplayHit_Texture_Square,
			Size,
			Size
		);
	}
}


event DrawHUDPassC (Canvas Canvas)
{
	if (Class'PlayerSettings'.Default.bShowEventBeacons)
	{
		EventBeacons_Draw (Canvas);
	}


	if (Class'PlayerSettings'.Default.bShowDamagePoints)
	{
		DamagePoints_Draw_Unrolled (Canvas);
	}


	if
	(
		(
			bShowPortrait
			||
			(
				bShowPortraitVC
				&&
				((Level.TimeSeconds - LastPlayerIDTalkingTime) < 2.0f)
			)
		)
		&&
		(Portrait != None)
	)
	{
		ChatPortrait_Draw (Canvas);
	}


	if (PawnOwner != None)
	{
		if
		(
			bShowWeaponInfo
			&&
			(PawnOwner.Weapon != None)
		)
		{
			PawnOwner.Weapon.NewDrawWeaponInfo (Canvas, 0.86f * Canvas.ClipY);
		}

		if
		(
			(PawnOwner != PlayerOwner.Pawn)
			&&
			(PawnOwner.PlayerReplicationInfo != None)
		)
		{
			SpectatedPlayerName_Draw (Canvas, PawnOwner.PlayerReplicationInfo);
		}
	}


	DrawCrosshair (Canvas);
}

// #

event DrawDamageIndicators (Canvas Canvas)
{
	if (Class'PlayerSettings'.Default.bShowDamageIndicators)
	{
		super.DrawDamageIndicators (Canvas);
	}

	if (Class'PlayerSettings'.Default.bUseTrackingDamageIndicators)
	{
		DrawTrackingDamageIndicators (Canvas);
	}
}

// #Spectating

protected function SpectatedPlayerName_Draw
(
	Canvas Canvas,
	PlayerReplicationInfo SpectatedPRI
)
{
	local string CachedString;
	local Color PawnTeamColor;
	local float Width_Text, Height_Text, X, Y;
	local int PawnTeamIndex;

	// <PawnTeamIndex|PawnTeamColor>
	if
	(
		(PawnOwnerPRI != None)
		&&
		(PawnOwnerPRI.Team != None)
	)
	{
		PawnTeamIndex = Clamp (PawnOwnerPRI.Team.TeamIndex, 0, IndexTeam_Max - 1);

		if (PawnTeamIndex == TeammateTeamIndex)
		{
			PawnTeamColor = TeammateColor;
		}
		else
		{
			PawnTeamColor = EnemyColor;
		}
	}
	else
	{
		PawnTeamColor = GoldColor;
	}
	// </PawnTeamIndex|PawnTeamColor>

	// Player Name

	Y = Canvas.ClipY * 0.71f;

	Canvas.DrawColor = PawnTeamColor;

	Canvas.Font = GetFontSizeIndex (Canvas, 1);

	Canvas.StrLen (SpectatedPRI.PlayerName, Width_Text, Height_Text);

	X = Canvas.ClipX - (Height_Text * 0.5f);

	Canvas.SetPos
	(
		X - Width_Text,
		Y - Height_Text
	);

	Canvas.DrawText (SpectatedPRI.PlayerName, False);

	// Team Name

	if (SpectatedPRI.Team != None)
	{
		CachedString = SpectatedPRI.Team.GetHumanReadableName ();

		Canvas.Font = GetFontSizeIndex (Canvas, -3);

		Canvas.StrLen (CachedString, Width_Text, Height_Text);

		Canvas.SetPos
		(
			X - Width_Text,
			Y
		);

		Canvas.DrawText (CachedString, False);
	}
}

// #MatchHint

protected function MatchHint_PostBeginPlay ()
{
	MatchHint_USize_Texture_Logo = MatchHint_OffsetTexture_Logo.X2 - MatchHint_OffsetTexture_Logo.X1;
	MatchHint_VSize_Texture_Logo = MatchHint_OffsetTexture_Logo.Y2 - MatchHint_OffsetTexture_Logo.Y1;
}

protected function EMatchHintContext MatchHint_GetContext ()
{
	local GameReplicationInfo GRI;
	local PlayerReplicationInfo LocalPRI;

	// Initialize

	GRI = PlayerOwner.GameReplicationInfo;
	LocalPRI = PlayerOwner.PlayerReplicationInfo;

	// Kick Warning > GUI State > Game > Player || Spectator

	if ((Level.TimeSeconds - UnrealPlayer(PlayerOwner).LastKickWarningTime) < 2.0f) // Idling
	{
		return MHC_MatchInProgress_KickWarning; // "You are about to be kicked for idling!"
	}
	else if (GUIController(PlayerOwner.Player.GUIController).ActivePage != None) // GUI
	{
		return MHC_Global_Menu;
	}
	else if // Replication Wait
	(
		(GRI == None)
		||
		(LocalPRI == None)
	)
	{
		return MHC_Replication_WaitingforOtherPlayers; // "Waiting for other players."
	}
	else if (GRI.bMatchhasBegun) // Match Over || Match In Progress
	{
		if // Match Over > Match In Progress
		(
			UnrealPlayer(Owner).bDisplayLoser
			||
			UnrealPlayer(Owner).bDisplayWinner
		)
		{
			if (UnrealPlayer(Owner).bDisplayLoser)
			{
				return MHC_MatchOver_Lost; // YouveLostTheMatch;
			}
			else if (UnrealPlayer(Owner).bDisplayWinner)
			{
				return MHC_MatchOver_Won; // YouveWonTheMatch;
			}
			else
			{
				return MHC_MatchOver_Latecomer; // Joined late. Not really invoked?
			}
		}
		else if (GRI.Winner != None) // Applies to match spectators.
		{
			return MHC_MatchOver_Spectators; // "The match has ended."
		}
		else if // Match In Progress
		(
			(Pawn(PlayerOwner.ViewTarget) != None)
			&&
			(Pawn(PlayerOwner.ViewTarget).PlayerReplicationInfo != None)
		)
		{
			if (PlayerOwner.PlayerReplicationInfo.bOnlySpectator)
			{
				return MHC_MatchInProgress_PlayerOutSpectator; // "Press Fire to View a different Player"
			}
			else
			{
				return MHC_MatchInProgress_PlayerOut; // "You are OUT. Fire to view other players."
			}
		}
		else if (PlayerOwner.IsDead ())
		{
			if (PlayerOwner.PlayerReplicationInfo.bOutofLives)
			{
				return MHC_MatchInProgress_PlayerOut; // "You are OUT. Fire to view other players."
			}
			else
			{
				return MHC_MatchInProgress_PlayerOutCanRespawn; // "You were killed. Press Fire to respawn!"
			}
		}
		else
		{
			return MHC_MatchInProgress_PlayerOutSpectator; // "Press Fire to View a different Player"
		}
	}
	else // Match Pending
	{
		if (LocalPRI.bOnlySpectator) // Match Spectator
		{
			return MHC_MatchPending_SpectatorWaitingforOtherPlayers; // "Waiting for other players."
		}
		else // Match Participant
		{
			if (Level.NetMode == NM_Standalone)
			{
				if (LocalPRI.bReadyToPlay)
				{
					return MHC_StandaloneMatchPending_PlayerIsReadyWaitingforReadySignals; // "Waiting for ready signals. You are READY."
				}
				else
				{
					return MHC_StandaloneMatchPending_PlayerPressFire; // "Press FIRE to start!"
				}
			}
			else if (LocalPRI.bReadyToPlay)
			{
				return MHC_MatchPending_PlayerIsReadyWaitingforReadySignals; // "Waiting for ready signals. You are READY."
			}
			else
			{
				return MHC_MatchPending_PlayerNotReady; // "You are NOT READY. Press Fire!"
			}
		}
	}

	return MHC_Unspecified;
}

protected function string MatchHint_GetText_Status (EMatchHintContext Context)
{
	local GameReplicationInfo GRI;

	// Initialize

	GRI = PlayerOwner.GameReplicationInfo;

	// Kick Warning > GUI State > Game > Player || Spectator

	switch (Context)
	{
		case MHC_MatchInProgress_KickWarning:
			return class'Engine.GameMessage'.Default.KickWarning; // "You are about to be kicked for idling!";

		case MHC_Global_Menu:
			return AtMenus;

		case MHC_Replication_WaitingforOtherPlayers:
			return class'UnrealGame.StartupMessage'.Default.Stage[0]; // "Waiting for other players.";

		case MHC_MatchOver_Lost:
			return YouveLostTheMatch;

		case MHC_MatchOver_Won:
			if (PlayerReplicationInfo(GRI.Winner) != None) // Replication can take time.  Especially if a network client joined at this point.
			{
				return
				(
					WonMatchPrefix
					$ PlayerReplicationInfo(GRI.Winner).PlayerName
					$ WonMatchPostFix
				);
			}
			else
			{
				return YouveWonTheMatch;
			}

		case MHC_MatchOver_Latecomer:
			return "";

		case MHC_MatchOver_Spectators:
			return class'XInterface.ScoreBoardDeathMatch'.Default.Ended; // "The match has ended."

		case MHC_MatchInProgress_SpectatingOtherPlayer:
			return class'XInterface.ScoreboardDeathMatch'.Default.OutFireText; // "You are OUT. Fire to view other players."

		case MHC_MatchInProgress_PlayerOut:
			return class'XInterface.ScoreboardDeathMatch'.Default.OutFireText; // "You are OUT. Fire to view other players."

		case MHC_MatchInProgress_PlayerOutCanRespawn:
			return class'XInterface.ScoreboardDeathMatch'.Default.Restart; // "You were killed. Press Fire to respawn!"

		case MHC_MatchInProgress_PlayerOutSpectator:
			return InitialViewingString; // "Press Fire to View a different Player"

		case MHC_MatchPending_SpectatorWaitingforOtherPlayers:
			return class'UnrealGame.StartupMessage'.Default.Stage[0]; // "Waiting for other players."

		case MHC_StandaloneMatchPending_PlayerIsReadyWaitingforReadySignals:
			return class'UnrealGame.StartupMessage'.Default.Stage[1];

		case MHC_StandaloneMatchPending_PlayerPressFire:
			return class'UnrealGame.StartupMessage'.Default.SinglePlayer; // "Press FIRE to start!"

		case MHC_MatchPending_PlayerIsReadyWaitingforReadySignals:
			return class'UnrealGame.StartupMessage'.Default.Stage[1]; // "Waiting for ready signals. You are READY."

		case MHC_MatchPending_PlayerNotReady:
			return class'UnrealGame.StartupMessage'.Default.NotReady; // "You are NOT READY. Press Fire!"
	}

	return "";
}

protected function MatchHint_Draw (Canvas Canvas)
{
	local Plane PlaneColorModulate;
	local string CachedString;
	local float Height_Text, Height_Bar, Y, Width_Text_Hint;

	// Initialize
	// - Temporarily resets the color modulation to override opacity
	// for the message, must be restored/popped.

	PlaneColorModulate = Canvas.ColorModulate;
	Canvas.ColorModulate = Canvas.Default.ColorModulate;

	// Draw Text

	if (PlayerOwner.GameReplicationInfo != None)
	{
		if (!bMatchHasBegun)
		{
			MatchPending_Draw (Canvas);
		}
	}

	// Draw Hint

	CachedString = MatchHint_GetText_Status (MatchHint_GetContext ());

	Canvas.Font = GetFontSizeIndex (Canvas, MatchHint_IndexSize_Font);

	Canvas.TextSize (CachedString, Width_Text_Hint, Height_Text);

	Y = Canvas.ClipY * 0.96f;

	Height_Bar = Height_Text * 2.0f;

	//

	Canvas.DrawColor = MatchHint_ColorMaterial_Background;

	Canvas.SetPos
	(
		Canvas.ClipX * 0.2f,
		Y - (Height_Bar * 0.5f)
	);

	Canvas.DrawTile
	(
		MatchHint_Texture_Background,
		Canvas.ClipX * 0.6f,
		Height_Bar,
		0.0f,
		0.0f,
		MatchHint_Texture_Background.USize,
		MatchHint_Texture_Background.VSize
	);


	Canvas.DrawColor = MatchHint_Color_Text;

	Canvas.SetPos
	(
		(Canvas.ClipX * 0.5f) - (Width_Text_Hint * 0.5f),
		Y - (Height_Text * 0.5f)
	);

	Canvas.DrawText (CachedString, False);

	Canvas.ColorModulate = PlaneColorModulate;

	// Draw Health / Shield

	if (ShouldDrawSpectatedPlayerStatus ())
	{
		DrawSpectatedPlayerStatus (Canvas);
	}
}

// #

protected function bool ShouldDrawSpectatedPlayerStatus ()
{
	return
	(
		bShowPersonalInfo
		&&
		(PawnOwner != None)
		&&
		!bMatchOver
	);
}

// #

protected function DrawSpectatedPlayerStatus (Canvas Canvas)
{
	local Vehicle VehiclePawnOwner;
	local Pawn RealPawnOwner;
	local Color PawnTeamColor;
	local int PawnTeamIndex;

	// <PawnTeamIndex|PawnTeamColor>
	if
	(
		(PawnOwnerPRI != None)
		&&
		(PawnOwnerPRI.Team != None)
	)
	{
		PawnTeamIndex = Clamp (PawnOwnerPRI.Team.TeamIndex, 0, IndexTeam_Max - 1);


		if (PawnTeamIndex == TeammateTeamIndex)
		{
			PawnTeamColor = TeammateColor;
		}
		else
		{
			PawnTeamColor = EnemyColor;
		}
	}
	else
	{
		PawnTeamIndex = IndexTeam_B; // Follow this rule to be consistent.


		PawnTeamColor = CustomHUDColor;
	}
	// </PawnTeamIndex|PawnTeamColor>

	VehiclePawnOwner = Vehicle(PawnOwner);

	// <Calculate>
	CalculateHealth ();

	DigitsHealth.Value = CurHealth;
	DigitsVehicleHealth.Value = CurVehicleHealth;

	CalculateShield ();

	DigitsShield.Value = CurShield;
	// </Calculate>


	HudBorderShield.Tints[0] = PawnTeamColor;
	HudBorderShield.Tints[1] = PawnTeamColor;

	HudBorderHealth.Tints[0] = PawnTeamColor;
	HudBorderHealth.Tints[1] = PawnTeamColor;

	HudBorderVehicleHealth.Tints[0] = PawnTeamColor;
	HudBorderVehicleHealth.Tints[1] = PawnTeamColor;

	HudBorderAmmo.Tints[0] = PawnTeamColor;
	HudBorderAmmo.Tints[1] = PawnTeamColor;

	HudHealthALERT.Tints[0] = PawnTeamColor;
	HudHealthALERT.Tints[1] = PawnTeamColor;

	HudVehicleHealthALERT.Tints[0] = PawnTeamColor;
	HudVehicleHealthALERT.Tints[1] = PawnTeamColor;


	if
	(
		(VehiclePawnOwner != None)
		&&
		(VehiclePawnOwner.Driver != None)
	)
	{
		if (VehiclePawnOwner.bShowChargingBar)
		{
			DrawVehicleChargeBar (Canvas);
		}

		RealPawnOwner = PawnOwner;

		PawnOwner = Vehicle(PawnOwner).Driver;
	}

	// Health

	DrawHUDAnimWidget (HudBorderHealthIcon, Default.HudBorderHealthIcon.TextureScale, LastHealthPickupTime, 0.6f, 0.6f);

	DrawWidgetAsTile (Canvas, HudBorderHealth);

	if
	(
		!RePRI(PawnOwnerPRI).IsCurrentPlayerStatus ('Thawing')
		&&
		((CurHealth / PawnOwner.HealthMax) < 0.26f)
	)
	{
		DrawWidgetAsTile (Canvas, HudHealthALERT);

		HudBorderHealthIcon.WidgetTexture = Material'HudContent.Generic.HUDPulse';
		HudBorderHealthIcon.TextureCoords = Default.HudBorderHealthIcon.TextureCoords;
		HudBorderHealthIcon.TextureScale = Default.HudBorderHealthIcon.TextureScale;
	}
	else
	{
		HudBorderHealthIcon.WidgetTexture = Default.HudBorderHealth.WidgetTexture;
		HudBorderHealthIcon.TextureCoords = Default.HudBorderHealthIcon.TextureCoords;
		HudBorderHealthIcon.TextureScale = Default.HudBorderHealthIcon.TextureScale;
	}


	DrawWidgetAsTile (Canvas, HudBorderHealthIcon);


	if (CurHealth < LastHealth)
	{
		LastDamagedHealth = Level.TimeSeconds;
	}


	DrawHUDAnimDigit (DigitsHealth, Default.DigitsHealth.TextureScale, LastDamagedHealth, 0.8f, Default.DigitsHealth.Tints[TeamIndex], HudColorHighLight);

	DrawNumericWidgetAsTiles (Canvas, DigitsHealth, DigitsBig);


	if(CurHealth > 999)
	{
		DigitsHealth.OffsetX=220;
		DigitsHealth.OffsetY=-35;
		DigitsHealth.TextureScale=0.39;
	}
	else
	{
		DigitsHealth.OffsetX = default.DigitsHealth.OffsetX;
		DigitsHealth.OffsetY = default.DigitsHealth.OffsetY;
		DigitsHealth.TextureScale = default.DigitsHealth.TextureScale;
	}


	if (RealPawnOwner != None)
	{
		PawnOwner = RealPawnOwner;

		DrawWidgetAsTile (Canvas, HudBorderVehicleHealth);

		if (CurVehicleHealth/PawnOwner.HealthMax < 0.26)
		{
			DrawWidgetAsTile (Canvas, HudVehicleHealthALERT);

			HudBorderVehicleHealthIcon.WidgetTexture = Material'HudContent.Generic.HUDPulse';
		}
		else
		{
			HudBorderVehicleHealthIcon.WidgetTexture = default.HudBorderVehicleHealth.WidgetTexture;
		}


		DrawWidgetAsTile(Canvas, HudBorderVehicleHealthIcon);


		if (CurVehicleHealth < LastVehicleHealth)
		{
			LastDamagedVehicleHealth = Level.TimeSeconds;
		}


		DrawHUDAnimDigit(DigitsVehicleHealth, default.DigitsVehicleHealth.TextureScale, LastDamagedVehicleHealth, 0.8, default.DigitsVehicleHealth.Tints[TeamIndex], HudColorHighLight);

		DrawNumericWidgetAsTiles (Canvas, DigitsVehicleHealth, DigitsBig);


		if (CurVehicleHealth > 999)
		{
			DigitsVehicleHealth.OffsetX = 220;
			DigitsVehicleHealth.OffsetY = -35;
			DigitsVehicleHealth.TextureScale = 0.39;
		}
		else
		{
			DigitsVehicleHealth.OffsetX = default.DigitsVehicleHealth.OffsetX;
			DigitsVehicleHealth.OffsetY = default.DigitsVehicleHealth.OffsetY;
			DigitsVehicleHealth.TextureScale = default.DigitsVehicleHealth.TextureScale;
		}
	}

	if (CurShield > 0)
	{
		DrawWidgetAsTile (Canvas, HudBorderShield);

		DrawWidgetAsTile (Canvas, HudBorderShieldIcon);

		DrawNumericWidgetAsTiles (Canvas, DigitsShield, DigitsBig);


		DrawHUDAnimWidget (HudBorderShieldIcon, Default.HudBorderShieldIcon.TextureScale, LastArmorPickupTime, 0.6, 0.6);
	}
}

// #Match Pending

protected function MatchPending_UpdateText_Title ()
{
	if
	(
		(MatchPending_Text_Title == "")
		&&
		(PlayerOwner != None)
		&&
		(PlayerOwner.GameReplicationInfo != None)
		&&
		(PlayerOwner.GameReplicationInfo.GameName != "")
		&&
		(Level.Title != "")
	)
	{
		MatchPending_Text_Game = PlayerOwner.GameReplicationInfo.GameName;

		MatchPending_Text_Title = Class'ReUtility'.Static.GetPlainString (Level.Title);
	}
}

//

protected function MatchPending_Draw (Canvas Canvas)
{
	local float OffsetX_Side, Width_Text, Height_Text, Height_Bar, Y_Text;
	local byte Alpha;

	Alpha = 127;

	// Initialize

	Canvas.Font = GetFontSizeIndex (Canvas, 0);

	MatchPending_UpdateText_Title ();

	Canvas.TextSize ("*", Width_Text, Height_Text);

	Height_Bar = Height_Text * 2.0f;
	Y_Text = 0.0f + (Height_Bar * 0.5f) - (Height_Text * 0.8f);

	OffsetX_Side = Height_Text * 0.5f;

	Canvas.SetPos
	(
		OffsetX_Side,
		Y_Text
	);

	Canvas.DrawColor = MatchPending_ColorText_LevelTitle;
	Canvas.DrawColor.A = Alpha;

	Canvas.SetPos
	(
		Height_Text * 0.5f,
		Y_Text
	);

	Canvas.DrawText (MatchPending_Text_Title, False);
}

// ## Network Status ##

protected function NetworkStatus_PreBeginPlay ()
{
	NetworkStatus_FadeColor_Circle = FadeColor_Allocate ();
	NetworkStatus_FadeColor_Circle.Color1 = WhiteColor;
	NetworkStatus_FadeColor_Circle.Color1.A = 255;
	NetworkStatus_FadeColor_Circle.Color2 = WhiteColor;
	NetworkStatus_FadeColor_Circle.Color2.A = 127;
	NetworkStatus_FadeColor_Circle.FadePeriod = 0.25f;
	NetworkStatus_FadeColor_Circle.ColorFadeType = FC_Sinusoidal;

	NetworkStatus_TexRotator_Circle = TexRotator_Allocate ();
	NetworkStatus_TexRotator_Circle.Material = Texture'Textures.Spinning';
	NetworkStatus_TexRotator_Circle.UOffset = 128.0f;
	NetworkStatus_TexRotator_Circle.VOffset = 128.0f;
	NetworkStatus_TexRotator_Circle.Rotation.Yaw = -32768;
	NetworkStatus_TexRotator_Circle.TexRotationType = TR_ConstantlyRotating;

	NetworkStatus_Shader_Circle = Shader_Allocate ();
	NetworkStatus_Shader_Circle.Diffuse = NetworkStatus_TexRotator_Circle;
	NetworkStatus_Shader_Circle.Opacity = NetworkStatus_TexRotator_Circle;
	NetworkStatus_Shader_Circle.Specular = NetworkStatus_FadeColor_Circle;
	NetworkStatus_Shader_Circle.SpecularityMask = NetworkStatus_TexRotator_Circle;

	NetworkStatus_SizeUV_Circle = NetworkStatus_Shader_Circle.MaterialUSize ();
}

// Preconditions:
// - (PlayerOwner != None)
// - (GRI != None)
// - (PRI != None)

protected function NetworkStatus_Draw (Canvas Canvas)
{
	local float ScaledSize_Material;
	local float Radius_Material;

	ScaledSize_Material = NetworkStatus_SizeUV_Circle * 0.25f;
	Radius_Material = ScaledSize_Material * 0.5f;

	if (bShowBadConnectionAlert)
	{
		Canvas.DrawColor = RedColor;
		Canvas.DrawColor.A = 127;

		NetworkStatus_FadeColor_Circle.Color1 = RedColor;
		NetworkStatus_FadeColor_Circle.Color2 = RedColor;

		Canvas.SetPos
		(
			(Canvas.ClipX * NetworkStatusPosX) - Radius_Material,
			(Canvas.ClipY * NetworkStatusPosY) - Radius_Material
		);

		Canvas.DrawTile
		(
			NetworkStatus_Shader_Circle,
			ScaledSize_Material,
			ScaledSize_Material,
			0.0f,
			0.0f,
			NetworkStatus_SizeUV_Circle,
			NetworkStatus_SizeUV_Circle
		);
	}
}

// #RespawnStatus

protected function bool RespawnStatus_Relevant ()
{
	return
	(
		!bMatchOver
		&&
		(PlayerOwner.GameReplicationInfo != None)
		&&
		(PlayerOwner.GameReplicationInfo.MaxLives > 1)
	);
}

function RespawnStatus_Update (GameReplicationInfo GRI)
{
	if
	(
		(GRI != None)
		&&
		(GRI.MaxLives > 1)
	)
	{
		if (PawnOwnerPRI == None)
		{
			RespawnStatus_Count_LivesRemaining = GRI.MaxLives - PlayerOwnerPRI.Deaths;
		}
		else
		{
			RespawnStatus_Count_LivesRemaining = GRI.MaxLives - PawnOwnerPRI.Deaths;
		}
	}
}

protected function RespawnStatus_Draw (Canvas Canvas, GameReplicationInfo GRI)
{
	RespawnStatus_Update (GRI);

	RespawnStatus_NumericWidget_Value.Value = RespawnStatus_Count_LivesRemaining;

	DrawWidgetAsTile (Canvas, RespawnStatus_SpriteWidget_SymbolProgress);

	DrawNumericWidgetAsTiles (Canvas, RespawnStatus_NumericWidget_Value, DigitsBig);
}

// #EventBeacons

// - Ignores spectated player beacon.

function EventBeacons_Enqueue
(
	int Code,
	optional PlayerReplicationInfo PRI,
	optional Vector Location_Event,
	optional int Type
)
{
	if (PawnOwnerPRI != PRI)
	{
		RePRI(PRI).ClientEventBeacons_Tag
		(
			Code,
			Location_Event,
			Level.TimeSeconds + EventBeacons_TimeInterval_Lifetime,
			Type,
			EventBeacons_OffsetTexture_Symbol[Code],
			EventBeacons_Color_Symbol[Code]
		);
	}
}

function EventBeacons_Reset ()
{
	local GameReplicationInfo GRI;
	local RePRI OtherRePRI;
	local int Index;

	GRI = PlayerOwner.GameReplicationInfo;

	if (GRI != None)
	{
		for (Index = 0; Index < GRI.PRIArray.Length; ++Index)
		{
			OtherRePRI = RePRI(GRI.PRIArray[Index]);

			if (OtherRePRI != None)
			{
				OtherRePRI.ClientEventBeacons_Reset ();
			}
		}
	}
}

protected static function bool EventBeacons_IsTargetWithinWindow
(
	Canvas Canvas,
	Vector Location_Target,
	Vector Location_Camera,
	Rotator Rotation_Camera,
	out Vector Location_Screen
)
{
	if (((Location_Target - Location_Camera) Dot Vector (Rotation_Camera)) < 0.0f)
	{
		return False;
	}

	Location_Screen = Canvas.WorldToScreen (Location_Target);

	if
	(
		(Location_Screen.X < (Canvas.ClipX * Default.EventBeacons_Window_ScaledPosition.X1))
		||
		(Location_Screen.X > (Canvas.ClipX * Default.EventBeacons_Window_ScaledPosition.X2))
		||
		(Location_Screen.Y < (Canvas.ClipY * Default.EventBeacons_Window_ScaledPosition.Y1))
		||
		(Location_Screen.Y > (Canvas.ClipY * Default.EventBeacons_Window_ScaledPosition.Y2))
	)
	{
		return False;
	}

	return True;
}

protected function EventBeacons_Draw (Canvas Canvas)
{
	local RePRI OtherRePRI;
	local float SizeUV_Symbol, X, Y, YOscillating;
	local int Index;

	if (PlayerOwner.GameReplicationInfo == None)
	{
		return;
	}

	X = Canvas.ClipX * 0.5f;
	Y = Canvas.ClipY * 0.5f;

	Canvas.Font = GetFontSizeIndex (Canvas, Clamp (Class'PlayerSettings'.Default.EventBeaconFontSize, -8, 8));

	Canvas.StrLen ("*", EventBeacons_L_Width_Text, EventBeacons_L_Height_Text);

	SizeUV_Symbol = EventBeacons_L_Height_Text * 1.25f;

	EventBeacons_L_WindowX1 = Canvas.ClipX * EventBeacons_Window_ScaledPosition.X1;
	EventBeacons_L_WindowY1 = Canvas.ClipY * EventBeacons_Window_ScaledPosition.Y1;
	EventBeacons_L_WindowX2 = Canvas.ClipX * EventBeacons_Window_ScaledPosition.X2;
	EventBeacons_L_WindowY2 = Canvas.ClipY * EventBeacons_Window_ScaledPosition.Y2;

	Canvas.GetCameraLocation (EventBeacons_L_Location_Camera, EventBeacons_L_Rotation_Camera);
	GetAxes (EventBeacons_L_Rotation_Camera, EventBeacons_L_X, EventBeacons_L_Y, EventBeacons_L_Z);

	YOscillating = SinY;

	for (Index = 0; Index < GroupPlayer.Length; ++Index)
	{
		OtherRePRI = GroupPlayer[Index];

		if (OtherRePRI.ClientEventBeacons_TimeSeconds > Level.TimeSeconds)
		{
			EventBeacons_L_Location_Target = OtherRePRI.ClientEventBeacons_Location;

			EventBeacons_L_Rectangle_Symbol = OtherRePRI.ClientEventBeacons_OffsetMaterial;
			EventBeacons_L_SizeUV_Symbol = (EventBeacons_L_Rectangle_Symbol.X2 - EventBeacons_L_Rectangle_Symbol.X1) * (SizeUV_Symbol / (EventBeacons_L_Rectangle_Symbol.X2 - EventBeacons_L_Rectangle_Symbol.X1));
			EventBeacons_L_Radius_Symbol = EventBeacons_L_SizeUV_Symbol * 0.5f;

			// Fade

			if ((OtherRePRI.ClientEventBeacons_TimeSeconds - Level.TimeSeconds) > EventBeacons_TimeInterval_Fade)
			{
				EventBeacons_L_ScaledAlpha = 1.0f;
			}
			else
			{
				EventBeacons_L_ScaledAlpha = (OtherRePRI.ClientEventBeacons_TimeSeconds - Level.TimeSeconds) / EventBeacons_TimeInterval_Fade;
			}

			Canvas.DrawColor = OtherRePRI.ClientEventBeacons_ColorMaterial;
			Canvas.DrawColor.A = Canvas.DrawColor.A * EventBeacons_L_ScaledAlpha;

			if (!EventBeacons_IsTargetWithinWindow (Canvas, EventBeacons_L_Location_Target, EventBeacons_L_Location_Camera, EventBeacons_L_Rotation_Camera, EventBeacons_L_Location_Screen))
			{
				// The logic below is taken from Assault.

				EventBeacons_L_DirectionY = Normal (EventBeacons_L_Location_Target - EventBeacons_L_Location_Camera) Dot Normal (EventBeacons_L_Y);
				EventBeacons_L_DirectionZ = Normal (EventBeacons_L_Location_Target - EventBeacons_L_Location_Camera) Dot Normal (EventBeacons_L_Z);

				EventBeacons_L_Distance = Sqrt (EventBeacons_L_DirectionY * EventBeacons_L_DirectionY + EventBeacons_L_DirectionZ * EventBeacons_L_DirectionZ);

				EventBeacons_L_Orientation.X = EventBeacons_L_DirectionY / EventBeacons_L_Distance;
				EventBeacons_L_Orientation.Y = EventBeacons_L_DirectionZ / EventBeacons_L_Distance;

				if (Abs (EventBeacons_L_Orientation.X) > Abs (EventBeacons_L_Orientation.Y))
				{
					EventBeacons_L_Edge = 1.0f / Abs (EventBeacons_L_Orientation.X);
				}
				else if (Abs (EventBeacons_L_Orientation.X) < Abs (EventBeacons_L_Orientation.Y))
				{
					EventBeacons_L_Edge = 1.0f / Abs (EventBeacons_L_Orientation.Y);
				}

				EventBeacons_L_Orientation.X = EventBeacons_L_Orientation.X * EventBeacons_L_Edge;
				EventBeacons_L_Orientation.Y = EventBeacons_L_Orientation.Y * EventBeacons_L_Edge;

				EventBeacons_L_Location_Screen.X = X + (Canvas.ClipX * EventBeacons_L_Orientation.X * 0.5f);
				EventBeacons_L_Location_Screen.Y = Y - (Canvas.ClipY * EventBeacons_L_Orientation.Y * 0.5f);

				// Limit

				EventBeacons_L_Location_Screen.X = FClamp (EventBeacons_L_Location_Screen.X, EventBeacons_L_WindowX1, EventBeacons_L_WindowX2);
				EventBeacons_L_Location_Screen.Y = FClamp (EventBeacons_L_Location_Screen.Y, EventBeacons_L_WindowY1, EventBeacons_L_WindowY2);

				// Fade

				// Symbol

				if (OtherRePRI.ClientEventBeacons_Code != 2)
				{
					if (Class'PlayerSettings'.Default.bShowEventBeaconDistance)
					{
						EventBeacons_L_Text_Distance = string(int(VSize (EventBeacons_L_Location_Target - EventBeacons_L_Location_Camera) * RatioUnrealUnitMeter));

						Canvas.StrLen (EventBeacons_L_Text_Distance, EventBeacons_L_Width_Text, EventBeacons_L_Height_Text);

						if (OtherRePRI.ClientEventBeacons_Code != 2)
						{
							Canvas.SetPos
							(
								EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
								EventBeacons_L_Location_Screen.Y + EventBeacons_L_Radius_Symbol + YOscillating
							);
						}
						else
						{
							Canvas.SetPos
							(
								EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
								EventBeacons_L_Location_Screen.Y + EventBeacons_L_Radius_Symbol
							);
						}

						Canvas.DrawText (EventBeacons_L_Text_Distance, False);
					}

					Canvas.SetPos
					(
						EventBeacons_L_Location_Screen.X - EventBeacons_L_Radius_Symbol,
						EventBeacons_L_Location_Screen.Y - EventBeacons_L_Radius_Symbol + YOscillating
					);

					Canvas.DrawTile
					(
						EventBeacons_Material_Symbols,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y1,
						EventBeacons_L_Rectangle_Symbol.X2 - EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y2 - EventBeacons_L_Rectangle_Symbol.Y1
					);
				}
				else if (!FastTrace (EventBeacons_L_Location_Target, EventBeacons_L_Location_Camera)) // in front and in obscured line-of-sight.
				{
					if (Class'PlayerSettings'.Default.bShowEventBeaconDistance)
					{
						EventBeacons_L_Text_Distance = string(int(VSize (EventBeacons_L_Location_Target - EventBeacons_L_Location_Camera) * RatioUnrealUnitMeter));

						Canvas.StrLen (EventBeacons_L_Text_Distance, EventBeacons_L_Width_Text, EventBeacons_L_Height_Text);

						if (OtherRePRI.ClientEventBeacons_Code != 2)
						{
							Canvas.SetPos
							(
								EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
								EventBeacons_L_Location_Screen.Y + EventBeacons_L_Radius_Symbol + YOscillating
							);
						}
						else
						{
							Canvas.SetPos
							(
								EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
								EventBeacons_L_Location_Screen.Y + EventBeacons_L_Radius_Symbol
							);
						}

						Canvas.DrawText (EventBeacons_L_Text_Distance, False);
					}

					Canvas.StrLen (OtherRePRI.PlayerName, EventBeacons_L_Width_Text, EventBeacons_L_Height_Text);

					Canvas.SetPos
					(
						EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
						EventBeacons_L_Location_Screen.Y - EventBeacons_L_Height_Text - EventBeacons_L_Radius_Symbol
					);

					Canvas.DrawText (OtherRePRI.PlayerName, False);

					//

					Canvas.SetPos
					(
						EventBeacons_L_Location_Screen.X - EventBeacons_L_Radius_Symbol,
						EventBeacons_L_Location_Screen.Y - EventBeacons_L_Radius_Symbol
					);

					Canvas.DrawTile
					(
						EventBeacons_Material_Symbols,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y1,
						EventBeacons_L_Rectangle_Symbol.X2 - EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y2 - EventBeacons_L_Rectangle_Symbol.Y1
					);
				}
			}
			else // The target is visible and in front of the player..
			{
				if (OtherRePRI.ClientEventBeacons_Code == 2) // Always show teammate down location
				{
					Canvas.StrLen (OtherRePRI.PlayerName, EventBeacons_L_Width_Text, EventBeacons_L_Height_Text);

					Canvas.SetPos
					(
						EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
						EventBeacons_L_Location_Screen.Y - EventBeacons_L_Height_Text - EventBeacons_L_Radius_Symbol
					);

					Canvas.DrawText (OtherRePRI.PlayerName, False);

					if
					(
						Class'PlayerSettings'.Default.bShowEventBeaconDistance
						&&
						!FastTrace (EventBeacons_L_Location_Target, EventBeacons_L_Location_Camera)
					)
					{
						EventBeacons_L_Text_Distance = string(int(VSize (EventBeacons_L_Location_Target - EventBeacons_L_Location_Camera) * RatioUnrealUnitMeter));

						Canvas.StrLen (EventBeacons_L_Text_Distance, EventBeacons_L_Width_Text, EventBeacons_L_Height_Text);

						Canvas.SetPos
						(
							EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
							EventBeacons_L_Location_Screen.Y + EventBeacons_L_Radius_Symbol
						);

						Canvas.DrawText (EventBeacons_L_Text_Distance, False);
					}

					// Draw

					Canvas.SetPos
					(
						EventBeacons_L_Location_Screen.X - EventBeacons_L_Radius_Symbol,
						EventBeacons_L_Location_Screen.Y - EventBeacons_L_Radius_Symbol
					);

					Canvas.DrawTile
					(
						EventBeacons_Material_Symbols,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y1,
						EventBeacons_L_Rectangle_Symbol.X2 - EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y2 - EventBeacons_L_Rectangle_Symbol.Y1
					);
				}
				else if (!FastTrace (EventBeacons_L_Location_Target, EventBeacons_L_Location_Camera)) // in front and in obscured line-of-sight.
				{
					if (Class'PlayerSettings'.Default.bShowEventBeaconDistance)
					{
						EventBeacons_L_Text_Distance = string(int(VSize (EventBeacons_L_Location_Target - EventBeacons_L_Location_Camera) * RatioUnrealUnitMeter));

						Canvas.StrLen (EventBeacons_L_Text_Distance, EventBeacons_L_Width_Text, EventBeacons_L_Height_Text);

						Canvas.SetPos
						(
							EventBeacons_L_Location_Screen.X - (EventBeacons_L_Width_Text * 0.5f),
							EventBeacons_L_Location_Screen.Y + EventBeacons_L_Radius_Symbol + YOscillating
						);

						Canvas.DrawText (EventBeacons_L_Text_Distance, False);
					}

					// Draw

					Canvas.SetPos
					(
						EventBeacons_L_Location_Screen.X - EventBeacons_L_Radius_Symbol,
						EventBeacons_L_Location_Screen.Y - EventBeacons_L_Radius_Symbol + YOscillating
					);

					Canvas.DrawTile
					(
						EventBeacons_Material_Symbols,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_SizeUV_Symbol,
						EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y1,
						EventBeacons_L_Rectangle_Symbol.X2 - EventBeacons_L_Rectangle_Symbol.X1,
						EventBeacons_L_Rectangle_Symbol.Y2 - EventBeacons_L_Rectangle_Symbol.Y1
					);
				}
			}
		}
	}
}

// #TypingPrompt

// - To get size for word wrapping.

protected function string GetText_TypingPrompt (string Text, optional int Index)
{
	if (Index < Len (Text))
	{
		return
		(
			DrawTypingPrompt_Text_Prefix
			@ Left (Text, Index)
			$ Chr (4)
			$ Mid (Text, Index)
		);
	}
	else
	{
		return
		(
			DrawTypingPrompt_Text_Prefix
			@ Left (Text, Index)
			$ Chr (4)
			$ "_"
		);
	}
}

protected function GetText_TypingPromptCommand
(
	string Text_Typed,
	out string Out_Text_Command,
	out string Out_Text_Parameters
)
{
	if (!Divide (Text_Typed, " ", Out_Text_Command, Out_Text_Parameters))
	{
		Out_Text_Command = Text_Typed;
	}
}

protected function bool CanSendTextMessage ()
{
	return
	(
		(Level.NetMode == NM_Standalone)
		||
		(
			(PlayerOwner.PlayerReplicationInfo != None)
			&&
			(PlayerOwner.PlayerReplicationInfo.bAdmin)
		)
		||
		(Level.TimeSeconds > PlayerOwner.LastBroadcastTime)
	);
}

// - To allow word wrapping.
// - To warn about message length (red color).
// - To warn about spamming (yellow color).

event DrawTypingPrompt (Canvas Canvas, string Text_Message, optional int Index)
{
	local string LineString, CommandString, ParameterString;
	local float X, Y, XL, YL;

	// Initialize

	Canvas.Style = ERenderStyle.STY_Alpha;

	X = (ConsoleMessagePosX * HUDCanvasScale * Canvas.SizeX) + (((1.0 - HUDCanvasScale) * 0.5) * Canvas.SizeX);

	Canvas.Font = GetConsoleFont (Canvas);

	// Set Clipping

	Canvas.SetOrigin (X, 0.0f);

	Canvas.SetClip
	(
		Canvas.SizeX * DrawTypingPrompt_ScaledWidth_TextArea,
		Canvas.SizeY
	);

	// Word Wrapped Size

	LineString = GetText_TypingPrompt (Text_Message, Index);

	Canvas.StrLen (LineString, XL, YL);

	Y = (ConsoleMessagePosY * HUDCanvasScale * Canvas.SizeY) + (((1.0 - HUDCanvasScale) * 0.5) * Canvas.SizeY);

	// Draw Background

	Canvas.DrawColor = DrawTypingPrompt_BackgroundTextureColor;

	Canvas.SetPos (X, Y - YL);

	Canvas.DrawTileStretched
	(
		DrawTypingPrompt_Texture_Background,
		Canvas.ClipX,
		YL
	);

	// Color

	GetText_TypingPromptCommand (Text_Message, CommandString, ParameterString);

	if
	(
		(CommandString ~= "Say") // Command names are not localized.
		||
		(CommandString ~= "TeamSay") // Command names are not localized.
	)
	{
		if (CanSendTextMessage ())
		{
			if (Len (ParameterString) > Length_MaxClientMessage)
			{
				Canvas.DrawColor = RedColor;
			}
			else
			{
				Canvas.DrawColor = ConsoleColor;
			}
		}
		else
		{
			Canvas.DrawColor = GoldColor;
		}
	}
	else
	{
		Canvas.DrawColor = ConsoleColor;
	}

	Canvas.SetPos (0.0f, Y - YL);
	Canvas.DrawText (LineString);

	// Restore Clipping

	Canvas.SetOrigin (0.0f, 0.0f);
	Canvas.SetClip (Canvas.SizeX, Canvas.SizeY);

	// Combat Typing

	if
	(
		Class'PlayerSettings'.Default.bShowCombatTyping
		&&
		(PlayerOwner.Pawn != None)
		&&
		IsInCombat ()
		&&
		(
			(Level.TimeSeconds - CombatTyping_TimeSeconds_LastWarning)
			>=
			CombatTyping_TimeInterval_LastWarning
		)
	)
	{
		PlayerOwner.ReceiveLocalizedMessage (CombatTypingLocalMessageClass);

		CombatTyping_TimeSeconds_LastWarning = Level.TimeSeconds;
	}
}

// #

protected function bool ChatLog_AllowedTextMessage (Class<LocalMessage> LocalMessageClass)
{
	return
	(
		(Class<LocalMessage_Say>(LocalMessageClass) != None)
		||
		(Class<LocalMessage_TeamSay>(LocalMessageClass) != None)
	);
}

// #Console

event AddTextMessage
(
	string MessageString,
	class<LocalMessage> LocalMessageClass,
	PlayerReplicationInfo RelatedPRI_1
)
{
	// Logging

	if
	(
		(RelatedPRI_1 != None)
		&&
		!PlayerOwner.bDemoOwner
		&&
		!RelatedPRI_1.bBot
		&&
		ChatLog_AllowedTextMessage (LocalMessageClass)
	)
	{
		RePlayer(PlayerOwner).ChatLog_Store (Class'ReUtility'.Static.GetPlainString (MessageString));
	}

	// Add

	TextMessages[TextMessages_IndexNext].Text = MessageString;
	TextMessages[TextMessages_IndexNext].TextColor = LocalMessageClass.Static.GetConsoleColor (RelatedPRI_1);
	TextMessages[TextMessages_IndexNext].MessageLife = Level.TimeSeconds + Clamp (Class'PlayerSettings'.Default.ChatMessageLifetime, Class'PlayerSettings'.Default.ChatMessageLifetime_Min, Class'PlayerSettings'.Default.ChatMessageLifetime_Max);
	TextMessages[TextMessages_IndexNext].PRI = RelatedPRI_1;

	// Increment

	++TextMessages_IndexNext;

	if (TextMessages_IndexNext == ArrayCount (TextMessages))
	{
		TextMessages_IndexNext = 0; // Wrap
	}

	// Beep

	if
	(
		bMessageBeep
		&&
		LocalMessageClass.Default.bBeep
	)
	{
		PlayerOwner.PlayBeepSound ();
	}
}

// #DisplayMessages

// Draws the console messages.

event DisplayMessages (Canvas Canvas)
{
	local float XL, YL, X, Y, Alpha, W, AlphaScaling;
	local int IndexTextMessage, Index;

	// Adjust Position

	if
	(
		bShowScoreboard
		||
		bShowLocalStats
	)
	{
		ConsoleMessagePosY = 0.995f;
	}
	else
	{
		ConsoleMessagePosY = Default.ConsoleMessagePosY;
	}

	// Initialize

	Canvas.Font = GetConsoleFont (Canvas);

	X = (ConsoleMessagePosX * HUDCanvasScale * Canvas.SizeX) + (((1.0f - HUDCanvasScale) / 2.0f) * Canvas.SizeX);
	Y = (ConsoleMessagePosY * HUDCanvasScale * Canvas.SizeY) + (((1.0f - HUDCanvasScale) / 2.0f) * Canvas.SizeY);

	// Set Clipping

	Canvas.SetOrigin (X, 0.0f);

	Canvas.SetClip
	(
		Canvas.SizeX * DrawTypingPrompt_ScaledWidth_TextArea,
		Canvas.SizeY
	);

	// Scale Time (Removed)

	DisplayMessages_L_ScaledTimeSeconds = 1.0f;

	// Draw Hint / Move Up

	if
	(
		(PlayerConsole != None)
		&&
		PlayerConsole.bTyping
	)
	{
		Canvas.StrLen (GetText_TypingPrompt (PlayerConsole.TypedStr, PlayerConsole.TypedStrPos), XL, YL); // To get enough information to wrap text.
		Y -= YL;
	}
	else
	{
		Canvas.TextSize ("*", XL, YL);
		Y -= YL;
	}

	// Draw Messages

	IndexTextMessage = TextMessages_IndexNext - 1;

	if (IndexTextMessage < 0)
	{
		IndexTextMessage = ArrayCount (TextMessages) - 1; // Wrap
	}

	if (Class'PlayerSettings'.Default.bChatMessageStay)
	{
		AlphaScaling = Canvas.ColorModulate.W / ConsoleMessageCount;

		W = Canvas.ColorModulate.W;

		for (Index = 0; Index < ConsoleMessageCount; ++Index)
		{
			Canvas.ColorModulate.W = FMax (0.25f, W * (AlphaScaling * (ConsoleMessageCount - 1 - Index)));

			Canvas.DrawColor = TextMessages[IndexTextMessage].TextColor;

			Canvas.StrLen (TextMessages[IndexTextMessage].Text, XL, YL);

			Canvas.SetPos (0.0f, Y - YL);
			Canvas.DrawText (TextMessages[IndexTextMessage].Text);

			Y -= YL;

			--IndexTextMessage;

			if (IndexTextMessage < 0)
			{
				IndexTextMessage = ArrayCount (TextMessages) - 1; // Wrap
			}
		}

		// Finalize

		Canvas.ColorModulate.W = W;

		// Restore Clipping

		Canvas.SetOrigin (0.0f, 0.0f);
		Canvas.SetClip (Canvas.SizeX, Canvas.SizeY);
	}
	else
	{
		for (Index = 0; Index < ConsoleMessageCount; ++Index)
		{
			Alpha = (TextMessages[IndexTextMessage].MessageLife * DisplayMessages_L_ScaledTimeSeconds) - Level.TimeSeconds;

			if (Alpha <= 0.0f)
			{
				TextMessages[TextMessages_IndexNext].PRI = None;

				break;
			}
			else if (Alpha < 1.0f)
			{
				W = Canvas.ColorModulate.W;
				Canvas.ColorModulate.W = Alpha * W;

				Canvas.DrawColor = TextMessages[IndexTextMessage].TextColor;

				Canvas.StrLen (TextMessages[IndexTextMessage].Text, XL, YL);

				Canvas.SetPos (0.0f, Y - YL);
				Canvas.DrawText (TextMessages[IndexTextMessage].Text);

				Canvas.ColorModulate.W = W;
			}
			else
			{
				Canvas.DrawColor = TextMessages[IndexTextMessage].TextColor;

				Canvas.StrLen (TextMessages[IndexTextMessage].Text, XL, YL);

				Canvas.SetPos (0.0f, Y - YL);
				Canvas.DrawText (TextMessages[IndexTextMessage].Text);
			}

			Y -= YL;

			--IndexTextMessage;

			if (IndexTextMessage < 0)
			{
				IndexTextMessage = ArrayCount (TextMessages) - 1; // Wrap
			}
		}

		// Restore Clipping

		Canvas.SetOrigin (0.0f, 0.0f);
		Canvas.SetClip (Canvas.SizeX, Canvas.SizeY);
	}
}

// #Respawned

// Context:
// - A: NotifyClientSpawned ()

function NotifyClientRespawned ()
{
	if (Class'PlayerSettings'.Default.bShowEventBeacons)
	{
		EventBeacons_Reset ();
	}

	if (Class'PlayerSettings'.Default.bShowDamageIndicators)
	{
		DisplayHit_Reset ();
	}

	if (Class'PlayerSettings'.Default.bUseTrackingDamageIndicators)
	{
		TrackingDisplayHit_Reset ();
	}
}

// #Queries

// - Currently used to show combat typing warning.

protected function bool IsInCombat ()
{
	local PlayerReplicationInfo PRI;

	PRI = PlayerOwner.PlayerReplicationInfo;

	return
	(
		(
			(PRI != None)
			&&
			!PRI.bOnlySpectator
			&&
			PRI.bOutofLives
		)
		||
		!PlayerOwner.IsInState ('GameEnded')
	);
}

// #Statistics

// - Call NextStats () if already drawing stats.
// - If stats are not shown, request to get stats for currently spectated player and show stats.

exec event NextStats ()
{
	local Pawn SpectatedPawn;
	local RePRI SpectatedPRI;

	if (LocalStatsScreen == None)
	{
		GetLocalStatsScreen ();
	}

	if (LocalStatsScreen != None)
	{
		if (bShowLocalStats)
		{
			LocalStatsScreen.NextStats ();
		}
		else if (LocalStatsScreen.IsA ('ReStatistics'))
		{
			SpectatedPawn = Pawn(PlayerOwner.ViewTarget);

			if (SpectatedPawn != None)
			{
				SpectatedPRI = RePRI(SpectatedPawn.PlayerReplicationInfo);
			}

			if (SpectatedPRI != None)
			{
				ReStatistics(LocalStatsScreen).RequestStats (RePRI(PawnOwner.PlayerReplicationInfo));


				ShowStats ();
			}
		}
	}
}

// #

event string GetInfoString ()
{
	Warn ("Replaced");

	return "";
}

// #Commands

protected exec function ShowNet ()
{
	Class'PlayerSettings'.Static.ShowNet ();
}

protected exec function ShowEvents ()
{
	Class'PlayerSettings'.static.ShowEvents ();
}

protected exec function ShowDamage ()
{
	Class'PlayerSettings'.static.ShowDamage ();
}

// #Developers

// - Dumps the state of any queued message.

exec function DumpLocalMessages ()
{
	local int Index;

	for (Index = 0; Index < ArrayCount (LocalMessages); ++Index)
	{
		Log ("LocalMessages[" $ Index $ "].Message:" @ LocalMessages[Index].Message);
		Log ("LocalMessages[" $ Index $ "].StringMessage:" @ LocalMessages[Index].StringMessage);
		Log ("LocalMessages[" $ Index $ "].Switch:" @ LocalMessages[Index].Switch);
		Log ("LocalMessages[" $ Index $ "].RelatedPRI:" @ LocalMessages[Index].RelatedPRI);
		Log ("LocalMessages[" $ Index $ "].RelatedPRI2:" @ LocalMessages[Index].RelatedPRI2);
		Log ("LocalMessages[" $ Index $ "].OptionalObject:" @ LocalMessages[Index].OptionalObject);
		Log ("LocalMessages[" $ Index $ "].EndOfLife:" @ LocalMessages[Index].EndOfLife);
		Log ("LocalMessages[" $ Index $ "].LifeTime:" @ LocalMessages[Index].LifeTime);
		Log ("LocalMessages[" $ Index $ "].StringFont:" @ LocalMessages[Index].StringFont);
		Log ("LocalMessages[" $ Index $ "].DrawColor:" @ LocalMessages[Index].DrawColor.R @ LocalMessages[Index].DrawColor.G @ LocalMessages[Index].DrawColor.B @ LocalMessages[Index].DrawColor.A);
		Log ("LocalMessages[" $ Index $ "].DrawPivot:" @ LocalMessages[Index].DrawPivot);
		Log ("LocalMessages[" $ Index $ "].StackMode:" @ LocalMessages[Index].StackMode);
		Log ("LocalMessages[" $ Index $ "].PosX:" @ LocalMessages[Index].PosX);
		Log ("LocalMessages[" $ Index $ "].PosY:" @ LocalMessages[Index].PosY);
		Log ("LocalMessages[" $ Index $ "].DX:" @ LocalMessages[Index].DX);
		Log ("LocalMessages[" $ Index $ "].DY:" @ LocalMessages[Index].DY);
		Log ("LocalMessages[" $ Index $ "].Drawn:" @ LocalMessages[Index].Drawn);
	}
}

// #

event DrawAdrenaline (Canvas Canvas)
{
	local TeamComboReplicationInfo TCRI;
	local float PosY, Scale;
	local int Index, Type, Drawn;

	Super.DrawAdrenaline (Canvas);

	// Team Combos

	if
	(
		PlayerOwner.bAdrenalineEnabled
		&&
		Class'PlayerSettings'.Default.bShowTeamCombos
		&&
		(ReGRI != None)
		&&
		ReGRI.bTeamCombos
		&&
		(PawnOwnerPRI != None)
		&&
		(PawnOwnerPRI.Team != None)
		&&
		(PawnOwnerPRI.Team.TeamIndex < IndexTeam_Max)
		&&
		(ReGRI.TeamComboReplicationInfo[PawnOwnerPRI.Team.TeamIndex] != None)
	)
	{
		TCRI = ReGRI.TeamComboReplicationInfo[PawnOwnerPRI.Team.TeamIndex];
	}

	if
	(
		(TCRI != None)
		&&
		TCRI.bRunning
	)
	{
	    Scale = FMax (HUDScale, 0.75f);

	    PosY = 1.0f - (0.105f * Scale);

	    for (Index = 0; Index < ArrayCount (TCRI.Type); ++Index)
	    {
	        if (TCRI.RemainingTime[Index] > 0.0f)
	        {
	            TeamComboBackgroundSpriteWidget.PosY = (PosY - (0.033f * Drawn) * Scale);
	            DrawWidgetAsTile (Canvas, TeamComboBackgroundSpriteWidget);

				Type = TCRI.Type[Index];

	            TeamComboTypeSpriteWidget[Type].PosY = (PosY - (0.033f * Drawn) * Scale);
	            DrawWidgetAsTile (Canvas, TeamComboTypeSpriteWidget[Type]);

	            TeamComboAdrenalineNumericWidget.Value = TCRI.RemainingTime[Index];
	            TeamComboAdrenalineNumericWidget.PosY = (PosY - (0.033f * Drawn) * Scale);

	            DrawNumericWidgetAsTiles (Canvas, TeamComboAdrenalineNumericWidget, DigitsBig);

	            ++Drawn;
	        }
	    }
	}
}

exec function Opacity (optional byte RequestedOpacity)
{
	if
	(
		(
			bShowScoreboard
			&&
			!bShowLocalStats
		)
		&&
		(Scoreboard != None)
		&&
		(Scoreboard.IsA ('ReTeamGameScoreboard'))
	)
	{
		ReTeamGameScoreboard(Scoreboard).SetOpacity (RequestedOpacity);
	}
}

// #

DefaultProperties
{
	ChatPortrait_Material_Noise = Material'XGameShaders.ModuNoise'
	ChatPortrait_ColorTexture_Portrait = (R=255,G=255,B=255,A=191)
	ChatPortrait_ColorTexture_Effect = (R=223,G=223,B=223,A=255)
	ChatPortrait_ColorTexture_Frame = (R=255,G=255,B=255,A=255)
	ChatPortrait_ColorAlphaTexture_Health = 135
	ChatPortrait_TimeSeconds_Duration = 3.0
	ChatPortrait_Tick_Speed = 6.0

	//

	SpawnProtectionPosY = 0.21
	SpawnProtectionString = "Spawn Protection:"

	SpawnProtectionTextColor = (R=255,G=255,B=255,A=156)
	SpawnProtectionBackgroundColor = (R=255,G=255,B=255,A=156)

	// Messages

	SayLocalMessageClass = Class'LocalMessage_Say'
	TeamSayLocalMessageClass = Class'LocalMessage_TeamSay'
	CriticalLocalMessageClass = Class'Gameplay.CriticalEventPlus'
	AnnouncementLocalMessageClass = Class'LocalMessage_Announcement'
	DeathMessageLocalMessageClass = Class'LocalMessage_Deaths'
	MessageLocalMessageClass = Class'UnrealGame.StringMessagePlus'
	TimeWarningLocalMessageClass = Class'LocalMessage_TimeWarning'
	EnemyPlayerNameLocalMessageClass = Class'LocalMessage_PlayerName'
	CombatTypingLocalMessageClass = Class'LocalMessage_CombatTyping'

	// Colors

	ConnectionStringColor = (R=28,G=223,B=244,A=255)
	ConnectionHadPacketlossStringColor = (R=255,G=127,B=31,A=255)
	ConnectionHasPacketlossStringColor = (R=255,G=255,B=31,A=255)
	OvertimeColor = (R=255,G=223,B=31,A=255)

	// CombatTyping

	CombatTyping_TimeInterval_LastWarning = 1.5

	// DamagePoints

	DamagePoints_ScaledPosition_X = 0.5
	DamagePoints_ScaledPosition_Y = 0.475
	DamagePoints_TimeSeconds_Duration = 1.5
	DamagePoints_TimeSeconds_Fadeout = 0.75
	DamagePoints_Tick_Speed = 150.0
	DamagePoints_OffsetX(0) = -0.5
	DamagePoints_OffsetX(1) = 0.5
	DamagePoints_OffsetX(2) = -1.0
	DamagePoints_OffsetX(3) = 1.0
	DamagePoints_OffsetX(4) = -1.5
	DamagePoints_OffsetX(5) = 1.5
	DamagePoints_OffsetX(6) = -2.0
	DamagePoints_OffsetX(7) = 2.0
	DamagePoints_Color_Type(0) = (R=255,G=223,B=23,A=223) // Enemy Damage Done
	DamagePoints_Color_Type(1) = (R=208,G=109,B=255,A=223) // Enemy Damage Taken / Not Implemented
	DamagePoints_Color_Type(2) = (R=32,G=255,B=32,A=223) // Team Damage Done
	DamagePoints_Color_Type(3) = (R=63,G=223,B=63,A=223) // Team Damage Taken / Not Implemented
	DamagePoints_Color_Type(4) = (R=0,G=255,B=255,A=223) // Other Damage Taken / Not Implemented

	// LocationName

	DrawLocationName_ScaledPosition_Y = 0.075

	// TypingPromt

	DrawTypingPrompt_BackgroundTextureColor = (R=0,G=0,B=0,A=63)
	DrawTypingPrompt_Texture_Background = Texture'Engine.WhiteSquareTexture'
	DrawTypingPrompt_ScaledWidth_TextArea = 0.75
	DrawTypingPrompt_Text_Prefix = "(>"

	// EventBeacons

	EventBeacons_Window_ScaledPosition = (X1=0.1,Y1=0.15,X2=0.9,Y2=0.85)
	EventBeacons_Material_Symbols = Material'Textures.Symbols'
	EventBeacons_OffsetTexture_Symbol(0) = (X1=0,Y1=896,X2=64,Y2=960) // -
	EventBeacons_OffsetTexture_Symbol(1) = (X1=0,Y1=512,X2=90,Y2=602) // Enemy Camping
	EventBeacons_OffsetTexture_Symbol(2) = (X1=0,Y1=960,X2=64,Y2=1024) // Teammate Down
	EventBeacons_OffsetTexture_Symbol(3) = (X1=192,Y1=64,X2=256,Y2=128) // -
	EventBeacons_Color_Symbol(0) = (R=255,G=255,B=255,A=127) // -
	EventBeacons_Color_Symbol(1) = (R=255,G=191,B=0,A=127) // Enemy Camping
	EventBeacons_Color_Symbol(2) = (R=255,G=255,B=255,A=127) // Teammate Down
	EventBeacons_Color_Symbol(3) = (R=255,G=255,B=255,A=127) // -
	EventBeacons_TimeInterval_Lifetime = 3.5
	EventBeacons_TimeInterval_Fade = 1.0

	// TeamCombos

	TeamComboAdrenalineNumericWidget = (RenderStyle=STY_Alpha,TextureScale=0.27,DrawPivot=DP_MiddleRight,PosX=0.98,PosY=0.06,OffsetX=-44,OffsetY=45,Tints[0]=(B=255,G=255,R=255,A=255),Tints[1]=(B=255,G=255,R=255,A=255))
	TeamComboBackgroundSpriteWidget = (WidgetTexture=Texture'HUDContent.Generic.HUD',RenderStyle=STY_Alpha,TextureCoords=(X1=168,Y1=211,X2=334,Y2=255),TextureScale=0.25,DrawPivot=DP_UpperRight,PosX=0.99,PosY=0.06,OffsetY=25,ScaleMode=SM_Left,Scale=1.5,Tints[0]=(A=150),Tints[1]=(A=150))

	TeamComboTypeSpriteWidget(1) = (WidgetTexture=Texture'Textures.ComboIcons',RenderStyle=STY_Alpha,TextureCoords=(X1=90,Y1=173,X2=166,Y2=249),TextureScale=0.2,DrawPivot=DP_UpperRight,PosX=0.9875,PosY=0.06,OffsetX=10,OffsetY=23,ScaleMode=SM_Right,Scale=1.0,Tints[0]=(B=255,G=255,R=255,A=200),Tints[1]=(B=255,G=255,R=255,A=200))
	TeamComboTypeSpriteWidget(2) = (WidgetTexture=Texture'Textures.ComboIcons',RenderStyle=STY_Alpha,TextureCoords=(X1=174,Y1=5,X2=250,Y2=81),TextureScale=0.2,DrawPivot=DP_UpperRight,PosX=0.9875,PosY=0.06,OffsetX=10,OffsetY=23,ScaleMode=SM_Right,Scale=1.0,Tints[0]=(B=255,G=255,R=255,A=200),Tints[1]=(B=255,G=255,R=255,A=200))
	TeamComboTypeSpriteWidget(3) = (WidgetTexture=Texture'Textures.ComboIcons',RenderStyle=STY_Alpha,TextureCoords=(X1=5,Y1=173,X2=81,Y2=249),TextureScale=0.2,DrawPivot=DP_UpperRight,PosX=0.9875,PosY=0.06,OffsetX=10,OffsetY=23,ScaleMode=SM_Right,Scale=1.0,Tints[0]=(B=255,G=255,R=255,A=200),Tints[1]=(B=255,G=255,R=255,A=200))
	TeamComboTypeSpriteWidget(4) = (WidgetTexture=Texture'Textures.ComboIcons',RenderStyle=STY_Alpha,TextureCoords=(X1=5,Y1=5,X2=81,Y2=81),TextureScale=0.2,DrawPivot=DP_UpperRight,PosX=0.9875,PosY=0.06,OffsetX=10,OffsetY=23,ScaleMode=SM_Right,Scale=1.0,Tints[0]=(B=255,G=255,R=255,A=200),Tints[1]=(B=255,G=255,R=255,A=200))
	TeamComboTypeSpriteWidget(5) = (WidgetTexture=Texture'Textures.ComboIcons',RenderStyle=STY_Alpha,TextureCoords=(X1=174,Y1=173,X2=250,Y2=249),TextureScale=0.2,DrawPivot=DP_UpperRight,PosX=0.9875,PosY=0.06,OffsetX=10,OffsetY=23,ScaleMode=SM_Right,Scale=1.0,Tints[0]=(B=255,G=255,R=255,A=200),Tints[1]=(B=255,G=255,R=255,A=200))
	TeamComboTypeSpriteWidget(6) = (WidgetTexture=Texture'Textures.ComboIcons',RenderStyle=STY_Alpha,TextureCoords=(X1=89,Y1=5,X2=165,Y2=81),TextureScale=0.2,DrawPivot=DP_UpperRight,PosX=0.9875,PosY=0.06,OffsetX=10,OffsetY=23,ScaleMode=SM_Right,Scale=1.0,Tints[0]=(B=255,G=255,R=255,A=200),Tints[1]=(B=255,G=255,R=255,A=200))
	TeamComboTypeSpriteWidget(7) = (WidgetTexture=Texture'Textures.ComboIcons',RenderStyle=STY_Alpha,TextureCoords=(X1=89,Y1=89,X2=165,Y2=165),TextureScale=0.2,DrawPivot=DP_UpperRight,PosX=0.9875,PosY=0.06,OffsetX=10,OffsetY=23,ScaleMode=SM_Right,Scale=1.0,Tints[0]=(B=255,G=255,R=255,A=200),Tints[1]=(B=255,G=255,R=255,A=200))

	// MatchHint

	MatchHint_IndexSize_Font = -3
	MatchHint_Color_Text = (R=255,G=255,B=255,A=223)

	MatchHint_ColorTexture_Logo = (R=255,G=255,B=255,A=159)
	MatchHint_Texture_Logo = Texture'Textures.Symbols'
	MatchHint_OffsetTexture_Logo = (X1=258,Y1=898,X2=426,Y2=1020)

	MatchHint_ColorMaterial_Background = (R=255,G=255,B=255,A=223)
	MatchHint_Texture_Background = Texture'Textures.MessageBackground'

	// MatchPending

	MatchPending_ColorText_LevelTitle = (R=255,G=255,B=255,A=191)

	// NetworkStatus

	NetworkStatusPosX = 0.5
	NetworkStatusPosY = 0.25

	// Symbols

	OffsetTexture_Playing = (X1=704,Y1=960,X2=768,Y2=1024)
	OffsetTexture_Out = (X1=384,Y1=0,X2=448,Y2=64)
	OffsetTexture_Spawning = (X1=320,Y1=0,X2=384,Y2=64)

	// Widgets

	RespawnStatus_SpriteWidget_SymbolProgress = (WidgetTexture=Texture'Textures.Symbols',PosX=0.8,PosY=0.019,OffsetX=0,OffsetY=0,DrawPivot=DP_UpperMiddle,RenderStyle=STY_Alpha,TextureCoords=(X1=320,Y1=0,X2=384,Y2=64),TextureScale=0.4,ScaleMode=SM_Up,Scale=1.0,Tints[0]=(R=255,G=255,B=255,A=223),Tints[1]=(R=255,G=255,B=255,A=223))
	RespawnStatus_NumericWidget_Value = (RenderStyle=STY_Alpha,TextureScale=0.5,DrawPivot=DP_UpperMiddle,PosX=0.8,PosY=0.0225,OffsetX=0,OffsetY=0,Tints[0]=(B=255,G=255,R=255,A=255),Tints[1]=(B=255,G=255,R=255,A=255))

	// TrackingDisplayHit

	TrackingDisplayHit_ColorTexture_Shield = (R=255,G=191,B=0,A=200) // Orange-Yellow
	TrackingDisplayHit_ColorTexture_SuperHealth = (R=255,G=31,B=255,A=200) // Purple
	TrackingDisplayHit_ColorTexture_Health = (R=255,G=0,B=0,A=200) // Red
	TrackingDisplayHit_ScaledSize_Crescent = 0.15
	TrackingDisplayHit_Texture_Crescent = Texture'Textures.DamageIndicator'
	TrackingDisplayHit_Texture_Square = Texture'Textures.DamageRectangle'
	TrackingDisplayHit_DamageLocal_ScaledSize_Texture = 0.5
	TrackingDisplayHit_DamageLocal_ColorTexture_Shield = (R=255,G=191,B=0,A=200)
	TrackingDisplayHit_DamageLocal_ColorTexture_SuperHealth = (R=255,G=31,B=255,A=200)
	TrackingDisplayHit_DamageLocal_ColorTexture_Health = (R=255,G=0,B=0,A=200)

	// HUDCDeathMatch

	AdrenalineBackground = (WidgetTexture=Texture'HudContent.Generic.HUD',Tints[0]=(G=0,R=0,B=0,A=159),Tints[1]=(G=0,R=0,B=0,A=159)) // Always black
	TimerBackground = (Tints[0]=(B=0,G=0,R=0,A=150),Tints[1]=(B=0,G=0,R=0,A=150)) // Always black

	// HUD

	ConsoleMessagePosX = 0.0125 // Just a bit from the side
	ConsoleMessagePosY = 0.88
}
