// *F* Developed 2013 rejecht <rejecht at outlook dot com>

// Background:
// - PlayerReplicationInfo is updated at a low frequency.
// - RealtimePlayerInfo is updated as fast as possible.

// CurrentPlayerStatusName:
// - Unspecified
// - Thawing
// - Out

class RealtimePlayerInfo extends ReplicationInfo
	HideDropDown
	;

// #Replication

var(Replicated) protected name CurrentPlayerStatusName;

replication
{
	reliable if (bNetDirty && (Role == ROLE_Authority))
		CurrentPlayerStatusName
		;
}

// #

event Reset ()
{
	Super.Reset ();


	ResetPlayerStatus ();
}

function ResetPlayerStatus ()
{
	CurrentPlayerStatusName = Default.CurrentPlayerStatusName;
}

function DefaultPlayerStatus ()
{
	CurrentPlayerStatusName = Default.CurrentPlayerStatusName;
}

// #

function ChangePlayerStatus (name RequestedPlayerStatusName)
{
	switch (RequestedPlayerStatusName)
	{
		case 'Dead':
		case 'Out':
		case 'Thawing':

			CurrentPlayerStatusName = RequestedPlayerStatusName;

			break;

		default:

			CurrentPlayerStatusName = Default.CurrentPlayerStatusName;

			Warn (Level.TimeSeconds @ Self @ "Unknown (RequestedPlayerStatusName)" @ RequestedPlayerStatusName);

			break;
    }
}

// #

simulated function string LogPlayerStatus ()
{
	return string(CurrentPlayerStatusName);
}

// #

simulated function bool IsCurrentPlayerStatus (name QueriedPlayerStatusName)
{
	return (CurrentPlayerStatusName == QueriedPlayerStatusName);
}

// #

DefaultProperties
{
	CurrentPlayerStatusName = Unspecified

	// Actor

	NetUpdateFrequency = 50
}
