// *F* Developed 2011-2013 rejecht <rejecht at outlook dot com>

class Statistics_AssaultRifle extends AssaultRifle
	CacheExempt
	HideDropdown
	;

// #Statistics

var(Cached) protected int Statistics_FireModeIndex[NUM_FIRE_MODES];

// #Lifetime

simulated event PostBeginPlay ()
{
	Super.PostBeginPlay ();


	if (Role == ROLE_Authority)
	{
		Statistics_PostBeginPlay ();
    }
}

// #Statistics

protected function Statistics_PostBeginPlay ()
{
	local AwardPRI AwardPRI;

	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	Statistics_FireModeIndex[0] = AwardPRI.Statistics_RegisterWeaponDamageType (Class'XWeapons.DamTypeAssaultBullet', 0);
	Statistics_FireModeIndex[1] = AwardPRI.Statistics_RegisterWeaponDamageType (Class'XWeapons.DamTypeAssaultGrenade', 1);
}

// #

simulated event bool ConsumeAmmo (int Mode, float Load, optional bool bAmountNeededIsMax)
{
	local AwardPRI AwardPRI;
	local bool bConsumed;

	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	bConsumed = Super.ConsumeAmmo (Mode, Load, bAmountNeededIsMax);

	if
	(
		(Role == ROLE_Authority)
		&&
		bConsumed
		&&
		(AwardPRI != None)
	)
	{
		AwardPRI.Statistics_LogWeaponFiredByIndex (Statistics_FireModeIndex[Mode], 1); // Handles both modes.
	}

	return bConsumed;
}

// #

DefaultProperties
{
}
