// *F* Developed 2011-2013 rejecht <rejecht at outlook dot com>

// - Logs both modes.
// - Caches separate stat for homing rockets.

class Statistics_RocketLauncher extends RocketLauncher
	CacheExempt
	;

// #Statistics

var(Cached) protected int Statistics_FireModeIndex;

// #Lifetime

simulated event PostBeginPlay ()
{
	Super.PostBeginPlay ();


	if (Role == ROLE_Authority)
	{
		Statistics_PostBeginPlay ();
    }
}

// #Statistics

protected function Statistics_PostBeginPlay ()
{
	local AwardPRI AwardPRI;

	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	Statistics_FireModeIndex = AwardPRI.Statistics_RegisterWeaponDamageType (Class'XWeapons.DamTypeRocket', 0);

	AwardPRI.Statistics_RegisterWeaponDamageType (Class'XWeapons.DamTypeRocketHoming', 2);
}

// #

simulated event bool ConsumeAmmo (int Mode, float Load, optional bool bAmountNeededIsMax)
{
	local AwardPRI AwardPRI;
	local bool bConsumed;

	AwardPRI = AwardPRI(Instigator.PlayerReplicationInfo);

	bConsumed = Super.ConsumeAmmo (Mode, Load, bAmountNeededIsMax);

	if
	(
		(Role == ROLE_Authority)
		&&
		bConsumed
		&&
		(AwardPRI != None)
	)
	{
		AwardPRI.Statistics_LogWeaponFiredByIndex (Statistics_FireModeIndex, Load);
	}

	return bConsumed;
}

// #

DefaultProperties
{
}
