// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class UT2K4Tab_Identicard extends MidGamePanel
	HideDropDown
	;

const bSaveDefault = True;


var protected Texture TextureFlag;
var protected IntBox OffsetTextureFlag;


var protected automated GUISectionBackground sb_Background;




var protected string sCountryCode;
var automated moEditBox ed_CountryCode;
var automated GUIImage i_CountryFlag;


var protected xUtil.PlayerRecord PR;
var protected string sCharacter;
var automated GUIImage i_Character;


// #Lifetime

event InitComponent (GUIController MyController, GUIComponent MyOwner)
{
	Super.InitComponent (MyController, MyOwner);

	ed_CountryCode.MyEditBox.bConvertSpaces = True;
	ed_CountryCode.MyEditBox.MaxWidth = 16;  // as per polge, check UT2K4Tab_PlayerSettings if you change this
}

function Free ()
{
	Super.Free ();


	TextureFlag = None;
}

// #Initialization

function InternalOnLoadINI (GUIComponent Sender, string s)
{
	if (GUIMenuOption(Sender) != None)
	{
		switch (GUIMenuOption(Sender))
		{
			case ed_CountryCode:

				sCountryCode = GetPlayerCountryCode ();

				ed_CountryCode.SetText (sCountryCode);

				UpdateCountryFlag ();

				break;
		}
	}
	else if (Sender == i_Character)
	{
		UpdateCharacter ();
    }
	else if (Sender == i_CountryFlag)
	{
		UpdateCountryFlag ();
    }
}

function InternalOnChange (GUIComponent Sender)
{
	if (GUIMenuOption(Sender) != None)
	{
		switch (GUIMenuOption(Sender))
		{
			case ed_CountryCode:

				sCountryCode = ed_CountryCode.GetText ();

				SetPlayerCountryCode (sCountryCode);

				UpdateCountryFlag ();

				break;
		}
	}
}

function ShowPanel (bool bShow)
{
	Super.ShowPanel (bShow);

	if (bShow)
	{
		InitGRI ();
    }
}

// #

protected function UpdateCountryFlag ()
{
	local string CountryCode;

	CountryCode = GetPlayerCountryCode ();

	if (Class'CountryCodes'.Static.GetTextureFlag (CountryCode, TextureFlag, OffsetTextureFlag))
	{
		i_CountryFlag.Image = TextureFlag;

		i_CountryFlag.X1 = OffsetTextureFlag.X1;
		i_CountryFlag.Y1 = OffsetTextureFlag.Y1;
		i_CountryFlag.X2 = OffsetTextureFlag.X1 + OffsetTextureFlag.X2;
		i_CountryFlag.Y2 = OffsetTextureFlag.Y1 + OffsetTextureFlag.Y2;
    }
    else
    {
		i_CountryFlag.Image = None;

		i_CountryFlag.X1 = -1;
		i_CountryFlag.Y1 = -1;
		i_CountryFlag.X2 = -1;
		i_CountryFlag.Y2 = -1;
    }
}

protected function bool DrawCountryFlag (Canvas Canvas)
{
	local float   oOrgX, oOrgY;
	local float   oClipX, oClipY;

	if (TextureFlag != None)
	{
    	oOrgX = Canvas.OrgX;
        oOrgY = Canvas.OrgY;
        oClipX = Canvas.ClipX;
        oClipY = Canvas.ClipY;

        Canvas.OrgX = sb_Background.ActualLeft ();
        Canvas.OrgY = sb_Background.ActualTop ();
        Canvas.ClipX = sb_Background.ActualWidth ();
        Canvas.ClipY = sb_Background.ActualHeight ();


		Canvas.DrawTile
		(
			TextureFlag,
			Canvas.ClipX,
			Canvas.ClipY,
			OffsetTextureFlag.X1,
			OffsetTextureFlag.Y1,
			OffsetTextureFlag.X2,
			OffsetTextureFlag.Y2
		);



        Canvas.OrgX = oOrgX;
	    Canvas.OrgY = oOrgY;
    	Canvas.ClipX = oClipX;
        Canvas.ClipY = oClipY;
    }

	return True;
}

// #

protected function UpdateCharacter ()
{
	local PlayerController PC;

	PC = PlayerOwner ();

	sCharacter = PC.GetURLOption ("Character");

	if (sCharacter != "")
	{
		PR = Class'xGame.xUtil'.Static.FindPlayerRecord (sCharacter);

		if (PR.Portrait != None)
		{
			i_Character.Image = PR.Portrait;
        }
        else
        {
			i_Character.Image = None;
        }
    }
}

// #

protected function GameReplicationInfo GetGRI ()
{
	return PlayerOwner ().GameReplicationInfo;
}

protected function InitGRI ()
{
	local GameReplicationInfo GRI;

	GRI = GetGRI ();
}

protected function SetPlayerCountryCode (string NewCountryCode)
{
	local PlayerController PC;

	NewCountryCode = Class'ReTeamGame'.Static.GetValidCountryCode (NewCountryCode);

	PC = PlayerOwner ();

	PC.UpdateURL ("CountryCode", NewCountryCode, bSaveDefault);
}

protected function string GetPlayerCountryCode ()
{
	local PlayerController PC;

	PC = PlayerOwner ();

	return Class'ReTeamGame'.Static.GetValidCountryCode (PC.GetURLOption ("CountryCode"));
}

// #

DefaultProperties
{
    Begin Object Class=AltSectionBackground Name=sbBackground
        Caption = "Identicard"
        LeftPadding = 0.0
        RightPadding = 0.0
        TopPadding = 0.0
        BottomPadding = 0.0
		WinLeft = 0.5
		WinTop = 0.025
		WinWidth = 0.444875
		WinHeight = 0.2
        bBoundToParent = True
        bScaleToParent = True
    End Object

    sb_Background = sbBackground


	Begin Object class=moEditBox Name=CountryCode
		WinWidth = 0.35
		WinLeft = 0.54
		WinTop = 0.1
		Caption = "Country Code"
		INIOption = "@INTERNAL"
		INIDefault = "Player"
		OnChange = InternalOnChange
		OnLoadINI = InternalOnLoadINI
		Hint = "Enter a two-letter country code [A, Z].  The server gets an update the next time you connect!"
		CaptionWidth = 0.4
		bAutoSizeCaption = True
		TabOrder = 1
	End Object
	ed_CountryCode = CountryCode


	Begin Object class=GUIImage Name=PlayerCharacter
		WinWidth = 0.45
		WinHeight = 0.9
		WinLeft = 0.025
		WinTop = 0.025
		ImageColor = (R=255,G=255,B=255,A=255)
		ImageRenderStyle = MSTY_Normal
		ImageStyle = ISTY_Scaled
        RenderWeight = 0.3
        OnLoadINI = InternalOnLoadINI
        IniOption = "@Internal"
	End Object
	i_Character = PlayerCharacter


	Begin Object class=GUIImage Name=CountryFlag
		WinWidth = 0.1
		WinHeight = 0.1
		WinLeft = 0.2 // 0,475 -- 0,225
		WinTop = 0.825
		ImageColor = (R=255,G=255,B=255,A=255)
		ImageRenderStyle = MSTY_Normal
		ImageStyle = ISTY_Scaled
        RenderWeight = 0.35
        OnLoadINI = InternalOnLoadINI
        IniOption = "@Internal"
	End Object
	i_CountryFlag = CountryFlag
}
