// *F* Developed 2011-2013 rejecht <rejecht at outlook dot com>

class UT2K4Tab_TeamColors extends MidGamePanel
    HideDropDown
    ;

const IndexTeam_Max = 2;
const IndexTeam_A = 0;
const IndexTeam_B = 1;
const IndexTeam_Unspecified = 255;

var protected Color UnspecifiedColor;

var protected automated GUISectionBackground
	sb_Background_Enemies,
	sb_Background_Teammates,
	sb_Background_Player
	;

var protected automated GUIImage
	i_TeamSymbol_Enemies,
	i_TeamSymbol_Teammates,
	i_TeamSymbol_Player
	;

const Count_ColorChannels = 3;

var protected automated moSlider
	sl_Color_Enemies[Count_ColorChannels],
	sl_Color_Teammates[Count_ColorChannels],
	sl_Color_Player[Count_ColorChannels]
	;

var automated GUIButton	b_Defaults;

// #

event InitComponent (GUIController MyController, GUIComponent MyOwner)
{
    Super.InitComponent (MyController, MyOwner);

    Sliders_Init ();
}

protected function Sliders_Init ()
{
    local Color Color;

    Color = GetCustomEnemyColor ();

    sl_Color_Enemies[0].SetValue (Color.R);
    sl_Color_Enemies[1].SetValue (Color.G);
    sl_Color_Enemies[2].SetValue (Color.B);

    UpdateEnemyColor ();

    Color = GetCustomTeammateColor ();

    sl_Color_Teammates[0].SetValue (Color.R);
    sl_Color_Teammates[1].SetValue (Color.G);
    sl_Color_Teammates[2].SetValue (Color.B);

    UpdateTeammateColor ();

    Color = GetCurrentCustomPlayerColor ();

    sl_Color_Player[0].SetValue (Color.R);
    sl_Color_Player[1].SetValue (Color.G);
    sl_Color_Player[2].SetValue (Color.B);

    UpdatePlayerColor ();
}

protected function bool Defaults_OnClick (GUIComponent Sender)
{
    Class'PlayerSettings'.static.ResetCustomEnemyColor ();
    Class'PlayerSettings'.static.ResetCustomTeammateColor ();
    Class'PlayerSettings'.static.ResetCustomPlayerColor ();

    Sliders_Init ();

    return true;
}

protected function Slider_OnChange (GUIComponent Sender)
{
    if
    (
        (Sender == sl_Color_Enemies[0])
        ||
        (Sender == sl_Color_Enemies[1])
        ||
        (Sender == sl_Color_Enemies[2])
    )
    {
        SetColor_Enemies
        (
            sl_Color_Enemies[0].GetValue (),
            sl_Color_Enemies[1].GetValue (),
            sl_Color_Enemies[2].GetValue ()
        );

        UpdateEnemyColor ();
    }
    else if
    (
        (Sender == sl_Color_Teammates[0])
        ||
        (Sender == sl_Color_Teammates[1])
        ||
        (Sender == sl_Color_Teammates[2])
    )
    {
        SetColor_Allies
        (
            sl_Color_Teammates[0].GetValue (),
            sl_Color_Teammates[1].GetValue (),
            sl_Color_Teammates[2].GetValue ()
        );

        UpdateTeammateColor ();
    }
    else if
    (
        (Sender == sl_Color_Player[0])
        ||
        (Sender == sl_Color_Player[1])
        ||
        (Sender == sl_Color_Player[2])
    )
    {
        SetColor_Player
        (
            sl_Color_Player[0].GetValue (),
            sl_Color_Player[1].GetValue (),
            sl_Color_Player[2].GetValue ()
        );

        UpdatePlayerColor ();
    }
    else
    {
        Log ("Missed: Slider_OnChange ("$Sender$")");
    }
}

protected function UpdateEnemyColor ()
{
    local Color Color;

    Color = GetCustomEnemyColor ();

    i_TeamSymbol_Enemies.ImageColor = Color;
}

protected function UpdateTeammateColor ()
{
    local Color Color;

    Color = GetCustomTeammateColor ();

    i_TeamSymbol_Teammates.ImageColor = Color;
}

protected function UpdatePlayerColor ()
{
    local Color Color;

    Color = GetCurrentCustomPlayerColor ();

    i_TeamSymbol_Player.ImageColor = Color;
}

protected function Color GetCustomEnemyColor ()
{
    local Color Color;

    if (Class'PlayerSettings'.static.UseCustomEnemyColor ())
    {
        Color = Class'PlayerSettings'.static.GetCurrentCustomEnemyColor ();
        Color.A = 255;

        return Color;
    }

    return UnspecifiedColor;
}

protected function Color GetCustomTeammateColor ()
{
    local Color Color;

    if (Class'PlayerSettings'.static.UseCustomTeammateColor ())
    {
        Color = Class'PlayerSettings'.static.GetCurrentCustomTeammateColor ();
        Color.A = 255;

        return Color;
    }

    return UnspecifiedColor;
}

protected function Color GetCurrentCustomPlayerColor ()
{
    return Class'PlayerSettings'.static.GetCurrentCustomPlayerColor ();
}

protected function SetColor_Allies
(
    byte Red,
    byte Green,
    byte Blue
)
{
    Class'PlayerSettings'.static.SetCustomTeammateColor (Red, Green, Blue);
}

protected function SetColor_Enemies
(
    byte Red,
    byte Green,
    byte Blue
)
{
    Class'PlayerSettings'.static.SetCustomEnemyColor (Red, Green, Blue);
}

protected function SetColor_Player
(
    byte Red,
    byte Green,
    byte Blue
)
{
    Class'PlayerSettings'.static.SetCustomPlayerColor (Red, Green, Blue);
}

// ##

DefaultProperties
{
    Begin Object Class=AltSectionBackground Name=sbBackgroundEnemies
        Caption="Enemies"
        LeftPadding=0.0
        RightPadding=0.0
        TopPadding=0.0
        BottomPadding=0.0
		WinLeft=0.023625
		WinTop=0.025
		WinWidth=0.944875
		WinHeight=0.275
        bBoundToParent = true
        bScaleToParent = true
    End Object

    Begin Object Class=AltSectionBackground Name=sbBackgroundAllies
        Caption="Teammates"
        LeftPadding=0.0
        RightPadding=0.0
        TopPadding=0.0
        BottomPadding=0.0
		WinLeft=0.023625
		WinTop=0.3125
		WinWidth=0.944875
		WinHeight=0.275
        bBoundToParent = true
        bScaleToParent = true
    End Object

    Begin Object Class=AltSectionBackground Name=sbBackgroundPlayer
        Caption="Player"
        LeftPadding=0.0
        RightPadding=0.0
        TopPadding=0.0
        BottomPadding=0.0
		WinLeft=0.023625
		WinTop=0.6
		WinWidth=0.944875
		WinHeight=0.275
        bBoundToParent = true
        bScaleToParent = true
    End Object

    sb_Background_Enemies = sbBackgroundEnemies
    sb_Background_Teammates = sbBackgroundAllies
    sb_Background_Player = sbBackgroundPlayer

	Begin Object Class=GUIImage Name=iTeamEnemies
		Image = Texture'Textures.EnemySymbol'
        WinLeft = 0.2
        WinTop = 0.0875
        WinWidth = 0.1375
        WinHeight = 0.1375
		ImageStyle = ISTY_PartialScaled
		ImageColor = (R=0,G=0,B=0,A=0)
	End Object

	Begin Object Class=GUIImage Name=iTeamAllies
		Image = Texture'Textures.TeammateSymbol'
        WinLeft = 0.2
        WinTop = 0.375
        WinWidth = 0.1375
        WinHeight = 0.1375
		ImageStyle = ISTY_PartialScaled
		ImageColor = (R=0,G=0,B=0,A=0)
	End Object

	Begin Object Class=GUIImage Name=iTeamPlayer
		Image = Texture'Textures.TeammateSymbol'
        WinLeft = 0.2
        WinTop = 0.6625
        WinWidth = 0.1375
        WinHeight = 0.1375
		ImageStyle = ISTY_PartialScaled
		ImageColor = (R=0,G=0,B=0,A=0)
	End Object

	i_TeamSymbol_Enemies = iTeamEnemies
	i_TeamSymbol_Teammates = iTeamAllies
	i_TeamSymbol_Player = iTeamPlayer

    Begin Object class=moSlider Name=SliderEnemiesRed
        Caption = "Red"
        CaptionWidth = 0.375
        TabOrder = 0
        WinLeft = 0.54
        WinTop = 0.0875
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    Begin Object class=moSlider Name=SliderEnemiesGreen
        Caption = "Green"
        CaptionWidth = 0.375
        TabOrder = 1
        WinLeft = 0.54
        WinTop = 0.1375
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    Begin Object class=moSlider Name=SliderEnemiesBlue
        Caption = "Blue"
        CaptionWidth = 0.375
        TabOrder = 2
        WinLeft = 0.54
        WinTop = 0.1875
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    sl_Color_Enemies(0) = SliderEnemiesRed
    sl_Color_Enemies(1) = SliderEnemiesGreen
    sl_Color_Enemies(2) = SliderEnemiesBlue

    Begin Object class=moSlider Name=SliderAlliesRed
        Caption = "Red"
        CaptionWidth = 0.375
        TabOrder = 3
        WinLeft = 0.54
        WinTop = 0.375
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    Begin Object class=moSlider Name=SliderAlliesGreen
        Caption = "Green"
        CaptionWidth = 0.375
        TabOrder = 4
        WinLeft = 0.54
        WinTop = 0.425
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    Begin Object class=moSlider Name=SliderAlliesBlue
        Caption = "Blue"
        CaptionWidth = 0.375
        TabOrder = 5
        WinLeft = 0.54
        WinTop = 0.475
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    sl_Color_Teammates(0) = SliderAlliesRed
    sl_Color_Teammates(1) = SliderAlliesGreen
    sl_Color_Teammates(2) = SliderAlliesBlue

    Begin Object class=moSlider Name=SliderPlayerRed
        Caption = "Red"
        CaptionWidth = 0.375
        TabOrder = 6
        WinLeft = 0.54
        WinTop = 0.6625
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    Begin Object class=moSlider Name=SliderPlayerGreen
        Caption = "Green"
        CaptionWidth = 0.375
        TabOrder = 7
        WinLeft = 0.54
        WinTop = 0.7125
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    Begin Object class=moSlider Name=SliderPlayerBlue
        Caption = "Blue"
        CaptionWidth = 0.375
        TabOrder = 8
        WinLeft = 0.54
        WinTop = 0.7625
        WinWidth = 0.35
        WinHeight = 0.0375
        bIntSlider = true
        MinValue = 0
        MaxValue = 255
        OnChange = Slider_OnChange
        bHeightFromComponent = false
        LabelStyleName = "TextLabel"
        SliderCaptionStyleName = "TextLabel"
        bScaleToParent = true
        bBoundToParent = true
    End Object

    sl_Color_Player(0) = SliderPlayerRed
    sl_Color_Player(1) = SliderPlayerGreen
    sl_Color_Player(2) = SliderPlayerBlue

	Begin Object Class=GUIButton Name=bDefaults
		Caption="Defaults"
        TabOrder = 9
		Hint="Set all colors to their defaults."
		WinWidth=0.5
		WinHeight=0.05
		WinLeft=0.25
		WinTop=0.9
		OnClick=Defaults_OnClick
	End Object
	b_Defaults = bDefaults

    UnspecifiedColor = (R=0,G=0,B=0,A=0)
}
