// Developed 2011-2013 rejecht <rejecht at outlook dot com>

class WeaponDamageTypeMap extends Object
    abstract
    HideDropdown
    ;

// #

struct SWeaponDamageType
{
	var const class<WeaponDamageType> WeaponDamageTypeClass;
	var localized const string DisplayName;
};

var const array<SWeaponDamageType> WeaponDamageTypeGroup;

// #

static final function int GetIndex_WeaponDamageType (Class<WeaponDamageType> WeaponDamageTypeClass)
{
    local int
		Index,
	    Count;

    Count = Default.WeaponDamageTypeGroup.Length;

    for (Index = 0; Index < Count; ++Index)
    {
        if (WeaponDamageTypeClass != Default.WeaponDamageTypeGroup[Index].WeaponDamageTypeClass)
        {
            continue;
        }
        else
        {
            return Index;
        }
    }

    return -1;
}

static final function string GetText_WeaponDamageType (Class<WeaponDamageType> WeaponDamageTypeClass)
{
    local int
		Index,
	    Count;

    Count = Default.WeaponDamageTypeGroup.Length;

    for (Index = 0; Index < Count; ++Index)
    {
        if (WeaponDamageTypeClass != Default.WeaponDamageTypeGroup[Index].WeaponDamageTypeClass)
        {
			continue;
        }
        else
        {
            return default.WeaponDamageTypeGroup[Index].DisplayName;
        }
    }

    return WeaponDamageTypeClass.Default.WeaponClass.Default.FireModeClass[0].Default.AmmoClass.Default.ItemName;
}

// #

static final function int GetLongestStringLength ()
{
    local int
		Index,
		Count,
		Longest,
		Length;

    Count = Default.WeaponDamageTypeGroup.Length;

    for (Index = 0; Index < Count; ++Index)
    {
		Length = Len (Default.WeaponDamageTypeGroup[Index].DisplayName);

		if (Length > Longest)
		{
			Longest = Length;
        }
    }

    return Longest;
}

// #

DefaultProperties
{
    WeaponDamageTypeGroup(0) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeFlakChunk',DisplayName="Flak Chunks") // Flak Cannon
    WeaponDamageTypeGroup(1) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeFlakShell',DisplayName="Flak Shells") // Flak Cannon
    WeaponDamageTypeGroup(2) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeRocket',DisplayName="Rockets") // Rocket Launcher
    WeaponDamageTypeGroup(3) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeRocketHoming',DisplayName="Homing Rockets") // Rocket Launcher
    WeaponDamageTypeGroup(4) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeShockBeam',DisplayName="Shock Beams") // Shock Rifle
    WeaponDamageTypeGroup(5) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeShockBall',DisplayName="Shock Cores") // Shock Rifle
    WeaponDamageTypeGroup(6) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeShockCombo',DisplayName="Shock Combos") // Shock Rifle
    WeaponDamageTypeGroup(7) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeAssaultBullet',DisplayName="Bullets") // Assault Rifle
    WeaponDamageTypeGroup(8) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeAssaultGrenade',DisplayName="Grenades") // Assault Rifle
    WeaponDamageTypeGroup(9) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeBioGlob',DisplayName="Bio Globs") // Bio Rifle
    WeaponDamageTypeGroup(10) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeIonBlast',DisplayName="Ionization") // Ion Cannon
    WeaponDamageTypeGroup(11) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeLinkPlasma',DisplayName="Plasma") // Link Gun
    WeaponDamageTypeGroup(12) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeLinkShaft',DisplayName="Shaft") // Link Gun
    WeaponDamageTypeGroup(13) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeMinigunBullet',DisplayName="Rapid Shells") // Minigun
    WeaponDamageTypeGroup(14) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeMinigunAlt',DisplayName="Heavy Shells") // Minigun
    WeaponDamageTypeGroup(15) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeRedeemer',DisplayName="Redeemers") // Redeemer
    WeaponDamageTypeGroup(16) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeShieldImpact',DisplayName="Shield Impacts") // Shield Gun
    WeaponDamageTypeGroup(17) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeSniperShot',DisplayName="Lightning Charges") // Lightning Gun
    WeaponDamageTypeGroup(18) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeSniperHeadShot',DisplayName="Head Shots") // Lightning Gun
    WeaponDamageTypeGroup(19) = (WeaponDamageTypeClass=Class'XWeapons.DamTypeTeleFrag',DisplayName="Telefrags") // Translocator
    WeaponDamageTypeGroup(20) = (WeaponDamageTypeClass=Class'UTClassic.DamTypeClassicSniper',DisplayName="Sniper Bullets") // Sniper Rifle
    WeaponDamageTypeGroup(21) = (WeaponDamageTypeClass=Class'UTClassic.DamTypeClassicHeadshot',DisplayName="Head Shots") // Sniper Rifle
    WeaponDamageTypeGroup(22) = (WeaponDamageTypeClass=Class'Onslaught.DamTypeONSAVRiLRocket',DisplayName="Anti-Vehicle Rockets") // AVRiL
    WeaponDamageTypeGroup(23) = (WeaponDamageTypeClass=Class'Onslaught.DamTypeONSGrenade',DisplayName="Sticky Grenades") // Grenade Launcher
    WeaponDamageTypeGroup(24) = (WeaponDamageTypeClass=Class'Onslaught.DamTypeONSMine',DisplayName="Parasite Mines") // Mine Layer
    WeaponDamageTypeGroup(25) = (WeaponDamageTypeClass=Class'DamTypeArcedLightning',DisplayName="Arced Lightning") // Lightning Gun Secondary Charge
    WeaponDamageTypeGroup(26) = (WeaponDamageTypeClass=Class'DamTypeStolenShockCombo',DisplayName="Stolen Shock Combos") // Shock Rifle
	WeaponDamageTypeGroup(27) = (WeaponDamageTypeClass=Class'DamTypeFlakShellChunk',DisplayName="Flak Shell Shrapnel") // Flak Cannon
	WeaponDamageTypeGroup(28) = (WeaponDamageTypeClass=Class'DamTypeChargedBioGlob',DisplayName="Charged Bio Globs") // Bio Rifle
	WeaponDamageTypeGroup(29) = (WeaponDamageTypeClass=Class'DamTypeShockBeamHeadShot',DisplayName="Head Shots") // Shock Beam
	WeaponDamageTypeGroup(30) = (WeaponDamageTypeClass=Class'DamTypeSuperShockBeam',DisplayName="Super Shock Beam") // Shock Beam
}
